/* util-js.c generated by valac 0.46.0, the Vala compiler
 * generated from util-js.vala, do not modify */

/*
 * Copyright 2017,2019 Michael James Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib.h>
#include <jsc/jsc.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define UTIL_JS_TYPE_CALLABLE (util_js_callable_get_type ())
#define UTIL_JS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UTIL_JS_TYPE_CALLABLE, UtilJSCallable))
#define UTIL_JS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UTIL_JS_TYPE_CALLABLE, UtilJSCallableClass))
#define UTIL_JS_IS_CALLABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UTIL_JS_TYPE_CALLABLE))
#define UTIL_JS_IS_CALLABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UTIL_JS_TYPE_CALLABLE))
#define UTIL_JS_CALLABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UTIL_JS_TYPE_CALLABLE, UtilJSCallableClass))

typedef struct _UtilJSCallable UtilJSCallable;
typedef struct _UtilJSCallableClass UtilJSCallableClass;
typedef struct _UtilJSCallablePrivate UtilJSCallablePrivate;
typedef struct _UtilJSParamSpecCallable UtilJSParamSpecCallable;

/**
     * Errors produced by functions in {@link Util.JS}.
     */
typedef enum  {
	UTIL_JS_ERROR_EXCEPTION,
	UTIL_JS_ERROR_TYPE
} UtilJSError;
#define UTIL_JS_ERROR util_js_error_quark ()
struct _UtilJSCallable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UtilJSCallablePrivate * priv;
};

struct _UtilJSCallableClass {
	GTypeClass parent_class;
	void (*finalize) (UtilJSCallable *self);
};

struct _UtilJSCallablePrivate {
	gchar* base_name;
	gchar** safe_args;
	gint safe_args_length1;
	gint _safe_args_size_;
};

struct _UtilJSParamSpecCallable {
	GParamSpec parent_instance;
};

static gint UtilJSCallable_private_offset;
static gpointer util_js_callable_parent_class = NULL;

GQuark util_js_error_quark (void);
gboolean util_js_to_bool (JSCValue* value,
                          GError** error);
void util_js_check_exception (JSCContext* context,
                              GError** error);
gdouble util_js_to_double (JSCValue* value,
                           GError** error);
gint32 util_js_to_int32 (JSCValue* value,
                         GError** error);
gchar* util_js_to_string (JSCValue* value,
                          GError** error);
JSCValue* util_js_get_property (JSCValue* value,
                                const gchar* name,
                                GError** error);
gchar* util_js_escape_string (const gchar* value);
gpointer util_js_callable_ref (gpointer instance);
void util_js_callable_unref (gpointer instance);
GParamSpec* util_js_param_spec_callable (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
void util_js_value_set_callable (GValue* value,
                                 gpointer v_object);
void util_js_value_take_callable (GValue* value,
                                  gpointer v_object);
gpointer util_js_value_get_callable (const GValue* value);
GType util_js_callable_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UtilJSCallable, util_js_callable_unref)
UtilJSCallable* util_js_callable (const gchar* base_name);
UtilJSCallable* util_js_callable_new (const gchar* base_name);
UtilJSCallable* util_js_callable_construct (GType object_type,
                                            const gchar* base_name);
gchar* util_js_callable_to_string (UtilJSCallable* self);
UtilJSCallable* util_js_callable_string (UtilJSCallable* self,
                                         const gchar* value);
static inline void util_js_callable_add_param (UtilJSCallable* self,
                                 const gchar* value);
UtilJSCallable* util_js_callable_double (UtilJSCallable* self,
                                         gdouble value);
UtilJSCallable* util_js_callable_int (UtilJSCallable* self,
                                      gint value);
UtilJSCallable* util_js_callable_bool (UtilJSCallable* self,
                                       gboolean value);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void util_js_callable_finalize (UtilJSCallable * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

GQuark
util_js_error_quark (void)
{
	return g_quark_from_static_string ("util-js-error-quark");
}

/**
     * Returns a JSC Value as a bool.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `Boolean`.
     */
gboolean
util_js_to_bool (JSCValue* value,
                 GError** error)
{
	gboolean boolean = FALSE;
	JSCContext* _tmp3_;
	JSCContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 34 "../src/client/util/util-js.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 36 "../src/client/util/util-js.vala"
	if (!jsc_value_is_boolean (value)) {
#line 151 "util-js.c"
		GError* _tmp0_;
#line 37 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Boolean object");
#line 37 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 37 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 159 "util-js.c"
			gboolean _tmp1_ = FALSE;
#line 37 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 37 "../src/client/util/util-js.vala"
			return _tmp1_;
#line 165 "util-js.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 37 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 37 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 37 "../src/client/util/util-js.vala"
			return _tmp2_;
#line 174 "util-js.c"
		}
	}
#line 39 "../src/client/util/util-js.vala"
	boolean = jsc_value_to_boolean (value);
#line 40 "../src/client/util/util-js.vala"
	_tmp3_ = jsc_value_get_context (value);
#line 40 "../src/client/util/util-js.vala"
	_tmp4_ = _tmp3_;
#line 40 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp4_, &_inner_error0_);
#line 40 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 189 "util-js.c"
			gboolean _tmp5_ = FALSE;
#line 40 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 40 "../src/client/util/util-js.vala"
			return _tmp5_;
#line 195 "util-js.c"
		} else {
			gboolean _tmp6_ = FALSE;
#line 40 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 40 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 40 "../src/client/util/util-js.vala"
			return _tmp6_;
#line 204 "util-js.c"
		}
	}
#line 41 "../src/client/util/util-js.vala"
	result = boolean;
#line 41 "../src/client/util/util-js.vala"
	return result;
#line 211 "util-js.c"
}

/**
     * Returns a JSC Value as a double.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
gdouble
util_js_to_double (JSCValue* value,
                   GError** error)
{
	gdouble number = 0.0;
	JSCContext* _tmp3_;
	JSCContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	gdouble result = 0.0;
#line 50 "../src/client/util/util-js.vala"
	g_return_val_if_fail (value != NULL, 0.0);
#line 52 "../src/client/util/util-js.vala"
	if (!jsc_value_is_number (value)) {
#line 233 "util-js.c"
		GError* _tmp0_;
#line 53 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Number object");
#line 53 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 53 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 241 "util-js.c"
			gdouble _tmp1_ = -1.0;
#line 53 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 53 "../src/client/util/util-js.vala"
			return _tmp1_;
#line 247 "util-js.c"
		} else {
			gdouble _tmp2_ = -1.0;
#line 53 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 53 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 53 "../src/client/util/util-js.vala"
			return _tmp2_;
#line 256 "util-js.c"
		}
	}
#line 56 "../src/client/util/util-js.vala"
	number = jsc_value_to_double (value);
#line 57 "../src/client/util/util-js.vala"
	_tmp3_ = jsc_value_get_context (value);
#line 57 "../src/client/util/util-js.vala"
	_tmp4_ = _tmp3_;
#line 57 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp4_, &_inner_error0_);
#line 57 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 57 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 271 "util-js.c"
			gdouble _tmp5_ = -1.0;
#line 57 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 57 "../src/client/util/util-js.vala"
			return _tmp5_;
#line 277 "util-js.c"
		} else {
			gdouble _tmp6_ = -1.0;
#line 57 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 57 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 57 "../src/client/util/util-js.vala"
			return _tmp6_;
#line 286 "util-js.c"
		}
	}
#line 58 "../src/client/util/util-js.vala"
	result = number;
#line 58 "../src/client/util/util-js.vala"
	return result;
#line 293 "util-js.c"
}

/**
     * Returns a JSC Value as an int32.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `Number`.
     */
gint32
util_js_to_int32 (JSCValue* value,
                  GError** error)
{
	gint32 number = 0;
	JSCContext* _tmp3_;
	JSCContext* _tmp4_;
	GError* _inner_error0_ = NULL;
	gint32 result = 0;
#line 67 "../src/client/util/util-js.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 69 "../src/client/util/util-js.vala"
	if (!jsc_value_is_number (value)) {
#line 315 "util-js.c"
		GError* _tmp0_;
#line 70 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Number object");
#line 70 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 70 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 323 "util-js.c"
			gint32 _tmp1_ = -1;
#line 70 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 70 "../src/client/util/util-js.vala"
			return _tmp1_;
#line 329 "util-js.c"
		} else {
			gint32 _tmp2_ = -1;
#line 70 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 70 "../src/client/util/util-js.vala"
			return _tmp2_;
#line 338 "util-js.c"
		}
	}
#line 73 "../src/client/util/util-js.vala"
	number = jsc_value_to_int32 (value);
#line 74 "../src/client/util/util-js.vala"
	_tmp3_ = jsc_value_get_context (value);
#line 74 "../src/client/util/util-js.vala"
	_tmp4_ = _tmp3_;
#line 74 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp4_, &_inner_error0_);
#line 74 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 353 "util-js.c"
			gint32 _tmp5_ = -1;
#line 74 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 74 "../src/client/util/util-js.vala"
			return _tmp5_;
#line 359 "util-js.c"
		} else {
			gint32 _tmp6_ = -1;
#line 74 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 74 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 74 "../src/client/util/util-js.vala"
			return _tmp6_;
#line 368 "util-js.c"
		}
	}
#line 75 "../src/client/util/util-js.vala"
	result = number;
#line 75 "../src/client/util/util-js.vala"
	return result;
#line 375 "util-js.c"
}

/**
     * Returns a JSC Value as a string.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not a JavaScript `String`.
     */
gchar*
util_js_to_string (JSCValue* value,
                   GError** error)
{
	gchar* str = NULL;
	gchar* _tmp1_;
	JSCContext* _tmp2_;
	JSCContext* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 84 "../src/client/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 86 "../src/client/util/util-js.vala"
	if (!jsc_value_is_string (value)) {
#line 398 "util-js.c"
		GError* _tmp0_;
#line 87 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS String object");
#line 87 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 87 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 87 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 87 "../src/client/util/util-js.vala"
			return NULL;
#line 410 "util-js.c"
		} else {
#line 87 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 87 "../src/client/util/util-js.vala"
			return NULL;
#line 418 "util-js.c"
		}
	}
#line 90 "../src/client/util/util-js.vala"
	_tmp1_ = jsc_value_to_string (value);
#line 90 "../src/client/util/util-js.vala"
	str = _tmp1_;
#line 91 "../src/client/util/util-js.vala"
	_tmp2_ = jsc_value_get_context (value);
#line 91 "../src/client/util/util-js.vala"
	_tmp3_ = _tmp2_;
#line 91 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp3_, &_inner_error0_);
#line 91 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 91 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 91 "../src/client/util/util-js.vala"
			_g_free0 (str);
#line 91 "../src/client/util/util-js.vala"
			return NULL;
#line 441 "util-js.c"
		} else {
#line 91 "../src/client/util/util-js.vala"
			_g_free0 (str);
#line 91 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 91 "../src/client/util/util-js.vala"
			return NULL;
#line 451 "util-js.c"
		}
	}
#line 92 "../src/client/util/util-js.vala"
	result = str;
#line 92 "../src/client/util/util-js.vala"
	return result;
#line 458 "util-js.c"
}

/**
     * Returns the value of an object property.
     *
     * This will raise a {@link Util.JS.Error.TYPE} error if the
     * value is not an object or does not contain the named property.
     */
inline JSCValue*
util_js_get_property (JSCValue* value,
                      const gchar* name,
                      GError** error)
{
	JSCValue* property = NULL;
	JSCValue* _tmp1_;
	JSCContext* _tmp2_;
	JSCContext* _tmp3_;
	GError* _inner_error0_ = NULL;
	JSCValue* result = NULL;
#line 101 "../src/client/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 101 "../src/client/util/util-js.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 104 "../src/client/util/util-js.vala"
	if (!jsc_value_is_object (value)) {
#line 484 "util-js.c"
		GError* _tmp0_;
#line 105 "../src/client/util/util-js.vala"
		_tmp0_ = g_error_new_literal (UTIL_JS_ERROR, UTIL_JS_ERROR_TYPE, "Value is not a JS Object");
#line 105 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp0_;
#line 105 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 105 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 105 "../src/client/util/util-js.vala"
			return NULL;
#line 496 "util-js.c"
		} else {
#line 105 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 105 "../src/client/util/util-js.vala"
			return NULL;
#line 504 "util-js.c"
		}
	}
#line 108 "../src/client/util/util-js.vala"
	_tmp1_ = jsc_value_object_get_property (value, name);
#line 108 "../src/client/util/util-js.vala"
	property = _tmp1_;
#line 109 "../src/client/util/util-js.vala"
	_tmp2_ = jsc_value_get_context (value);
#line 109 "../src/client/util/util-js.vala"
	_tmp3_ = _tmp2_;
#line 109 "../src/client/util/util-js.vala"
	util_js_check_exception (_tmp3_, &_inner_error0_);
#line 109 "../src/client/util/util-js.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 109 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 109 "../src/client/util/util-js.vala"
			_g_object_unref0 (property);
#line 109 "../src/client/util/util-js.vala"
			return NULL;
#line 527 "util-js.c"
		} else {
#line 109 "../src/client/util/util-js.vala"
			_g_object_unref0 (property);
#line 109 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 109 "../src/client/util/util-js.vala"
			return NULL;
#line 537 "util-js.c"
		}
	}
#line 110 "../src/client/util/util-js.vala"
	result = property;
#line 110 "../src/client/util/util-js.vala"
	return result;
#line 544 "util-js.c"
}

/**
     * Checks an JS exception returned from a JSC call.
     *
     * If the given context has a current exception, it will cleared
     * and a {@link Util.JS.Error} will be thrown.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 121 "../src/client/util/util-js.vala"
	return self ? g_object_ref (self) : NULL;
#line 558 "util-js.c"
}

inline void
util_js_check_exception (JSCContext* context,
                         GError** error)
{
	JSCException* exception = NULL;
	JSCException* _tmp0_;
	JSCException* _tmp1_;
	JSCException* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 119 "../src/client/util/util-js.vala"
	g_return_if_fail (context != NULL);
#line 121 "../src/client/util/util-js.vala"
	_tmp0_ = jsc_context_get_exception (context);
#line 121 "../src/client/util/util-js.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 121 "../src/client/util/util-js.vala"
	exception = _tmp1_;
#line 122 "../src/client/util/util-js.vala"
	_tmp2_ = exception;
#line 122 "../src/client/util/util-js.vala"
	if (_tmp2_ != NULL) {
#line 582 "util-js.c"
		JSCException* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GError* _tmp6_;
		GError* _tmp7_;
#line 123 "../src/client/util/util-js.vala"
		jsc_context_clear_exception (context);
#line 124 "../src/client/util/util-js.vala"
		_tmp3_ = exception;
#line 124 "../src/client/util/util-js.vala"
		_tmp4_ = jsc_exception_to_string (_tmp3_);
#line 124 "../src/client/util/util-js.vala"
		_tmp5_ = _tmp4_;
#line 124 "../src/client/util/util-js.vala"
		_tmp6_ = g_error_new (UTIL_JS_ERROR, UTIL_JS_ERROR_EXCEPTION, "JS exception thrown: %s", _tmp5_);
#line 124 "../src/client/util/util-js.vala"
		_tmp7_ = _tmp6_;
#line 124 "../src/client/util/util-js.vala"
		_g_free0 (_tmp5_);
#line 124 "../src/client/util/util-js.vala"
		_inner_error0_ = _tmp7_;
#line 124 "../src/client/util/util-js.vala"
		if (_inner_error0_->domain == UTIL_JS_ERROR) {
#line 124 "../src/client/util/util-js.vala"
			g_propagate_error (error, _inner_error0_);
#line 124 "../src/client/util/util-js.vala"
			_g_object_unref0 (exception);
#line 124 "../src/client/util/util-js.vala"
			return;
#line 612 "util-js.c"
		} else {
#line 124 "../src/client/util/util-js.vala"
			_g_object_unref0 (exception);
#line 124 "../src/client/util/util-js.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/client/util/util-js.vala"
			g_clear_error (&_inner_error0_);
#line 124 "../src/client/util/util-js.vala"
			return;
#line 622 "util-js.c"
		}
	}
#line 119 "../src/client/util/util-js.vala"
	_g_object_unref0 (exception);
#line 627 "util-js.c"
}

/**
     * Escapes a string so as to be safe to use as a JS string literal.
     *
     * This does not append opening or closing quotes.
     */
static gboolean
string_valid_char (const gchar* self,
                   gint index)
{
	guint8 c = 0U;
	guint8 _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result = FALSE;
#line 1186 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1187 "glib-2.0.vapi"
	_tmp0_ = ((guint8*) self)[index];
#line 1187 "glib-2.0.vapi"
	c = _tmp0_;
#line 1188 "glib-2.0.vapi"
	if (((gint) c) == 0x00) {
#line 1188 "glib-2.0.vapi"
		_tmp2_ = TRUE;
#line 654 "util-js.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 1188 "glib-2.0.vapi"
		if (((gint) c) >= 0x80) {
#line 1188 "glib-2.0.vapi"
			_tmp3_ = ((gint) c) < 0xc2;
#line 661 "util-js.c"
		} else {
#line 1188 "glib-2.0.vapi"
			_tmp3_ = FALSE;
#line 665 "util-js.c"
		}
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _tmp3_;
#line 669 "util-js.c"
	}
#line 1188 "glib-2.0.vapi"
	if (_tmp2_) {
#line 1188 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 675 "util-js.c"
	} else {
#line 1188 "glib-2.0.vapi"
		_tmp1_ = ((gint) c) >= 0xf5;
#line 679 "util-js.c"
	}
#line 1188 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1189 "glib-2.0.vapi"
		result = FALSE;
#line 1189 "glib-2.0.vapi"
		return result;
#line 687 "util-js.c"
	} else {
#line 1191 "glib-2.0.vapi"
		result = TRUE;
#line 1191 "glib-2.0.vapi"
		return result;
#line 693 "util-js.c"
	}
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1210 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1211 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1211 "glib-2.0.vapi"
	return result;
#line 708 "util-js.c"
}

static guint8*
g_string_get_data (GString* self,
                   gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 5035 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5036 "glib-2.0.vapi"
	_tmp0_ = self->str;
#line 5036 "glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 5036 "glib-2.0.vapi"
	res_length1 = -1;
#line 5036 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 5037 "glib-2.0.vapi"
	res_length1 = (gint) self->len;
#line 5038 "glib-2.0.vapi"
	_tmp1_ = res;
#line 5038 "glib-2.0.vapi"
	_tmp1__length1 = res_length1;
#line 5038 "glib-2.0.vapi"
	_tmp2_ = _tmp1_;
#line 5038 "glib-2.0.vapi"
	_tmp2__length1 = _tmp1__length1;
#line 5038 "glib-2.0.vapi"
	if (result_length1) {
#line 5038 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 748 "util-js.c"
	}
#line 5038 "glib-2.0.vapi"
	result = _tmp2_;
#line 5038 "glib-2.0.vapi"
	return result;
#line 754 "util-js.c"
}

gchar*
util_js_escape_string (const gchar* value)
{
	GString* builder = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GString* _tmp2_;
	GString* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
	guint8* _tmp20_;
	gint _tmp20__length1;
	gchar* _tmp21_;
	gchar* result = NULL;
#line 135 "../src/client/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 136 "../src/client/util/util-js.vala"
	_tmp0_ = strlen (value);
#line 136 "../src/client/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 136 "../src/client/util/util-js.vala"
	_tmp2_ = g_string_sized_new ((gsize) _tmp1_);
#line 136 "../src/client/util/util-js.vala"
	builder = _tmp2_;
#line 781 "util-js.c"
	{
		gint i = 0;
#line 137 "../src/client/util/util-js.vala"
		i = 0;
#line 786 "util-js.c"
		{
			gboolean _tmp3_ = FALSE;
#line 137 "../src/client/util/util-js.vala"
			_tmp3_ = TRUE;
#line 137 "../src/client/util/util-js.vala"
			while (TRUE) {
#line 793 "util-js.c"
				gint _tmp5_;
				gint _tmp6_;
#line 137 "../src/client/util/util-js.vala"
				if (!_tmp3_) {
#line 798 "util-js.c"
					gint _tmp4_;
#line 137 "../src/client/util/util-js.vala"
					_tmp4_ = i;
#line 137 "../src/client/util/util-js.vala"
					i = _tmp4_ + 1;
#line 804 "util-js.c"
				}
#line 137 "../src/client/util/util-js.vala"
				_tmp3_ = FALSE;
#line 137 "../src/client/util/util-js.vala"
				_tmp5_ = strlen (value);
#line 137 "../src/client/util/util-js.vala"
				_tmp6_ = _tmp5_;
#line 137 "../src/client/util/util-js.vala"
				if (!(i < _tmp6_)) {
#line 137 "../src/client/util/util-js.vala"
					break;
#line 816 "util-js.c"
				}
#line 138 "../src/client/util/util-js.vala"
				if (string_valid_char (value, i)) {
#line 820 "util-js.c"
					gunichar c = 0U;
#line 139 "../src/client/util/util-js.vala"
					c = string_get_char (value, (glong) i);
#line 140 "../src/client/util/util-js.vala"
					switch (c) {
#line 140 "../src/client/util/util-js.vala"
						case '\x00':
#line 828 "util-js.c"
						{
							GString* _tmp7_;
#line 142 "../src/client/util/util-js.vala"
							_tmp7_ = builder;
#line 142 "../src/client/util/util-js.vala"
							g_string_append (_tmp7_, "\x00");
#line 143 "../src/client/util/util-js.vala"
							break;
#line 837 "util-js.c"
						}
#line 140 "../src/client/util/util-js.vala"
						case '\'':
#line 841 "util-js.c"
						{
							GString* _tmp8_;
#line 145 "../src/client/util/util-js.vala"
							_tmp8_ = builder;
#line 145 "../src/client/util/util-js.vala"
							g_string_append (_tmp8_, "\\\'");
#line 146 "../src/client/util/util-js.vala"
							break;
#line 850 "util-js.c"
						}
#line 140 "../src/client/util/util-js.vala"
						case '"':
#line 854 "util-js.c"
						{
							GString* _tmp9_;
#line 148 "../src/client/util/util-js.vala"
							_tmp9_ = builder;
#line 148 "../src/client/util/util-js.vala"
							g_string_append (_tmp9_, "\\\"");
#line 149 "../src/client/util/util-js.vala"
							break;
#line 863 "util-js.c"
						}
#line 140 "../src/client/util/util-js.vala"
						case '\\':
#line 867 "util-js.c"
						{
							GString* _tmp10_;
#line 151 "../src/client/util/util-js.vala"
							_tmp10_ = builder;
#line 151 "../src/client/util/util-js.vala"
							g_string_append (_tmp10_, "\\\\");
#line 152 "../src/client/util/util-js.vala"
							break;
#line 876 "util-js.c"
						}
#line 140 "../src/client/util/util-js.vala"
						case '\n':
#line 880 "util-js.c"
						{
							GString* _tmp11_;
#line 154 "../src/client/util/util-js.vala"
							_tmp11_ = builder;
#line 154 "../src/client/util/util-js.vala"
							g_string_append (_tmp11_, "\\n");
#line 155 "../src/client/util/util-js.vala"
							break;
#line 889 "util-js.c"
						}
#line 140 "../src/client/util/util-js.vala"
						case '\r':
#line 893 "util-js.c"
						{
							GString* _tmp12_;
#line 157 "../src/client/util/util-js.vala"
							_tmp12_ = builder;
#line 157 "../src/client/util/util-js.vala"
							g_string_append (_tmp12_, "\\r");
#line 158 "../src/client/util/util-js.vala"
							break;
#line 902 "util-js.c"
						}
#line 140 "../src/client/util/util-js.vala"
						case '\x0b':
#line 906 "util-js.c"
						{
							GString* _tmp13_;
#line 160 "../src/client/util/util-js.vala"
							_tmp13_ = builder;
#line 160 "../src/client/util/util-js.vala"
							g_string_append (_tmp13_, "\x0b");
#line 161 "../src/client/util/util-js.vala"
							break;
#line 915 "util-js.c"
						}
#line 140 "../src/client/util/util-js.vala"
						case '\t':
#line 919 "util-js.c"
						{
							GString* _tmp14_;
#line 163 "../src/client/util/util-js.vala"
							_tmp14_ = builder;
#line 163 "../src/client/util/util-js.vala"
							g_string_append (_tmp14_, "\\t");
#line 164 "../src/client/util/util-js.vala"
							break;
#line 928 "util-js.c"
						}
#line 140 "../src/client/util/util-js.vala"
						case '\b':
#line 932 "util-js.c"
						{
							GString* _tmp15_;
#line 166 "../src/client/util/util-js.vala"
							_tmp15_ = builder;
#line 166 "../src/client/util/util-js.vala"
							g_string_append (_tmp15_, "\\b");
#line 167 "../src/client/util/util-js.vala"
							break;
#line 941 "util-js.c"
						}
#line 140 "../src/client/util/util-js.vala"
						case '\f':
#line 945 "util-js.c"
						{
							GString* _tmp16_;
#line 169 "../src/client/util/util-js.vala"
							_tmp16_ = builder;
#line 169 "../src/client/util/util-js.vala"
							g_string_append (_tmp16_, "\\f");
#line 170 "../src/client/util/util-js.vala"
							break;
#line 954 "util-js.c"
						}
						default:
						{
							GString* _tmp17_;
#line 172 "../src/client/util/util-js.vala"
							_tmp17_ = builder;
#line 172 "../src/client/util/util-js.vala"
							g_string_append_unichar (_tmp17_, c);
#line 173 "../src/client/util/util-js.vala"
							break;
#line 965 "util-js.c"
						}
					}
				}
			}
		}
	}
#line 177 "../src/client/util/util-js.vala"
	_tmp18_ = builder;
#line 177 "../src/client/util/util-js.vala"
	_tmp19_ = g_string_get_data (_tmp18_, &_tmp19__length1);
#line 177 "../src/client/util/util-js.vala"
	_tmp20_ = _tmp19_;
#line 177 "../src/client/util/util-js.vala"
	_tmp20__length1 = _tmp19__length1;
#line 177 "../src/client/util/util-js.vala"
	_tmp21_ = g_strdup ((const gchar*) _tmp20_);
#line 177 "../src/client/util/util-js.vala"
	result = _tmp21_;
#line 177 "../src/client/util/util-js.vala"
	_g_string_free0 (builder);
#line 177 "../src/client/util/util-js.vala"
	return result;
#line 988 "util-js.c"
}

/**
     * Convenience method for returning a new Callable instance.
     */
UtilJSCallable*
util_js_callable (const gchar* base_name)
{
	UtilJSCallable* _tmp0_;
	UtilJSCallable* result = NULL;
#line 183 "../src/client/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 184 "../src/client/util/util-js.vala"
	_tmp0_ = util_js_callable_new (base_name);
#line 184 "../src/client/util/util-js.vala"
	result = _tmp0_;
#line 184 "../src/client/util/util-js.vala"
	return result;
#line 1007 "util-js.c"
}

static inline gpointer
util_js_callable_get_instance_private (UtilJSCallable* self)
{
	return G_STRUCT_MEMBER_P (self, UtilJSCallable_private_offset);
}

UtilJSCallable*
util_js_callable_construct (GType object_type,
                            const gchar* base_name)
{
	UtilJSCallable* self = NULL;
	gchar* _tmp0_;
#line 196 "../src/client/util/util-js.vala"
	g_return_val_if_fail (base_name != NULL, NULL);
#line 196 "../src/client/util/util-js.vala"
	self = (UtilJSCallable*) g_type_create_instance (object_type);
#line 197 "../src/client/util/util-js.vala"
	_tmp0_ = g_strdup (base_name);
#line 197 "../src/client/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 197 "../src/client/util/util-js.vala"
	self->priv->base_name = _tmp0_;
#line 196 "../src/client/util/util-js.vala"
	return self;
#line 1034 "util-js.c"
}

UtilJSCallable*
util_js_callable_new (const gchar* base_name)
{
#line 196 "../src/client/util/util-js.vala"
	return util_js_callable_construct (UTIL_JS_TYPE_CALLABLE, base_name);
#line 1042 "util-js.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result = NULL;
#line 1148 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1149 "glib-2.0.vapi"
		separator = "";
#line 1056 "util-js.c"
	}
#line 1151 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 1060 "util-js.c"
		gboolean _tmp1_ = FALSE;
#line 1151 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1151 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 1066 "util-js.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1151 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 1071 "util-js.c"
				const gchar* _tmp3_;
#line 1151 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1151 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 1077 "util-js.c"
			} else {
#line 1151 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 1081 "util-js.c"
			}
#line 1151 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 1085 "util-js.c"
		}
#line 1151 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 1089 "util-js.c"
	} else {
#line 1151 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1093 "util-js.c"
	}
#line 1151 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1097 "util-js.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		void* ptr = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		void* _tmp21_;
		const gchar* _tmp31_;
#line 1153 "glib-2.0.vapi"
		len = (gsize) 1;
#line 1111 "util-js.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
			i = 0;
#line 1154 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1154 "glib-2.0.vapi"
			while (TRUE) {
#line 1120 "util-js.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1154 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1127 "util-js.c"
					gint _tmp5_;
#line 1154 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1154 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1133 "util-js.c"
				}
#line 1154 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1154 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1141 "util-js.c"
				} else {
#line 1154 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1145 "util-js.c"
				}
#line 1154 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1154 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1151 "util-js.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1154 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1156 "util-js.c"
						const gchar* _tmp9_;
#line 1154 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1154 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1162 "util-js.c"
					} else {
#line 1154 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1166 "util-js.c"
					}
#line 1154 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1170 "util-js.c"
				}
#line 1154 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1154 "glib-2.0.vapi"
					break;
#line 1176 "util-js.c"
				}
#line 1155 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1155 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1182 "util-js.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1155 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1155 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1155 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1155 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1194 "util-js.c"
				} else {
#line 1155 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1198 "util-js.c"
				}
#line 1155 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1202 "util-js.c"
			}
		}
#line 1157 "glib-2.0.vapi"
		if (i == 0) {
#line 1207 "util-js.c"
			gchar* _tmp15_;
#line 1158 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1158 "glib-2.0.vapi"
			result = _tmp15_;
#line 1158 "glib-2.0.vapi"
			return result;
#line 1215 "util-js.c"
		}
#line 1160 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1161 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1161 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1161 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1163 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1163 "glib-2.0.vapi"
		res = _tmp18_;
#line 1164 "glib-2.0.vapi"
		_tmp19_ = res;
#line 1164 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1164 "glib-2.0.vapi"
		_tmp21_ = g_stpcpy ((void*) _tmp19_, (const gchar*) _tmp20_);
#line 1164 "glib-2.0.vapi"
		ptr = _tmp21_;
#line 1237 "util-js.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
			i = 1;
#line 1165 "glib-2.0.vapi"
			_tmp22_ = TRUE;
#line 1165 "glib-2.0.vapi"
			while (TRUE) {
#line 1246 "util-js.c"
				void* _tmp24_;
				void* _tmp25_;
				const gchar* _tmp26_ = NULL;
				const gchar* _tmp27_;
				void* _tmp29_;
				void* _tmp30_;
#line 1165 "glib-2.0.vapi"
				if (!_tmp22_) {
#line 1255 "util-js.c"
					gint _tmp23_;
#line 1165 "glib-2.0.vapi"
					_tmp23_ = i;
#line 1165 "glib-2.0.vapi"
					i = _tmp23_ + 1;
#line 1261 "util-js.c"
				}
#line 1165 "glib-2.0.vapi"
				_tmp22_ = FALSE;
#line 1165 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1165 "glib-2.0.vapi"
					break;
#line 1269 "util-js.c"
				}
#line 1166 "glib-2.0.vapi"
				_tmp24_ = ptr;
#line 1166 "glib-2.0.vapi"
				_tmp25_ = g_stpcpy (_tmp24_, (const gchar*) separator);
#line 1166 "glib-2.0.vapi"
				ptr = _tmp25_;
#line 1167 "glib-2.0.vapi"
				_tmp27_ = str_array[i];
#line 1167 "glib-2.0.vapi"
				if (_tmp27_ != NULL) {
#line 1281 "util-js.c"
					const gchar* _tmp28_;
#line 1167 "glib-2.0.vapi"
					_tmp28_ = str_array[i];
#line 1167 "glib-2.0.vapi"
					_tmp26_ = (const gchar*) _tmp28_;
#line 1287 "util-js.c"
				} else {
#line 1167 "glib-2.0.vapi"
					_tmp26_ = "";
#line 1291 "util-js.c"
				}
#line 1167 "glib-2.0.vapi"
				_tmp29_ = ptr;
#line 1167 "glib-2.0.vapi"
				_tmp30_ = g_stpcpy (_tmp29_, _tmp26_);
#line 1167 "glib-2.0.vapi"
				ptr = _tmp30_;
#line 1299 "util-js.c"
			}
		}
#line 1170 "glib-2.0.vapi"
		_tmp31_ = res;
#line 1170 "glib-2.0.vapi"
		res = NULL;
#line 1170 "glib-2.0.vapi"
		result = (gchar*) _tmp31_;
#line 1170 "glib-2.0.vapi"
		return result;
#line 1310 "util-js.c"
	} else {
		gchar* _tmp32_;
#line 1172 "glib-2.0.vapi"
		_tmp32_ = g_strdup ("");
#line 1172 "glib-2.0.vapi"
		result = _tmp32_;
#line 1172 "glib-2.0.vapi"
		return result;
#line 1319 "util-js.c"
	}
}

gchar*
util_js_callable_to_string (UtilJSCallable* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result = NULL;
#line 200 "../src/client/util/util-js.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "../src/client/util/util-js.vala"
	_tmp0_ = self->priv->base_name;
#line 201 "../src/client/util/util-js.vala"
	_tmp1_ = g_strconcat (_tmp0_, "(", NULL);
#line 201 "../src/client/util/util-js.vala"
	_tmp2_ = _tmp1_;
#line 201 "../src/client/util/util-js.vala"
	_tmp3_ = self->priv->safe_args;
#line 201 "../src/client/util/util-js.vala"
	_tmp3__length1 = self->priv->safe_args_length1;
#line 201 "../src/client/util/util-js.vala"
	_tmp4_ = _vala_g_strjoinv (",", _tmp3_, (gint) _tmp3__length1);
#line 201 "../src/client/util/util-js.vala"
	_tmp5_ = _tmp4_;
#line 201 "../src/client/util/util-js.vala"
	_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 201 "../src/client/util/util-js.vala"
	_tmp7_ = _tmp6_;
#line 201 "../src/client/util/util-js.vala"
	_tmp8_ = g_strconcat (_tmp7_, ");", NULL);
#line 201 "../src/client/util/util-js.vala"
	_tmp9_ = _tmp8_;
#line 201 "../src/client/util/util-js.vala"
	_g_free0 (_tmp7_);
#line 201 "../src/client/util/util-js.vala"
	_g_free0 (_tmp5_);
#line 201 "../src/client/util/util-js.vala"
	_g_free0 (_tmp2_);
#line 201 "../src/client/util/util-js.vala"
	result = _tmp9_;
#line 201 "../src/client/util/util-js.vala"
	return result;
#line 1372 "util-js.c"
}

static gpointer
_util_js_callable_ref0 (gpointer self)
{
#line 206 "../src/client/util/util-js.vala"
	return self ? util_js_callable_ref (self) : NULL;
#line 1380 "util-js.c"
}

UtilJSCallable*
util_js_callable_string (UtilJSCallable* self,
                         const gchar* value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	UtilJSCallable* _tmp6_;
	UtilJSCallable* result = NULL;
#line 204 "../src/client/util/util-js.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "../src/client/util/util-js.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 205 "../src/client/util/util-js.vala"
	_tmp0_ = util_js_escape_string (value);
#line 205 "../src/client/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 205 "../src/client/util/util-js.vala"
	_tmp2_ = g_strconcat ("\"", _tmp1_, NULL);
#line 205 "../src/client/util/util-js.vala"
	_tmp3_ = _tmp2_;
#line 205 "../src/client/util/util-js.vala"
	_tmp4_ = g_strconcat (_tmp3_, "\"", NULL);
#line 205 "../src/client/util/util-js.vala"
	_tmp5_ = _tmp4_;
#line 205 "../src/client/util/util-js.vala"
	util_js_callable_add_param (self, _tmp5_);
#line 205 "../src/client/util/util-js.vala"
	_g_free0 (_tmp5_);
#line 205 "../src/client/util/util-js.vala"
	_g_free0 (_tmp3_);
#line 205 "../src/client/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 206 "../src/client/util/util-js.vala"
	_tmp6_ = _util_js_callable_ref0 (self);
#line 206 "../src/client/util/util-js.vala"
	result = _tmp6_;
#line 206 "../src/client/util/util-js.vala"
	return result;
#line 1425 "util-js.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 938 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 938 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 938 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 938 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 938 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 938 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 938 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 938 "glib-2.0.vapi"
	result = _tmp4_;
#line 938 "glib-2.0.vapi"
	return result;
#line 1456 "util-js.c"
}

UtilJSCallable*
util_js_callable_double (UtilJSCallable* self,
                         gdouble value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	UtilJSCallable* _tmp2_;
	UtilJSCallable* result = NULL;
#line 209 "../src/client/util/util-js.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "../src/client/util/util-js.vala"
	_tmp0_ = double_to_string (value);
#line 210 "../src/client/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 210 "../src/client/util/util-js.vala"
	util_js_callable_add_param (self, _tmp1_);
#line 210 "../src/client/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 211 "../src/client/util/util-js.vala"
	_tmp2_ = _util_js_callable_ref0 (self);
#line 211 "../src/client/util/util-js.vala"
	result = _tmp2_;
#line 211 "../src/client/util/util-js.vala"
	return result;
#line 1483 "util-js.c"
}

UtilJSCallable*
util_js_callable_int (UtilJSCallable* self,
                      gint value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	UtilJSCallable* _tmp2_;
	UtilJSCallable* result = NULL;
#line 214 "../src/client/util/util-js.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 215 "../src/client/util/util-js.vala"
	_tmp0_ = g_strdup_printf ("%i", value);
#line 215 "../src/client/util/util-js.vala"
	_tmp1_ = _tmp0_;
#line 215 "../src/client/util/util-js.vala"
	util_js_callable_add_param (self, _tmp1_);
#line 215 "../src/client/util/util-js.vala"
	_g_free0 (_tmp1_);
#line 216 "../src/client/util/util-js.vala"
	_tmp2_ = _util_js_callable_ref0 (self);
#line 216 "../src/client/util/util-js.vala"
	result = _tmp2_;
#line 216 "../src/client/util/util-js.vala"
	return result;
#line 1510 "util-js.c"
}

UtilJSCallable*
util_js_callable_bool (UtilJSCallable* self,
                       gboolean value)
{
	const gchar* _tmp0_ = NULL;
	UtilJSCallable* _tmp1_;
	UtilJSCallable* result = NULL;
#line 219 "../src/client/util/util-js.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 220 "../src/client/util/util-js.vala"
	if (value) {
#line 220 "../src/client/util/util-js.vala"
		_tmp0_ = "true";
#line 1526 "util-js.c"
	} else {
#line 220 "../src/client/util/util-js.vala"
		_tmp0_ = "false";
#line 1530 "util-js.c"
	}
#line 220 "../src/client/util/util-js.vala"
	util_js_callable_add_param (self, _tmp0_);
#line 221 "../src/client/util/util-js.vala"
	_tmp1_ = _util_js_callable_ref0 (self);
#line 221 "../src/client/util/util-js.vala"
	result = _tmp1_;
#line 221 "../src/client/util/util-js.vala"
	return result;
#line 1540 "util-js.c"
}

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 225 "../src/client/util/util-js.vala"
	if ((*length) == (*size)) {
#line 225 "../src/client/util/util-js.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 225 "../src/client/util/util-js.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1555 "util-js.c"
	}
#line 225 "../src/client/util/util-js.vala"
	(*array)[(*length)++] = value;
#line 225 "../src/client/util/util-js.vala"
	(*array)[*length] = NULL;
#line 1561 "util-js.c"
}

static inline void
util_js_callable_add_param (UtilJSCallable* self,
                            const gchar* value)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
#line 224 "../src/client/util/util-js.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/client/util/util-js.vala"
	g_return_if_fail (value != NULL);
#line 225 "../src/client/util/util-js.vala"
	_tmp0_ = self->priv->safe_args;
#line 225 "../src/client/util/util-js.vala"
	_tmp0__length1 = self->priv->safe_args_length1;
#line 225 "../src/client/util/util-js.vala"
	_tmp1_ = g_strdup (value);
#line 225 "../src/client/util/util-js.vala"
	_vala_array_add1 (&self->priv->safe_args, &self->priv->safe_args_length1, &self->priv->_safe_args_size_, _tmp1_);
#line 1583 "util-js.c"
}

static void
util_js_value_callable_init (GValue* value)
{
#line 190 "../src/client/util/util-js.vala"
	value->data[0].v_pointer = NULL;
#line 1591 "util-js.c"
}

static void
util_js_value_callable_free_value (GValue* value)
{
#line 190 "../src/client/util/util-js.vala"
	if (value->data[0].v_pointer) {
#line 190 "../src/client/util/util-js.vala"
		util_js_callable_unref (value->data[0].v_pointer);
#line 1601 "util-js.c"
	}
}

static void
util_js_value_callable_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 190 "../src/client/util/util-js.vala"
	if (src_value->data[0].v_pointer) {
#line 190 "../src/client/util/util-js.vala"
		dest_value->data[0].v_pointer = util_js_callable_ref (src_value->data[0].v_pointer);
#line 1613 "util-js.c"
	} else {
#line 190 "../src/client/util/util-js.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1617 "util-js.c"
	}
}

static gpointer
util_js_value_callable_peek_pointer (const GValue* value)
{
#line 190 "../src/client/util/util-js.vala"
	return value->data[0].v_pointer;
#line 1626 "util-js.c"
}

static gchar*
util_js_value_callable_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 190 "../src/client/util/util-js.vala"
	if (collect_values[0].v_pointer) {
#line 1637 "util-js.c"
		UtilJSCallable * object;
		object = collect_values[0].v_pointer;
#line 190 "../src/client/util/util-js.vala"
		if (object->parent_instance.g_class == NULL) {
#line 190 "../src/client/util/util-js.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1644 "util-js.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 190 "../src/client/util/util-js.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1648 "util-js.c"
		}
#line 190 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = util_js_callable_ref (object);
#line 1652 "util-js.c"
	} else {
#line 190 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 1656 "util-js.c"
	}
#line 190 "../src/client/util/util-js.vala"
	return NULL;
#line 1660 "util-js.c"
}

static gchar*
util_js_value_callable_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	UtilJSCallable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 190 "../src/client/util/util-js.vala"
	if (!object_p) {
#line 190 "../src/client/util/util-js.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1675 "util-js.c"
	}
#line 190 "../src/client/util/util-js.vala"
	if (!value->data[0].v_pointer) {
#line 190 "../src/client/util/util-js.vala"
		*object_p = NULL;
#line 1681 "util-js.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 190 "../src/client/util/util-js.vala"
		*object_p = value->data[0].v_pointer;
#line 1685 "util-js.c"
	} else {
#line 190 "../src/client/util/util-js.vala"
		*object_p = util_js_callable_ref (value->data[0].v_pointer);
#line 1689 "util-js.c"
	}
#line 190 "../src/client/util/util-js.vala"
	return NULL;
#line 1693 "util-js.c"
}

GParamSpec*
util_js_param_spec_callable (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	UtilJSParamSpecCallable* spec;
#line 190 "../src/client/util/util-js.vala"
	g_return_val_if_fail (g_type_is_a (object_type, UTIL_JS_TYPE_CALLABLE), NULL);
#line 190 "../src/client/util/util-js.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 190 "../src/client/util/util-js.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 190 "../src/client/util/util-js.vala"
	return G_PARAM_SPEC (spec);
#line 1712 "util-js.c"
}

gpointer
util_js_value_get_callable (const GValue* value)
{
#line 190 "../src/client/util/util-js.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTIL_JS_TYPE_CALLABLE), NULL);
#line 190 "../src/client/util/util-js.vala"
	return value->data[0].v_pointer;
#line 1722 "util-js.c"
}

void
util_js_value_set_callable (GValue* value,
                            gpointer v_object)
{
	UtilJSCallable * old;
#line 190 "../src/client/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTIL_JS_TYPE_CALLABLE));
#line 190 "../src/client/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 190 "../src/client/util/util-js.vala"
	if (v_object) {
#line 190 "../src/client/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTIL_JS_TYPE_CALLABLE));
#line 190 "../src/client/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 190 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 190 "../src/client/util/util-js.vala"
		util_js_callable_ref (value->data[0].v_pointer);
#line 1744 "util-js.c"
	} else {
#line 190 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 1748 "util-js.c"
	}
#line 190 "../src/client/util/util-js.vala"
	if (old) {
#line 190 "../src/client/util/util-js.vala"
		util_js_callable_unref (old);
#line 1754 "util-js.c"
	}
}

void
util_js_value_take_callable (GValue* value,
                             gpointer v_object)
{
	UtilJSCallable * old;
#line 190 "../src/client/util/util-js.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTIL_JS_TYPE_CALLABLE));
#line 190 "../src/client/util/util-js.vala"
	old = value->data[0].v_pointer;
#line 190 "../src/client/util/util-js.vala"
	if (v_object) {
#line 190 "../src/client/util/util-js.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTIL_JS_TYPE_CALLABLE));
#line 190 "../src/client/util/util-js.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 190 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = v_object;
#line 1775 "util-js.c"
	} else {
#line 190 "../src/client/util/util-js.vala"
		value->data[0].v_pointer = NULL;
#line 1779 "util-js.c"
	}
#line 190 "../src/client/util/util-js.vala"
	if (old) {
#line 190 "../src/client/util/util-js.vala"
		util_js_callable_unref (old);
#line 1785 "util-js.c"
	}
}

static void
util_js_callable_class_init (UtilJSCallableClass * klass,
                             gpointer klass_data)
{
#line 190 "../src/client/util/util-js.vala"
	util_js_callable_parent_class = g_type_class_peek_parent (klass);
#line 190 "../src/client/util/util-js.vala"
	((UtilJSCallableClass *) klass)->finalize = util_js_callable_finalize;
#line 190 "../src/client/util/util-js.vala"
	g_type_class_adjust_private_offset (klass, &UtilJSCallable_private_offset);
#line 1799 "util-js.c"
}

static void
util_js_callable_instance_init (UtilJSCallable * self,
                                gpointer klass)
{
	gchar** _tmp0_;
#line 190 "../src/client/util/util-js.vala"
	self->priv = util_js_callable_get_instance_private (self);
#line 193 "../src/client/util/util-js.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 193 "../src/client/util/util-js.vala"
	self->priv->safe_args = _tmp0_;
#line 193 "../src/client/util/util-js.vala"
	self->priv->safe_args_length1 = 0;
#line 193 "../src/client/util/util-js.vala"
	self->priv->_safe_args_size_ = self->priv->safe_args_length1;
#line 190 "../src/client/util/util-js.vala"
	self->ref_count = 1;
#line 1819 "util-js.c"
}

static void
util_js_callable_finalize (UtilJSCallable * obj)
{
	UtilJSCallable * self;
#line 190 "../src/client/util/util-js.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UTIL_JS_TYPE_CALLABLE, UtilJSCallable);
#line 190 "../src/client/util/util-js.vala"
	g_signal_handlers_destroy (self);
#line 192 "../src/client/util/util-js.vala"
	_g_free0 (self->priv->base_name);
#line 193 "../src/client/util/util-js.vala"
	self->priv->safe_args = (_vala_array_free (self->priv->safe_args, self->priv->safe_args_length1, (GDestroyNotify) g_free), NULL);
#line 1834 "util-js.c"
}

/**
     * A class for constructing a well formed, safe, invokable JS call.
     */
GType
util_js_callable_get_type (void)
{
	static volatile gsize util_js_callable_type_id__volatile = 0;
	if (g_once_init_enter (&util_js_callable_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { util_js_value_callable_init, util_js_value_callable_free_value, util_js_value_callable_copy_value, util_js_value_callable_peek_pointer, "p", util_js_value_callable_collect_value, "p", util_js_value_callable_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UtilJSCallableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) util_js_callable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilJSCallable), 0, (GInstanceInitFunc) util_js_callable_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType util_js_callable_type_id;
		util_js_callable_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UtilJSCallable", &g_define_type_info, &g_define_type_fundamental_info, 0);
		UtilJSCallable_private_offset = g_type_add_instance_private (util_js_callable_type_id, sizeof (UtilJSCallablePrivate));
		g_once_init_leave (&util_js_callable_type_id__volatile, util_js_callable_type_id);
	}
	return util_js_callable_type_id__volatile;
}

gpointer
util_js_callable_ref (gpointer instance)
{
	UtilJSCallable * self;
	self = instance;
#line 190 "../src/client/util/util-js.vala"
	g_atomic_int_inc (&self->ref_count);
#line 190 "../src/client/util/util-js.vala"
	return instance;
#line 1865 "util-js.c"
}

void
util_js_callable_unref (gpointer instance)
{
	UtilJSCallable * self;
	self = instance;
#line 190 "../src/client/util/util-js.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 190 "../src/client/util/util-js.vala"
		UTIL_JS_CALLABLE_GET_CLASS (self)->finalize (self);
#line 190 "../src/client/util/util-js.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1879 "util-js.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

