/* geary-config.c generated by valac 0.46.0, the Vala compiler
 * generated from geary-config.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "geary-engine.h"
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
typedef struct _ConfigurationPrivate ConfigurationPrivate;
typedef enum  {
	CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN = 0,
	CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY
} ConfigurationDesktopEnvironment;

#define CONFIGURATION_TYPE_DESKTOP_ENVIRONMENT (configuration_desktop_environment_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef enum  {
	UTIL_DATE_CLOCK_FORMAT_TWELVE_HOURS,
	UTIL_DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS,
	UTIL_DATE_CLOCK_FORMAT_LOCALE_DEFAULT,
	UTIL_DATE_CLOCK_FORMAT_TOTAL
} UtilDateClockFormat;

#define UTIL_DATE_TYPE_CLOCK_FORMAT (util_date_clock_format_get_type ())
typedef struct _ParamSpecConfiguration ParamSpecConfiguration;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Configuration {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ConfigurationPrivate * priv;
};

struct _ConfigurationClass {
	GTypeClass parent_class;
	void (*finalize) (Configuration *self);
};

struct _ConfigurationPrivate {
	GSettings* _settings;
	GSettings* _gnome_interface;
	gboolean _enable_debug;
	gboolean _enable_inspector;
	gboolean _revoke_certs;
};

struct _ParamSpecConfiguration {
	GParamSpec parent_instance;
};

static gint Configuration_private_offset;
static gpointer configuration_parent_class = NULL;

gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_configuration (GValue* value,
                              gpointer v_object);
void value_take_configuration (GValue* value,
                               gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Configuration, configuration_unref)
GType configuration_desktop_environment_get_type (void) G_GNUC_CONST;
#define CONFIGURATION_WINDOW_WIDTH_KEY "window-width"
#define CONFIGURATION_WINDOW_HEIGHT_KEY "window-height"
#define CONFIGURATION_WINDOW_MAXIMIZE_KEY "window-maximize"
#define CONFIGURATION_FOLDER_LIST_PANE_POSITION_KEY "folder-list-pane-position"
#define CONFIGURATION_FOLDER_LIST_PANE_POSITION_HORIZONTAL_KEY "folder-list-pane-position-horizontal"
#define CONFIGURATION_FOLDER_LIST_PANE_POSITION_VERTICAL_KEY "folder-list-pane-position-vertical"
#define CONFIGURATION_FOLDER_LIST_PANE_HORIZONTAL_KEY "folder-list-pane-horizontal"
#define CONFIGURATION_MESSAGES_PANE_POSITION_KEY "messages-pane-position"
#define CONFIGURATION_AUTOSELECT_KEY "autoselect"
#define CONFIGURATION_DISPLAY_PREVIEW_KEY "display-preview"
#define CONFIGURATION_PLAY_SOUNDS_KEY "play-sounds"
#define CONFIGURATION_SHOW_NOTIFICATIONS_KEY "show-notifications"
#define CONFIGURATION_STARTUP_NOTIFICATIONS_KEY "startup-notifications"
#define CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY "ask-open-attachment"
#define CONFIGURATION_COMPOSE_AS_HTML_KEY "compose-as-html"
#define CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES "spell-check-visible-languages"
#define CONFIGURATION_SPELL_CHECK_LANGUAGES "spell-check-languages"
#define CONFIGURATION_SEARCH_STRATEGY_KEY "search-strategy"
#define CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY "conversation-viewer-zoom"
#define CONFIGURATION_COMPOSER_WINDOW_SIZE_KEY "composer-window-size"
#define CONFIGURATION_CLOCK_FORMAT_KEY "clock-format"
void configuration_init (gboolean is_installed,
                         const gchar* schema_dir);
Configuration* configuration_new (const gchar* schema_id);
Configuration* configuration_construct (GType object_type,
                                        const gchar* schema_id);
static void configuration_set_settings (Configuration* self,
                                 GSettings* value);
static void configuration_set_gnome_interface (Configuration* self,
                                        GSettings* value);
void migrate_old_app_config (GSettings* newSettings,
                             const gchar* old_app_id);
GSettings* configuration_get_settings (Configuration* self);
#define MIGRATE_OLD_APP_ID "org.yorba.geary"
void configuration_bind (Configuration* self,
                         const gchar* key,
                         GObject* object,
                         const gchar* property,
                         GSettingsBindFlags flags);
static void configuration_set_boolean (Configuration* self,
                                const gchar* name,
                                gboolean value);
GearySearchQueryStrategy configuration_get_search_strategy (Configuration* self);
void configuration_set_search_strategy (Configuration* self,
                                        GearySearchQueryStrategy strategy);
GSettings* configuration_get_gnome_interface (Configuration* self);
gboolean configuration_get_enable_debug (Configuration* self);
void configuration_set_enable_debug (Configuration* self,
                                     gboolean value);
gboolean configuration_get_enable_inspector (Configuration* self);
void configuration_set_enable_inspector (Configuration* self,
                                         gboolean value);
gboolean configuration_get_revoke_certs (Configuration* self);
void configuration_set_revoke_certs (Configuration* self,
                                     gboolean value);
ConfigurationDesktopEnvironment configuration_get_desktop_environment (Configuration* self);
gint configuration_get_window_width (Configuration* self);
gint configuration_get_window_height (Configuration* self);
gboolean configuration_get_window_maximize (Configuration* self);
gint configuration_get_folder_list_pane_position_old (Configuration* self);
gint configuration_get_folder_list_pane_position_horizontal (Configuration* self);
void configuration_set_folder_list_pane_position_horizontal (Configuration* self,
                                                             gint value);
gint configuration_get_folder_list_pane_position_vertical (Configuration* self);
gboolean configuration_get_folder_list_pane_horizontal (Configuration* self);
gint configuration_get_messages_pane_position (Configuration* self);
void configuration_set_messages_pane_position (Configuration* self,
                                               gint value);
gboolean configuration_get_autoselect (Configuration* self);
gboolean configuration_get_display_preview (Configuration* self);
gchar** configuration_get_spell_check_languages (Configuration* self,
                                                 gint* result_length1);
gchar** util_international_get_user_preferred_languages (gint* result_length1);
static gchar** _vala_array_dup4 (gchar** self,
                          int length);
void configuration_set_spell_check_languages (Configuration* self,
                                              gchar** value,
                                              gint value_length1);
gchar** configuration_get_spell_check_visible_languages (Configuration* self,
                                                         gint* result_length1);
void configuration_set_spell_check_visible_languages (Configuration* self,
                                                      gchar** value,
                                                      gint value_length1);
gboolean configuration_get_play_sounds (Configuration* self);
gboolean configuration_get_show_notifications (Configuration* self);
gboolean configuration_get_startup_notifications (Configuration* self);
void configuration_set_startup_notifications (Configuration* self,
                                              gboolean value);
GType util_date_clock_format_get_type (void) G_GNUC_CONST;
UtilDateClockFormat configuration_get_clock_format (Configuration* self);
gboolean configuration_get_ask_open_attachment (Configuration* self);
void configuration_set_ask_open_attachment (Configuration* self,
                                            gboolean value);
gboolean configuration_get_compose_as_html (Configuration* self);
void configuration_set_compose_as_html (Configuration* self,
                                        gboolean value);
gdouble configuration_get_conversation_viewer_zoom (Configuration* self);
void configuration_set_conversation_viewer_zoom (Configuration* self,
                                                 gdouble value);
gint* configuration_get_composer_window_size (Configuration* self,
                                              gint* result_length1);
static gint _variant_get2 (GVariant* value);
static gint _variant_get3 (GVariant* value);
void configuration_set_composer_window_size (Configuration* self,
                                             gint* value,
                                             gint value_length1);
static GVariant* _variant_new1 (gint* value,
                         gint value_length1);
static void configuration_finalize (Configuration * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
configuration_get_instance_private (Configuration* self)
{
	return G_STRUCT_MEMBER_P (self, Configuration_private_offset);
}

GType
configuration_desktop_environment_get_type (void)
{
	static volatile gsize configuration_desktop_environment_type_id__volatile = 0;
	if (g_once_init_enter (&configuration_desktop_environment_type_id__volatile)) {
		static const GEnumValue values[] = {{CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN, "CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN", "unknown"}, {CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY, "CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY", "unity"}, {0, NULL, NULL}};
		GType configuration_desktop_environment_type_id;
		configuration_desktop_environment_type_id = g_enum_register_static ("ConfigurationDesktopEnvironment", values);
		g_once_init_leave (&configuration_desktop_environment_type_id__volatile, configuration_desktop_environment_type_id);
	}
	return configuration_desktop_environment_type_id__volatile;
}

void
configuration_init (gboolean is_installed,
                    const gchar* schema_dir)
{
#line 43 "../src/client/application/geary-config.vala"
	if (!is_installed) {
#line 44 "../src/client/application/geary-config.vala"
		_vala_assert (schema_dir != NULL, "schema_dir != null");
#line 47 "../src/client/application/geary-config.vala"
		g_setenv ("GSETTINGS_SCHEMA_DIR", schema_dir, TRUE);
#line 241 "geary-config.c"
	}
}

Configuration*
configuration_construct (GType object_type,
                         const gchar* schema_id)
{
	Configuration* self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
#line 213 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (schema_id != NULL, NULL);
#line 213 "../src/client/application/geary-config.vala"
	self = (Configuration*) g_type_create_instance (object_type);
#line 215 "../src/client/application/geary-config.vala"
	_tmp0_ = g_settings_new (schema_id);
#line 215 "../src/client/application/geary-config.vala"
	_tmp1_ = _tmp0_;
#line 215 "../src/client/application/geary-config.vala"
	configuration_set_settings (self, _tmp1_);
#line 215 "../src/client/application/geary-config.vala"
	_g_object_unref0 (_tmp1_);
#line 216 "../src/client/application/geary-config.vala"
	_tmp2_ = g_settings_new ("org.gnome.desktop.interface");
#line 216 "../src/client/application/geary-config.vala"
	_tmp3_ = _tmp2_;
#line 216 "../src/client/application/geary-config.vala"
	configuration_set_gnome_interface (self, _tmp3_);
#line 216 "../src/client/application/geary-config.vala"
	_g_object_unref0 (_tmp3_);
#line 218 "../src/client/application/geary-config.vala"
	_tmp4_ = self->priv->_settings;
#line 218 "../src/client/application/geary-config.vala"
	migrate_old_app_config (_tmp4_, MIGRATE_OLD_APP_ID);
#line 213 "../src/client/application/geary-config.vala"
	return self;
#line 281 "geary-config.c"
}

Configuration*
configuration_new (const gchar* schema_id)
{
#line 213 "../src/client/application/geary-config.vala"
	return configuration_construct (TYPE_CONFIGURATION, schema_id);
#line 289 "geary-config.c"
}

void
configuration_bind (Configuration* self,
                    const gchar* key,
                    GObject* object,
                    const gchar* property,
                    GSettingsBindFlags flags)
{
	GSettings* _tmp0_;
#line 221 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 221 "../src/client/application/geary-config.vala"
	g_return_if_fail (key != NULL);
#line 221 "../src/client/application/geary-config.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (object, G_TYPE_OBJECT));
#line 221 "../src/client/application/geary-config.vala"
	g_return_if_fail (property != NULL);
#line 223 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 223 "../src/client/application/geary-config.vala"
	g_settings_bind (_tmp0_, key, object, property, flags);
#line 312 "geary-config.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 321 "geary-config.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 329 "geary-config.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 338 "geary-config.c"
	}
}

static void
configuration_set_boolean (Configuration* self,
                           const gchar* name,
                           gboolean value)
{
	GSettings* _tmp0_;
#line 226 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 226 "../src/client/application/geary-config.vala"
	g_return_if_fail (name != NULL);
#line 227 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 227 "../src/client/application/geary-config.vala"
	if (!g_settings_set_boolean (_tmp0_, name, value)) {
#line 356 "geary-config.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 228 "../src/client/application/geary-config.vala"
		_tmp1_ = bool_to_string (value);
#line 228 "../src/client/application/geary-config.vala"
		_tmp2_ = _tmp1_;
#line 228 "../src/client/application/geary-config.vala"
		g_message ("geary-config.vala:228: Unable to set configuration value %s = %s", name, _tmp2_);
#line 228 "../src/client/application/geary-config.vala"
		_g_free0 (_tmp2_);
#line 367 "geary-config.c"
	}
}

GearySearchQueryStrategy
configuration_get_search_strategy (Configuration* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
#line 232 "../src/client/application/geary-config.vala"
	static GQuark _tmp6_label0 = 0;
#line 232 "../src/client/application/geary-config.vala"
	static GQuark _tmp6_label1 = 0;
#line 232 "../src/client/application/geary-config.vala"
	static GQuark _tmp6_label2 = 0;
#line 387 "geary-config.c"
	GearySearchQueryStrategy result = 0;
#line 231 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 232 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 232 "../src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, CONFIGURATION_SEARCH_STRATEGY_KEY);
#line 232 "../src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_;
#line 232 "../src/client/application/geary-config.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 232 "../src/client/application/geary-config.vala"
	_tmp4_ = _tmp3_;
#line 232 "../src/client/application/geary-config.vala"
	_g_free0 (_tmp2_);
#line 232 "../src/client/application/geary-config.vala"
	_tmp5_ = _tmp4_;
#line 232 "../src/client/application/geary-config.vala"
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
#line 232 "../src/client/application/geary-config.vala"
	g_free (_tmp5_);
#line 232 "../src/client/application/geary-config.vala"
	if (_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("exact")))) {
#line 232 "../src/client/application/geary-config.vala"
		switch (0) {
#line 413 "geary-config.c"
			default:
			{
#line 234 "../src/client/application/geary-config.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_EXACT;
#line 234 "../src/client/application/geary-config.vala"
				return result;
#line 420 "geary-config.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("aggressive")))) {
#line 232 "../src/client/application/geary-config.vala"
		switch (0) {
#line 426 "geary-config.c"
			default:
			{
#line 237 "../src/client/application/geary-config.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE;
#line 237 "../src/client/application/geary-config.vala"
				return result;
#line 433 "geary-config.c"
			}
		}
	} else if (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("horizon")))) {
#line 232 "../src/client/application/geary-config.vala"
		switch (0) {
#line 439 "geary-config.c"
			default:
			{
#line 240 "../src/client/application/geary-config.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_HORIZON;
#line 240 "../src/client/application/geary-config.vala"
				return result;
#line 446 "geary-config.c"
			}
		}
	} else {
#line 232 "../src/client/application/geary-config.vala"
		switch (0) {
#line 452 "geary-config.c"
			default:
			{
#line 244 "../src/client/application/geary-config.vala"
				result = GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE;
#line 244 "../src/client/application/geary-config.vala"
				return result;
#line 459 "geary-config.c"
			}
		}
	}
}

void
configuration_set_search_strategy (Configuration* self,
                                   GearySearchQueryStrategy strategy)
{
#line 248 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 249 "../src/client/application/geary-config.vala"
	switch (strategy) {
#line 249 "../src/client/application/geary-config.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_EXACT:
#line 475 "geary-config.c"
		{
			GSettings* _tmp0_;
#line 251 "../src/client/application/geary-config.vala"
			_tmp0_ = self->priv->_settings;
#line 251 "../src/client/application/geary-config.vala"
			g_settings_set_string (_tmp0_, CONFIGURATION_SEARCH_STRATEGY_KEY, "exact");
#line 252 "../src/client/application/geary-config.vala"
			break;
#line 484 "geary-config.c"
		}
#line 249 "../src/client/application/geary-config.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_AGGRESSIVE:
#line 488 "geary-config.c"
		{
			GSettings* _tmp1_;
#line 255 "../src/client/application/geary-config.vala"
			_tmp1_ = self->priv->_settings;
#line 255 "../src/client/application/geary-config.vala"
			g_settings_set_string (_tmp1_, CONFIGURATION_SEARCH_STRATEGY_KEY, "aggressive");
#line 256 "../src/client/application/geary-config.vala"
			break;
#line 497 "geary-config.c"
		}
#line 249 "../src/client/application/geary-config.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_HORIZON:
#line 501 "geary-config.c"
		{
			GSettings* _tmp2_;
#line 259 "../src/client/application/geary-config.vala"
			_tmp2_ = self->priv->_settings;
#line 259 "../src/client/application/geary-config.vala"
			g_settings_set_string (_tmp2_, CONFIGURATION_SEARCH_STRATEGY_KEY, "horizon");
#line 260 "../src/client/application/geary-config.vala"
			break;
#line 510 "geary-config.c"
		}
		default:
#line 249 "../src/client/application/geary-config.vala"
		case GEARY_SEARCH_QUERY_STRATEGY_CONSERVATIVE:
#line 515 "geary-config.c"
		{
			GSettings* _tmp3_;
#line 264 "../src/client/application/geary-config.vala"
			_tmp3_ = self->priv->_settings;
#line 264 "../src/client/application/geary-config.vala"
			g_settings_set_string (_tmp3_, CONFIGURATION_SEARCH_STRATEGY_KEY, "conservative");
#line 265 "../src/client/application/geary-config.vala"
			break;
#line 524 "geary-config.c"
		}
	}
}

GSettings*
configuration_get_settings (Configuration* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 52 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 52 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 52 "../src/client/application/geary-config.vala"
	result = _tmp0_;
#line 52 "../src/client/application/geary-config.vala"
	return result;
#line 542 "geary-config.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/client/application/geary-config.vala"
	return self ? g_object_ref (self) : NULL;
#line 550 "geary-config.c"
}

static void
configuration_set_settings (Configuration* self,
                            GSettings* value)
{
	GSettings* _tmp0_;
#line 52 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 52 "../src/client/application/geary-config.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 52 "../src/client/application/geary-config.vala"
	_g_object_unref0 (self->priv->_settings);
#line 52 "../src/client/application/geary-config.vala"
	self->priv->_settings = _tmp0_;
#line 566 "geary-config.c"
}

GSettings*
configuration_get_gnome_interface (Configuration* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 53 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 53 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_gnome_interface;
#line 53 "../src/client/application/geary-config.vala"
	result = _tmp0_;
#line 53 "../src/client/application/geary-config.vala"
	return result;
#line 582 "geary-config.c"
}

static void
configuration_set_gnome_interface (Configuration* self,
                                   GSettings* value)
{
	GSettings* _tmp0_;
#line 53 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 53 "../src/client/application/geary-config.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 53 "../src/client/application/geary-config.vala"
	_g_object_unref0 (self->priv->_gnome_interface);
#line 53 "../src/client/application/geary-config.vala"
	self->priv->_gnome_interface = _tmp0_;
#line 598 "geary-config.c"
}

gboolean
configuration_get_enable_debug (Configuration* self)
{
	gboolean result;
#line 56 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 56 "../src/client/application/geary-config.vala"
	result = self->priv->_enable_debug;
#line 56 "../src/client/application/geary-config.vala"
	return result;
#line 611 "geary-config.c"
}

void
configuration_set_enable_debug (Configuration* self,
                                gboolean value)
{
#line 56 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 56 "../src/client/application/geary-config.vala"
	self->priv->_enable_debug = value;
#line 622 "geary-config.c"
}

gboolean
configuration_get_enable_inspector (Configuration* self)
{
	gboolean result;
#line 59 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 59 "../src/client/application/geary-config.vala"
	result = self->priv->_enable_inspector;
#line 59 "../src/client/application/geary-config.vala"
	return result;
#line 635 "geary-config.c"
}

void
configuration_set_enable_inspector (Configuration* self,
                                    gboolean value)
{
#line 59 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 59 "../src/client/application/geary-config.vala"
	self->priv->_enable_inspector = value;
#line 646 "geary-config.c"
}

gboolean
configuration_get_revoke_certs (Configuration* self)
{
	gboolean result;
#line 62 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 62 "../src/client/application/geary-config.vala"
	result = self->priv->_revoke_certs;
#line 62 "../src/client/application/geary-config.vala"
	return result;
#line 659 "geary-config.c"
}

void
configuration_set_revoke_certs (Configuration* self,
                                gboolean value)
{
#line 62 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 62 "../src/client/application/geary-config.vala"
	self->priv->_revoke_certs = value;
#line 670 "geary-config.c"
}

ConfigurationDesktopEnvironment
configuration_get_desktop_environment (Configuration* self)
{
	ConfigurationDesktopEnvironment result;
	gchar* xdg_current_desktop = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
#line 65 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 66 "../src/client/application/geary-config.vala"
	_tmp0_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 66 "../src/client/application/geary-config.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 66 "../src/client/application/geary-config.vala"
	xdg_current_desktop = _tmp1_;
#line 67 "../src/client/application/geary-config.vala"
	_tmp3_ = xdg_current_desktop;
#line 67 "../src/client/application/geary-config.vala"
	if (_tmp3_ != NULL) {
#line 694 "geary-config.c"
		const gchar* _tmp4_;
#line 67 "../src/client/application/geary-config.vala"
		_tmp4_ = xdg_current_desktop;
#line 67 "../src/client/application/geary-config.vala"
		_tmp2_ = g_str_has_prefix (_tmp4_, "Unity");
#line 700 "geary-config.c"
	} else {
#line 67 "../src/client/application/geary-config.vala"
		_tmp2_ = FALSE;
#line 704 "geary-config.c"
	}
#line 67 "../src/client/application/geary-config.vala"
	if (_tmp2_) {
#line 68 "../src/client/application/geary-config.vala"
		result = CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY;
#line 68 "../src/client/application/geary-config.vala"
		_g_free0 (xdg_current_desktop);
#line 68 "../src/client/application/geary-config.vala"
		return result;
#line 714 "geary-config.c"
	} else {
#line 70 "../src/client/application/geary-config.vala"
		result = CONFIGURATION_DESKTOP_ENVIRONMENT_UNKNOWN;
#line 70 "../src/client/application/geary-config.vala"
		_g_free0 (xdg_current_desktop);
#line 70 "../src/client/application/geary-config.vala"
		return result;
#line 722 "geary-config.c"
	}
#line 65 "../src/client/application/geary-config.vala"
	_g_free0 (xdg_current_desktop);
#line 726 "geary-config.c"
}

gint
configuration_get_window_width (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 76 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 76 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 76 "../src/client/application/geary-config.vala"
	result = g_settings_get_int (_tmp0_, CONFIGURATION_WINDOW_WIDTH_KEY);
#line 76 "../src/client/application/geary-config.vala"
	return result;
#line 742 "geary-config.c"
}

gint
configuration_get_window_height (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 80 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 80 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 80 "../src/client/application/geary-config.vala"
	result = g_settings_get_int (_tmp0_, CONFIGURATION_WINDOW_HEIGHT_KEY);
#line 80 "../src/client/application/geary-config.vala"
	return result;
#line 758 "geary-config.c"
}

gboolean
configuration_get_window_maximize (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 84 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 84 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 84 "../src/client/application/geary-config.vala"
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_WINDOW_MAXIMIZE_KEY);
#line 84 "../src/client/application/geary-config.vala"
	return result;
#line 774 "geary-config.c"
}

gint
configuration_get_folder_list_pane_position_old (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 88 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 88 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 88 "../src/client/application/geary-config.vala"
	result = g_settings_get_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_KEY);
#line 88 "../src/client/application/geary-config.vala"
	return result;
#line 790 "geary-config.c"
}

gint
configuration_get_folder_list_pane_position_horizontal (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 92 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 92 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 92 "../src/client/application/geary-config.vala"
	result = g_settings_get_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_HORIZONTAL_KEY);
#line 92 "../src/client/application/geary-config.vala"
	return result;
#line 806 "geary-config.c"
}

void
configuration_set_folder_list_pane_position_horizontal (Configuration* self,
                                                        gint value)
{
	GSettings* _tmp0_;
#line 93 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 93 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 93 "../src/client/application/geary-config.vala"
	g_settings_set_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_HORIZONTAL_KEY, value);
#line 820 "geary-config.c"
}

gint
configuration_get_folder_list_pane_position_vertical (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 97 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 97 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 97 "../src/client/application/geary-config.vala"
	result = g_settings_get_int (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_POSITION_VERTICAL_KEY);
#line 97 "../src/client/application/geary-config.vala"
	return result;
#line 836 "geary-config.c"
}

gboolean
configuration_get_folder_list_pane_horizontal (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 101 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 101 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 101 "../src/client/application/geary-config.vala"
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_FOLDER_LIST_PANE_HORIZONTAL_KEY);
#line 101 "../src/client/application/geary-config.vala"
	return result;
#line 852 "geary-config.c"
}

gint
configuration_get_messages_pane_position (Configuration* self)
{
	gint result;
	GSettings* _tmp0_;
#line 105 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 105 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 105 "../src/client/application/geary-config.vala"
	result = g_settings_get_int (_tmp0_, CONFIGURATION_MESSAGES_PANE_POSITION_KEY);
#line 105 "../src/client/application/geary-config.vala"
	return result;
#line 868 "geary-config.c"
}

void
configuration_set_messages_pane_position (Configuration* self,
                                          gint value)
{
	GSettings* _tmp0_;
#line 106 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 106 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 106 "../src/client/application/geary-config.vala"
	g_settings_set_int (_tmp0_, CONFIGURATION_MESSAGES_PANE_POSITION_KEY, value);
#line 882 "geary-config.c"
}

gboolean
configuration_get_autoselect (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 110 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 110 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 110 "../src/client/application/geary-config.vala"
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_AUTOSELECT_KEY);
#line 110 "../src/client/application/geary-config.vala"
	return result;
#line 898 "geary-config.c"
}

gboolean
configuration_get_display_preview (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 114 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 114 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 114 "../src/client/application/geary-config.vala"
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_DISPLAY_PREVIEW_KEY);
#line 114 "../src/client/application/geary-config.vala"
	return result;
#line 914 "geary-config.c"
}

static gchar**
_vala_array_dup4 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 130 "../src/client/application/geary-config.vala"
	result = g_new0 (gchar*, length + 1);
#line 130 "../src/client/application/geary-config.vala"
	for (i = 0; i < length; i++) {
#line 927 "geary-config.c"
		gchar* _tmp0_;
#line 130 "../src/client/application/geary-config.vala"
		_tmp0_ = g_strdup (self[i]);
#line 130 "../src/client/application/geary-config.vala"
		result[i] = _tmp0_;
#line 933 "geary-config.c"
	}
#line 130 "../src/client/application/geary-config.vala"
	return result;
#line 937 "geary-config.c"
}

gchar**
configuration_get_spell_check_languages (Configuration* self,
                                         gint* result_length1)
{
	gchar** result;
	GVariant* value = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	const gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint __tmp5__size_ = 0;
	GVariant* _tmp6_;
	gchar** langs = NULL;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint langs_length1;
	gint _langs_size_;
	gchar** _tmp13_;
	gint _tmp13__length1;
#line 127 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 128 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 128 "../src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, CONFIGURATION_SPELL_CHECK_LANGUAGES);
#line 128 "../src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_;
#line 128 "../src/client/application/geary-config.vala"
	_tmp3_ = g_variant_get_maybe (_tmp2_);
#line 128 "../src/client/application/geary-config.vala"
	_tmp4_ = _tmp3_;
#line 128 "../src/client/application/geary-config.vala"
	_g_variant_unref0 (_tmp2_);
#line 128 "../src/client/application/geary-config.vala"
	value = _tmp4_;
#line 130 "../src/client/application/geary-config.vala"
	_tmp6_ = value;
#line 130 "../src/client/application/geary-config.vala"
	if (_tmp6_ != NULL) {
#line 982 "geary-config.c"
		GVariant* _tmp7_;
		size_t _tmp8_ = 0;
		const gchar** _tmp9_;
#line 131 "../src/client/application/geary-config.vala"
		_tmp7_ = value;
#line 131 "../src/client/application/geary-config.vala"
		_tmp9_ = g_variant_get_strv (_tmp7_, &_tmp8_);
#line 131 "../src/client/application/geary-config.vala"
		_tmp5_ = (g_free (_tmp5_), NULL);
#line 131 "../src/client/application/geary-config.vala"
		_tmp5_ = _tmp9_;
#line 131 "../src/client/application/geary-config.vala"
		_tmp5__length1 = _tmp8_;
#line 131 "../src/client/application/geary-config.vala"
		__tmp5__size_ = _tmp5__length1;
#line 998 "geary-config.c"
	} else {
		gint _tmp10_ = 0;
		gchar** _tmp11_;
#line 132 "../src/client/application/geary-config.vala"
		_tmp11_ = util_international_get_user_preferred_languages (&_tmp10_);
#line 132 "../src/client/application/geary-config.vala"
		_tmp5_ = (g_free (_tmp5_), NULL);
#line 132 "../src/client/application/geary-config.vala"
		_tmp5_ = _tmp11_;
#line 132 "../src/client/application/geary-config.vala"
		_tmp5__length1 = _tmp10_;
#line 132 "../src/client/application/geary-config.vala"
		__tmp5__size_ = _tmp5__length1;
#line 1012 "geary-config.c"
	}
#line 130 "../src/client/application/geary-config.vala"
	_tmp12_ = (_tmp5_ != NULL) ? _vala_array_dup4 (_tmp5_, _tmp5__length1) : ((gpointer) _tmp5_);
#line 130 "../src/client/application/geary-config.vala"
	_tmp12__length1 = _tmp5__length1;
#line 130 "../src/client/application/geary-config.vala"
	langs = _tmp12_;
#line 130 "../src/client/application/geary-config.vala"
	langs_length1 = _tmp12__length1;
#line 130 "../src/client/application/geary-config.vala"
	_langs_size_ = langs_length1;
#line 133 "../src/client/application/geary-config.vala"
	_tmp13_ = langs;
#line 133 "../src/client/application/geary-config.vala"
	_tmp13__length1 = langs_length1;
#line 133 "../src/client/application/geary-config.vala"
	if (result_length1) {
#line 133 "../src/client/application/geary-config.vala"
		*result_length1 = _tmp13__length1;
#line 1032 "geary-config.c"
	}
#line 133 "../src/client/application/geary-config.vala"
	result = _tmp13_;
#line 133 "../src/client/application/geary-config.vala"
	_tmp5_ = (g_free (_tmp5_), NULL);
#line 133 "../src/client/application/geary-config.vala"
	_g_variant_unref0 (value);
#line 133 "../src/client/application/geary-config.vala"
	return result;
#line 1042 "geary-config.c"
}

void
configuration_set_spell_check_languages (Configuration* self,
                                         gchar** value,
                                         gint value_length1)
{
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
#line 135 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 136 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 136 "../src/client/application/geary-config.vala"
	_tmp1_ = g_variant_new_strv (value, value_length1);
#line 136 "../src/client/application/geary-config.vala"
	g_variant_ref_sink (_tmp1_);
#line 136 "../src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_;
#line 136 "../src/client/application/geary-config.vala"
	_tmp3_ = g_variant_new_maybe (NULL, _tmp2_);
#line 136 "../src/client/application/geary-config.vala"
	g_variant_ref_sink (_tmp3_);
#line 136 "../src/client/application/geary-config.vala"
	_tmp4_ = _tmp3_;
#line 136 "../src/client/application/geary-config.vala"
	g_settings_set_value (_tmp0_, CONFIGURATION_SPELL_CHECK_LANGUAGES, _tmp4_);
#line 136 "../src/client/application/geary-config.vala"
	_g_variant_unref0 (_tmp4_);
#line 136 "../src/client/application/geary-config.vala"
	_g_variant_unref0 (_tmp2_);
#line 1077 "geary-config.c"
}

gchar**
configuration_get_spell_check_visible_languages (Configuration* self,
                                                 gint* result_length1)
{
	gchar** result;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 150 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 151 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 151 "../src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES);
#line 151 "../src/client/application/geary-config.vala"
	_tmp3_ = _tmp2_;
#line 151 "../src/client/application/geary-config.vala"
	_tmp3__length1 = _vala_array_length (_tmp1_);
#line 151 "../src/client/application/geary-config.vala"
	if (result_length1) {
#line 151 "../src/client/application/geary-config.vala"
		*result_length1 = _tmp3__length1;
#line 1104 "geary-config.c"
	}
#line 151 "../src/client/application/geary-config.vala"
	result = _tmp3_;
#line 151 "../src/client/application/geary-config.vala"
	return result;
#line 1110 "geary-config.c"
}

void
configuration_set_spell_check_visible_languages (Configuration* self,
                                                 gchar** value,
                                                 gint value_length1)
{
	GSettings* _tmp0_;
#line 153 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 154 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 154 "../src/client/application/geary-config.vala"
	g_settings_set_strv (_tmp0_, CONFIGURATION_SPELL_CHECK_VISIBLE_LANGUAGES, value);
#line 1125 "geary-config.c"
}

gboolean
configuration_get_play_sounds (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 159 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 159 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 159 "../src/client/application/geary-config.vala"
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_PLAY_SOUNDS_KEY);
#line 159 "../src/client/application/geary-config.vala"
	return result;
#line 1141 "geary-config.c"
}

gboolean
configuration_get_show_notifications (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 163 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 163 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 163 "../src/client/application/geary-config.vala"
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_SHOW_NOTIFICATIONS_KEY);
#line 163 "../src/client/application/geary-config.vala"
	return result;
#line 1157 "geary-config.c"
}

gboolean
configuration_get_startup_notifications (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 167 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 167 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 167 "../src/client/application/geary-config.vala"
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_STARTUP_NOTIFICATIONS_KEY);
#line 167 "../src/client/application/geary-config.vala"
	return result;
#line 1173 "geary-config.c"
}

void
configuration_set_startup_notifications (Configuration* self,
                                         gboolean value)
{
#line 168 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 168 "../src/client/application/geary-config.vala"
	configuration_set_boolean (self, CONFIGURATION_STARTUP_NOTIFICATIONS_KEY, value);
#line 1184 "geary-config.c"
}

UtilDateClockFormat
configuration_get_clock_format (Configuration* self)
{
	UtilDateClockFormat result;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 173 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0);
#line 174 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_gnome_interface;
#line 174 "../src/client/application/geary-config.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, CONFIGURATION_CLOCK_FORMAT_KEY);
#line 174 "../src/client/application/geary-config.vala"
	_tmp2_ = _tmp1_;
#line 174 "../src/client/application/geary-config.vala"
	_tmp3_ = g_strcmp0 (_tmp2_, "12h") == 0;
#line 174 "../src/client/application/geary-config.vala"
	_g_free0 (_tmp2_);
#line 174 "../src/client/application/geary-config.vala"
	if (_tmp3_) {
#line 175 "../src/client/application/geary-config.vala"
		result = UTIL_DATE_CLOCK_FORMAT_TWELVE_HOURS;
#line 175 "../src/client/application/geary-config.vala"
		return result;
#line 1213 "geary-config.c"
	} else {
#line 177 "../src/client/application/geary-config.vala"
		result = UTIL_DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS;
#line 177 "../src/client/application/geary-config.vala"
		return result;
#line 1219 "geary-config.c"
	}
}

gboolean
configuration_get_ask_open_attachment (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 182 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 182 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 182 "../src/client/application/geary-config.vala"
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY);
#line 182 "../src/client/application/geary-config.vala"
	return result;
#line 1236 "geary-config.c"
}

void
configuration_set_ask_open_attachment (Configuration* self,
                                       gboolean value)
{
#line 183 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 183 "../src/client/application/geary-config.vala"
	configuration_set_boolean (self, CONFIGURATION_ASK_OPEN_ATTACHMENT_KEY, value);
#line 1247 "geary-config.c"
}

gboolean
configuration_get_compose_as_html (Configuration* self)
{
	gboolean result;
	GSettings* _tmp0_;
#line 187 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), FALSE);
#line 187 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 187 "../src/client/application/geary-config.vala"
	result = g_settings_get_boolean (_tmp0_, CONFIGURATION_COMPOSE_AS_HTML_KEY);
#line 187 "../src/client/application/geary-config.vala"
	return result;
#line 1263 "geary-config.c"
}

void
configuration_set_compose_as_html (Configuration* self,
                                   gboolean value)
{
#line 188 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 188 "../src/client/application/geary-config.vala"
	configuration_set_boolean (self, CONFIGURATION_COMPOSE_AS_HTML_KEY, value);
#line 1274 "geary-config.c"
}

gdouble
configuration_get_conversation_viewer_zoom (Configuration* self)
{
	gdouble result;
	GSettings* _tmp0_;
#line 192 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), 0.0);
#line 192 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 192 "../src/client/application/geary-config.vala"
	result = g_settings_get_double (_tmp0_, CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY);
#line 192 "../src/client/application/geary-config.vala"
	return result;
#line 1290 "geary-config.c"
}

void
configuration_set_conversation_viewer_zoom (Configuration* self,
                                            gdouble value)
{
	GSettings* _tmp0_;
#line 193 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 193 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 193 "../src/client/application/geary-config.vala"
	g_settings_set_double (_tmp0_, CONFIGURATION_CONVERSATION_VIEWER_ZOOM_KEY, value);
#line 1304 "geary-config.c"
}

static gint
_variant_get2 (GVariant* value)
{
#line 201 "../src/client/application/geary-config.vala"
	return g_variant_get_int32 (value);
#line 1312 "geary-config.c"
}

static gint
_variant_get3 (GVariant* value)
{
#line 201 "../src/client/application/geary-config.vala"
	return g_variant_get_int32 (value);
#line 1320 "geary-config.c"
}

gint*
configuration_get_composer_window_size (Configuration* self,
                                        gint* result_length1)
{
	gint* result;
	gint* size = NULL;
	gint* _tmp0_;
	gint size_length1;
	gint _size_size_;
	GVariant* s = NULL;
	GSettings* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	gint* _tmp14_;
	gint _tmp14__length1;
#line 197 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (IS_CONFIGURATION (self), NULL);
#line 198 "../src/client/application/geary-config.vala"
	_tmp0_ = g_new0 (gint, 2);
#line 198 "../src/client/application/geary-config.vala"
	size = _tmp0_;
#line 198 "../src/client/application/geary-config.vala"
	size_length1 = 2;
#line 198 "../src/client/application/geary-config.vala"
	_size_size_ = size_length1;
#line 199 "../src/client/application/geary-config.vala"
	_tmp1_ = self->priv->_settings;
#line 199 "../src/client/application/geary-config.vala"
	_tmp2_ = g_settings_get_value (_tmp1_, CONFIGURATION_COMPOSER_WINDOW_SIZE_KEY);
#line 199 "../src/client/application/geary-config.vala"
	s = _tmp2_;
#line 200 "../src/client/application/geary-config.vala"
	_tmp3_ = s;
#line 200 "../src/client/application/geary-config.vala"
	if (g_variant_n_children (_tmp3_) == ((gsize) 2)) {
#line 1358 "geary-config.c"
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		gint _tmp7_;
		GVariant* _tmp8_;
		GVariant* _tmp9_;
		GVariant* _tmp10_;
		gint _tmp11_;
		gint* _tmp12_;
#line 201 "../src/client/application/geary-config.vala"
		_tmp4_ = s;
#line 201 "../src/client/application/geary-config.vala"
		_tmp5_ = g_variant_get_child_value (_tmp4_, (gsize) 0);
#line 201 "../src/client/application/geary-config.vala"
		_tmp6_ = _tmp5_;
#line 201 "../src/client/application/geary-config.vala"
		_tmp7_ = _variant_get2 (_tmp6_);
#line 201 "../src/client/application/geary-config.vala"
		_tmp8_ = s;
#line 201 "../src/client/application/geary-config.vala"
		_tmp9_ = g_variant_get_child_value (_tmp8_, (gsize) 1);
#line 201 "../src/client/application/geary-config.vala"
		_tmp10_ = _tmp9_;
#line 201 "../src/client/application/geary-config.vala"
		_tmp11_ = _variant_get3 (_tmp10_);
#line 201 "../src/client/application/geary-config.vala"
		_tmp12_ = g_new0 (gint, 2);
#line 201 "../src/client/application/geary-config.vala"
		_tmp12_[0] = _tmp7_;
#line 201 "../src/client/application/geary-config.vala"
		_tmp12_[1] = _tmp11_;
#line 201 "../src/client/application/geary-config.vala"
		size = (g_free (size), NULL);
#line 201 "../src/client/application/geary-config.vala"
		size = _tmp12_;
#line 201 "../src/client/application/geary-config.vala"
		size_length1 = 2;
#line 201 "../src/client/application/geary-config.vala"
		_size_size_ = size_length1;
#line 201 "../src/client/application/geary-config.vala"
		_g_variant_unref0 (_tmp10_);
#line 201 "../src/client/application/geary-config.vala"
		_g_variant_unref0 (_tmp6_);
#line 1402 "geary-config.c"
	} else {
		gint* _tmp13_;
#line 203 "../src/client/application/geary-config.vala"
		_tmp13_ = g_new0 (gint, 2);
#line 203 "../src/client/application/geary-config.vala"
		_tmp13_[0] = -1;
#line 203 "../src/client/application/geary-config.vala"
		_tmp13_[1] = -1;
#line 203 "../src/client/application/geary-config.vala"
		size = (g_free (size), NULL);
#line 203 "../src/client/application/geary-config.vala"
		size = _tmp13_;
#line 203 "../src/client/application/geary-config.vala"
		size_length1 = 2;
#line 203 "../src/client/application/geary-config.vala"
		_size_size_ = size_length1;
#line 1419 "geary-config.c"
	}
#line 205 "../src/client/application/geary-config.vala"
	_tmp14_ = size;
#line 205 "../src/client/application/geary-config.vala"
	_tmp14__length1 = size_length1;
#line 205 "../src/client/application/geary-config.vala"
	if (result_length1) {
#line 205 "../src/client/application/geary-config.vala"
		*result_length1 = _tmp14__length1;
#line 1429 "geary-config.c"
	}
#line 205 "../src/client/application/geary-config.vala"
	result = _tmp14_;
#line 205 "../src/client/application/geary-config.vala"
	_g_variant_unref0 (s);
#line 205 "../src/client/application/geary-config.vala"
	return result;
#line 1437 "geary-config.c"
}

static GVariant*
_variant_new1 (gint* value,
               gint value_length1)
{
	gint* _tmp1_;
	GVariantBuilder _tmp2_;
	gint _tmp3_;
#line 208 "../src/client/application/geary-config.vala"
	_tmp1_ = value;
#line 208 "../src/client/application/geary-config.vala"
	g_variant_builder_init (&_tmp2_, G_VARIANT_TYPE ("ai"));
#line 208 "../src/client/application/geary-config.vala"
	for (_tmp3_ = 0; _tmp3_ < value_length1; _tmp3_++) {
#line 208 "../src/client/application/geary-config.vala"
		g_variant_builder_add_value (&_tmp2_, g_variant_new_int32 (*_tmp1_));
#line 208 "../src/client/application/geary-config.vala"
		_tmp1_++;
#line 1457 "geary-config.c"
	}
#line 208 "../src/client/application/geary-config.vala"
	return g_variant_ref_sink (g_variant_builder_end (&_tmp2_));
#line 1461 "geary-config.c"
}

void
configuration_set_composer_window_size (Configuration* self,
                                        gint* value,
                                        gint value_length1)
{
	GSettings* _tmp0_;
	GVariant* _tmp4_;
#line 207 "../src/client/application/geary-config.vala"
	g_return_if_fail (IS_CONFIGURATION (self));
#line 208 "../src/client/application/geary-config.vala"
	_tmp0_ = self->priv->_settings;
#line 208 "../src/client/application/geary-config.vala"
	_tmp4_ = _variant_new1 (value, value_length1);
#line 208 "../src/client/application/geary-config.vala"
	g_settings_set_value (_tmp0_, CONFIGURATION_COMPOSER_WINDOW_SIZE_KEY, _tmp4_);
#line 208 "../src/client/application/geary-config.vala"
	_g_variant_unref0 (_tmp4_);
#line 1481 "geary-config.c"
}

static void
value_configuration_init (GValue* value)
{
#line 10 "../src/client/application/geary-config.vala"
	value->data[0].v_pointer = NULL;
#line 1489 "geary-config.c"
}

static void
value_configuration_free_value (GValue* value)
{
#line 10 "../src/client/application/geary-config.vala"
	if (value->data[0].v_pointer) {
#line 10 "../src/client/application/geary-config.vala"
		configuration_unref (value->data[0].v_pointer);
#line 1499 "geary-config.c"
	}
}

static void
value_configuration_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 10 "../src/client/application/geary-config.vala"
	if (src_value->data[0].v_pointer) {
#line 10 "../src/client/application/geary-config.vala"
		dest_value->data[0].v_pointer = configuration_ref (src_value->data[0].v_pointer);
#line 1511 "geary-config.c"
	} else {
#line 10 "../src/client/application/geary-config.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1515 "geary-config.c"
	}
}

static gpointer
value_configuration_peek_pointer (const GValue* value)
{
#line 10 "../src/client/application/geary-config.vala"
	return value->data[0].v_pointer;
#line 1524 "geary-config.c"
}

static gchar*
value_configuration_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 10 "../src/client/application/geary-config.vala"
	if (collect_values[0].v_pointer) {
#line 1535 "geary-config.c"
		Configuration * object;
		object = collect_values[0].v_pointer;
#line 10 "../src/client/application/geary-config.vala"
		if (object->parent_instance.g_class == NULL) {
#line 10 "../src/client/application/geary-config.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1542 "geary-config.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 10 "../src/client/application/geary-config.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1546 "geary-config.c"
		}
#line 10 "../src/client/application/geary-config.vala"
		value->data[0].v_pointer = configuration_ref (object);
#line 1550 "geary-config.c"
	} else {
#line 10 "../src/client/application/geary-config.vala"
		value->data[0].v_pointer = NULL;
#line 1554 "geary-config.c"
	}
#line 10 "../src/client/application/geary-config.vala"
	return NULL;
#line 1558 "geary-config.c"
}

static gchar*
value_configuration_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	Configuration ** object_p;
	object_p = collect_values[0].v_pointer;
#line 10 "../src/client/application/geary-config.vala"
	if (!object_p) {
#line 10 "../src/client/application/geary-config.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1573 "geary-config.c"
	}
#line 10 "../src/client/application/geary-config.vala"
	if (!value->data[0].v_pointer) {
#line 10 "../src/client/application/geary-config.vala"
		*object_p = NULL;
#line 1579 "geary-config.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 10 "../src/client/application/geary-config.vala"
		*object_p = value->data[0].v_pointer;
#line 1583 "geary-config.c"
	} else {
#line 10 "../src/client/application/geary-config.vala"
		*object_p = configuration_ref (value->data[0].v_pointer);
#line 1587 "geary-config.c"
	}
#line 10 "../src/client/application/geary-config.vala"
	return NULL;
#line 1591 "geary-config.c"
}

GParamSpec*
param_spec_configuration (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecConfiguration* spec;
#line 10 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_CONFIGURATION), NULL);
#line 10 "../src/client/application/geary-config.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 10 "../src/client/application/geary-config.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 10 "../src/client/application/geary-config.vala"
	return G_PARAM_SPEC (spec);
#line 1610 "geary-config.c"
}

gpointer
value_get_configuration (const GValue* value)
{
#line 10 "../src/client/application/geary-config.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIGURATION), NULL);
#line 10 "../src/client/application/geary-config.vala"
	return value->data[0].v_pointer;
#line 1620 "geary-config.c"
}

void
value_set_configuration (GValue* value,
                         gpointer v_object)
{
	Configuration * old;
#line 10 "../src/client/application/geary-config.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIGURATION));
#line 10 "../src/client/application/geary-config.vala"
	old = value->data[0].v_pointer;
#line 10 "../src/client/application/geary-config.vala"
	if (v_object) {
#line 10 "../src/client/application/geary-config.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIGURATION));
#line 10 "../src/client/application/geary-config.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 10 "../src/client/application/geary-config.vala"
		value->data[0].v_pointer = v_object;
#line 10 "../src/client/application/geary-config.vala"
		configuration_ref (value->data[0].v_pointer);
#line 1642 "geary-config.c"
	} else {
#line 10 "../src/client/application/geary-config.vala"
		value->data[0].v_pointer = NULL;
#line 1646 "geary-config.c"
	}
#line 10 "../src/client/application/geary-config.vala"
	if (old) {
#line 10 "../src/client/application/geary-config.vala"
		configuration_unref (old);
#line 1652 "geary-config.c"
	}
}

void
value_take_configuration (GValue* value,
                          gpointer v_object)
{
	Configuration * old;
#line 10 "../src/client/application/geary-config.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_CONFIGURATION));
#line 10 "../src/client/application/geary-config.vala"
	old = value->data[0].v_pointer;
#line 10 "../src/client/application/geary-config.vala"
	if (v_object) {
#line 10 "../src/client/application/geary-config.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_CONFIGURATION));
#line 10 "../src/client/application/geary-config.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 10 "../src/client/application/geary-config.vala"
		value->data[0].v_pointer = v_object;
#line 1673 "geary-config.c"
	} else {
#line 10 "../src/client/application/geary-config.vala"
		value->data[0].v_pointer = NULL;
#line 1677 "geary-config.c"
	}
#line 10 "../src/client/application/geary-config.vala"
	if (old) {
#line 10 "../src/client/application/geary-config.vala"
		configuration_unref (old);
#line 1683 "geary-config.c"
	}
}

static void
configuration_class_init (ConfigurationClass * klass,
                          gpointer klass_data)
{
#line 10 "../src/client/application/geary-config.vala"
	configuration_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/client/application/geary-config.vala"
	((ConfigurationClass *) klass)->finalize = configuration_finalize;
#line 10 "../src/client/application/geary-config.vala"
	g_type_class_adjust_private_offset (klass, &Configuration_private_offset);
#line 1697 "geary-config.c"
}

static void
configuration_instance_init (Configuration * self,
                             gpointer klass)
{
#line 10 "../src/client/application/geary-config.vala"
	self->priv = configuration_get_instance_private (self);
#line 56 "../src/client/application/geary-config.vala"
	self->priv->_enable_debug = FALSE;
#line 59 "../src/client/application/geary-config.vala"
	self->priv->_enable_inspector = FALSE;
#line 62 "../src/client/application/geary-config.vala"
	self->priv->_revoke_certs = FALSE;
#line 10 "../src/client/application/geary-config.vala"
	self->ref_count = 1;
#line 1714 "geary-config.c"
}

static void
configuration_finalize (Configuration * obj)
{
	Configuration * self;
#line 10 "../src/client/application/geary-config.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONFIGURATION, Configuration);
#line 10 "../src/client/application/geary-config.vala"
	g_signal_handlers_destroy (self);
#line 52 "../src/client/application/geary-config.vala"
	_g_object_unref0 (self->priv->_settings);
#line 53 "../src/client/application/geary-config.vala"
	_g_object_unref0 (self->priv->_gnome_interface);
#line 1729 "geary-config.c"
}

/**
 * Provides convenience properties to current Geary GSettings values.
 */
GType
configuration_get_type (void)
{
	static volatile gsize configuration_type_id__volatile = 0;
	if (g_once_init_enter (&configuration_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_configuration_init, value_configuration_free_value, value_configuration_copy_value, value_configuration_peek_pointer, "p", value_configuration_collect_value, "p", value_configuration_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ConfigurationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) configuration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Configuration), 0, (GInstanceInitFunc) configuration_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType configuration_type_id;
		configuration_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Configuration", &g_define_type_info, &g_define_type_fundamental_info, 0);
		Configuration_private_offset = g_type_add_instance_private (configuration_type_id, sizeof (ConfigurationPrivate));
		g_once_init_leave (&configuration_type_id__volatile, configuration_type_id);
	}
	return configuration_type_id__volatile;
}

gpointer
configuration_ref (gpointer instance)
{
	Configuration * self;
	self = instance;
#line 10 "../src/client/application/geary-config.vala"
	g_atomic_int_inc (&self->ref_count);
#line 10 "../src/client/application/geary-config.vala"
	return instance;
#line 1760 "geary-config.c"
}

void
configuration_unref (gpointer instance)
{
	Configuration * self;
	self = instance;
#line 10 "../src/client/application/geary-config.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 10 "../src/client/application/geary-config.vala"
		CONFIGURATION_GET_CLASS (self)->finalize (self);
#line 10 "../src/client/application/geary-config.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1774 "geary-config.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

