/* search-bar.c generated by valac 0.46.0, the Vala compiler
 * generated from search-bar.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define TYPE_SEARCH_BAR (search_bar_get_type ())
#define SEARCH_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SEARCH_BAR, SearchBar))
#define SEARCH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SEARCH_BAR, SearchBarClass))
#define IS_SEARCH_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SEARCH_BAR))
#define IS_SEARCH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SEARCH_BAR))
#define SEARCH_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SEARCH_BAR, SearchBarClass))

typedef struct _SearchBar SearchBar;
typedef struct _SearchBarClass SearchBarClass;
typedef struct _SearchBarPrivate SearchBarPrivate;

#define TYPE_MONITORED_PROGRESS_BAR (monitored_progress_bar_get_type ())
#define MONITORED_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORED_PROGRESS_BAR, MonitoredProgressBar))
#define MONITORED_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MONITORED_PROGRESS_BAR, MonitoredProgressBarClass))
#define IS_MONITORED_PROGRESS_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORED_PROGRESS_BAR))
#define IS_MONITORED_PROGRESS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MONITORED_PROGRESS_BAR))
#define MONITORED_PROGRESS_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MONITORED_PROGRESS_BAR, MonitoredProgressBarClass))

typedef struct _MonitoredProgressBar MonitoredProgressBar;
typedef struct _MonitoredProgressBarClass MonitoredProgressBarClass;
enum  {
	SEARCH_BAR_0_PROPERTY,
	SEARCH_BAR_SEARCH_TEXT_PROPERTY,
	SEARCH_BAR_SEARCH_ENTRY_HAS_FOCUS_PROPERTY,
	SEARCH_BAR_NUM_PROPERTIES
};
static GParamSpec* search_bar_properties[SEARCH_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;

#define APPLICATION_TYPE_CONTROLLER (application_controller_get_type ())
#define APPLICATION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationController))
#define APPLICATION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))
#define APPLICATION_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))

typedef struct _ApplicationController ApplicationController;
typedef struct _ApplicationControllerClass ApplicationControllerClass;
enum  {
	SEARCH_BAR_SEARCH_TEXT_CHANGED_SIGNAL,
	SEARCH_BAR_NUM_SIGNALS
};
static guint search_bar_signals[SEARCH_BAR_NUM_SIGNALS] = {0};

struct _SearchBar {
	GtkSearchBar parent_instance;
	SearchBarPrivate * priv;
};

struct _SearchBarClass {
	GtkSearchBarClass parent_class;
};

struct _SearchBarPrivate {
	GtkSearchEntry* search_entry;
	GearyProgressMonitor* search_upgrade_progress_monitor;
	MonitoredProgressBar* search_upgrade_progress_bar;
	GearyAccount* current_account;
};

static gint SearchBar_private_offset;
static gpointer search_bar_parent_class = NULL;

GType search_bar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SearchBar, g_object_unref)
GType monitored_progress_bar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MonitoredProgressBar, g_object_unref)
MonitoredProgressBar* monitored_progress_bar_new (void);
MonitoredProgressBar* monitored_progress_bar_construct (GType object_type);
#define SEARCH_BAR_DEFAULT_SEARCH_TEXT _ ("Search")
SearchBar* search_bar_new (void);
SearchBar* search_bar_construct (GType object_type);
static void __lambda99_ (SearchBar* self);
static void ___lambda99__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                   gpointer self);
static void __lambda100_ (SearchBar* self);
static void ___lambda100__gtk_entry_activate (GtkEntry* _sender,
                                       gpointer self);
void search_bar_set_search_placeholder_text (SearchBar* self,
                                             const gchar* placeholder);
void search_bar_set_search_text (SearchBar* self,
                                 const gchar* text);
void search_bar_give_search_focus (SearchBar* self);
void search_bar_set_account (SearchBar* self,
                             GearyAccount* account);
static void search_bar_on_search_upgrade_finished (SearchBar* self);
static void search_bar_on_search_upgrade_start (SearchBar* self);
static void _search_bar_on_search_upgrade_start_geary_progress_monitor_start (GearyProgressMonitor* _sender,
                                                                       gpointer self);
static void _search_bar_on_search_upgrade_finished_geary_progress_monitor_finish (GearyProgressMonitor* _sender,
                                                                           gpointer self);
static void search_bar_on_information_changed (SearchBar* self);
static void _search_bar_on_information_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                           gpointer self);
void monitored_progress_bar_set_progress_monitor (MonitoredProgressBar* self,
                                                  GearyProgressMonitor* monitor);
GType geary_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyApplication, g_object_unref)
GearyApplication* geary_application_get_instance (void) G_GNUC_DEPRECATED;
GType application_controller_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ApplicationController, g_object_unref)
ApplicationController* geary_application_get_controller (GearyApplication* self);
gint application_controller_get_num_accounts (ApplicationController* self);
const gchar* search_bar_get_search_text (SearchBar* self);
gboolean search_bar_get_search_entry_has_focus (SearchBar* self);
static void search_bar_finalize (GObject * obj);
static void _vala_search_bar_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);

static inline gpointer
search_bar_get_instance_private (SearchBar* self)
{
	return G_STRUCT_MEMBER_P (self, SearchBar_private_offset);
}

static void
__lambda99_ (SearchBar* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 25 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 25 "../src/client/components/search-bar.vala"
	_tmp1_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry));
#line 25 "../src/client/components/search-bar.vala"
	_tmp2_ = _tmp1_;
#line 25 "../src/client/components/search-bar.vala"
	g_signal_emit (self, search_bar_signals[SEARCH_BAR_SEARCH_TEXT_CHANGED_SIGNAL], 0, _tmp2_);
#line 161 "search-bar.c"
}

static void
___lambda99__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                              gpointer self)
{
#line 24 "../src/client/components/search-bar.vala"
	__lambda99_ ((SearchBar*) self);
#line 170 "search-bar.c"
}

static void
__lambda100_ (SearchBar* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 28 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 28 "../src/client/components/search-bar.vala"
	_tmp1_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry));
#line 28 "../src/client/components/search-bar.vala"
	_tmp2_ = _tmp1_;
#line 28 "../src/client/components/search-bar.vala"
	g_signal_emit (self, search_bar_signals[SEARCH_BAR_SEARCH_TEXT_CHANGED_SIGNAL], 0, _tmp2_);
#line 187 "search-bar.c"
}

static void
___lambda100__gtk_entry_activate (GtkEntry* _sender,
                                  gpointer self)
{
#line 27 "../src/client/components/search-bar.vala"
	__lambda100_ ((SearchBar*) self);
#line 196 "search-bar.c"
}

SearchBar*
search_bar_construct (GType object_type)
{
	SearchBar * self = NULL;
	GtkSearchEntry* _tmp0_;
	GtkSearchEntry* _tmp1_;
	GtkSearchEntry* _tmp2_;
	GtkSearchEntry* _tmp3_;
	GtkSearchEntry* _tmp4_;
	MonitoredProgressBar* _tmp5_;
	MonitoredProgressBar* _tmp6_;
	MonitoredProgressBar* _tmp7_;
	MonitoredProgressBar* _tmp8_;
	GtkSearchEntry* _tmp9_;
#line 20 "../src/client/components/search-bar.vala"
	self = (SearchBar*) g_object_new (object_type, NULL);
#line 22 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 22 "../src/client/components/search-bar.vala"
	gtk_entry_set_width_chars (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry), 28);
#line 23 "../src/client/components/search-bar.vala"
	_tmp1_ = self->priv->search_entry;
#line 23 "../src/client/components/search-bar.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), _ ("Search all mail in account for keywords (Ctrl+S)"));
#line 24 "../src/client/components/search-bar.vala"
	_tmp2_ = self->priv->search_entry;
#line 24 "../src/client/components/search-bar.vala"
	g_signal_connect_object (_tmp2_, "search-changed", (GCallback) ___lambda99__gtk_search_entry_search_changed, self, 0);
#line 27 "../src/client/components/search-bar.vala"
	_tmp3_ = self->priv->search_entry;
#line 27 "../src/client/components/search-bar.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_entry_get_type (), GtkEntry), "activate", (GCallback) ___lambda100__gtk_entry_activate, self, 0);
#line 30 "../src/client/components/search-bar.vala"
	_tmp4_ = self->priv->search_entry;
#line 30 "../src/client/components/search-bar.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), "has-focus", TRUE, NULL);
#line 33 "../src/client/components/search-bar.vala"
	_tmp5_ = self->priv->search_upgrade_progress_bar;
#line 33 "../src/client/components/search-bar.vala"
	gtk_progress_bar_set_show_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_progress_bar_get_type (), GtkProgressBar), TRUE);
#line 34 "../src/client/components/search-bar.vala"
	_tmp6_ = self->priv->search_upgrade_progress_bar;
#line 34 "../src/client/components/search-bar.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 35 "../src/client/components/search-bar.vala"
	_tmp7_ = self->priv->search_upgrade_progress_bar;
#line 35 "../src/client/components/search-bar.vala"
	gtk_widget_set_no_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 37 "../src/client/components/search-bar.vala"
	_tmp8_ = self->priv->search_upgrade_progress_bar;
#line 37 "../src/client/components/search-bar.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 38 "../src/client/components/search-bar.vala"
	_tmp9_ = self->priv->search_entry;
#line 38 "../src/client/components/search-bar.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget));
#line 40 "../src/client/components/search-bar.vala"
	search_bar_set_search_placeholder_text (self, SEARCH_BAR_DEFAULT_SEARCH_TEXT);
#line 20 "../src/client/components/search-bar.vala"
	return self;
#line 259 "search-bar.c"
}

SearchBar*
search_bar_new (void)
{
#line 20 "../src/client/components/search-bar.vala"
	return search_bar_construct (TYPE_SEARCH_BAR);
#line 267 "search-bar.c"
}

void
search_bar_set_search_text (SearchBar* self,
                            const gchar* text)
{
	GtkSearchEntry* _tmp0_;
#line 43 "../src/client/components/search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 43 "../src/client/components/search-bar.vala"
	g_return_if_fail (text != NULL);
#line 44 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 44 "../src/client/components/search-bar.vala"
	gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry), text);
#line 283 "search-bar.c"
}

void
search_bar_give_search_focus (SearchBar* self)
{
	GtkSearchEntry* _tmp0_;
#line 47 "../src/client/components/search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 48 "../src/client/components/search-bar.vala"
	gtk_search_bar_set_search_mode (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_search_bar_get_type (), GtkSearchBar), TRUE);
#line 49 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 49 "../src/client/components/search-bar.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 298 "search-bar.c"
}

void
search_bar_set_search_placeholder_text (SearchBar* self,
                                        const gchar* placeholder)
{
	GtkSearchEntry* _tmp0_;
#line 52 "../src/client/components/search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 52 "../src/client/components/search-bar.vala"
	g_return_if_fail (placeholder != NULL);
#line 53 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 53 "../src/client/components/search-bar.vala"
	gtk_entry_set_placeholder_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry), placeholder);
#line 314 "search-bar.c"
}

static void
_search_bar_on_search_upgrade_start_geary_progress_monitor_start (GearyProgressMonitor* _sender,
                                                                  gpointer self)
{
#line 60 "../src/client/components/search-bar.vala"
	search_bar_on_search_upgrade_start ((SearchBar*) self);
#line 323 "search-bar.c"
}

static void
_search_bar_on_search_upgrade_finished_geary_progress_monitor_finish (GearyProgressMonitor* _sender,
                                                                      gpointer self)
{
#line 61 "../src/client/components/search-bar.vala"
	search_bar_on_search_upgrade_finished ((SearchBar*) self);
#line 332 "search-bar.c"
}

static void
_search_bar_on_information_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                      gpointer self)
{
#line 66 "../src/client/components/search-bar.vala"
	search_bar_on_information_changed ((SearchBar*) self);
#line 341 "search-bar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 71 "../src/client/components/search-bar.vala"
	return self ? g_object_ref (self) : NULL;
#line 349 "search-bar.c"
}

void
search_bar_set_account (SearchBar* self,
                        GearyAccount* account)
{
	GearyProgressMonitor* _tmp0_;
	GearyAccount* _tmp5_;
	GearyAccount* _tmp29_;
#line 56 "../src/client/components/search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 56 "../src/client/components/search-bar.vala"
	g_return_if_fail ((account == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT));
#line 57 "../src/client/components/search-bar.vala"
	search_bar_on_search_upgrade_finished (self);
#line 59 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_upgrade_progress_monitor;
#line 59 "../src/client/components/search-bar.vala"
	if (_tmp0_ != NULL) {
#line 369 "search-bar.c"
		GearyProgressMonitor* _tmp1_;
		guint _tmp2_;
		GearyProgressMonitor* _tmp3_;
		guint _tmp4_;
#line 60 "../src/client/components/search-bar.vala"
		_tmp1_ = self->priv->search_upgrade_progress_monitor;
#line 60 "../src/client/components/search-bar.vala"
		g_signal_parse_name ("start", GEARY_TYPE_PROGRESS_MONITOR, &_tmp2_, NULL, FALSE);
#line 60 "../src/client/components/search-bar.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _search_bar_on_search_upgrade_start_geary_progress_monitor_start, self);
#line 61 "../src/client/components/search-bar.vala"
		_tmp3_ = self->priv->search_upgrade_progress_monitor;
#line 61 "../src/client/components/search-bar.vala"
		g_signal_parse_name ("finish", GEARY_TYPE_PROGRESS_MONITOR, &_tmp4_, NULL, FALSE);
#line 61 "../src/client/components/search-bar.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _search_bar_on_search_upgrade_finished_geary_progress_monitor_finish, self);
#line 62 "../src/client/components/search-bar.vala"
		_g_object_unref0 (self->priv->search_upgrade_progress_monitor);
#line 62 "../src/client/components/search-bar.vala"
		self->priv->search_upgrade_progress_monitor = NULL;
#line 390 "search-bar.c"
	}
#line 65 "../src/client/components/search-bar.vala"
	_tmp5_ = self->priv->current_account;
#line 65 "../src/client/components/search-bar.vala"
	if (_tmp5_ != NULL) {
#line 396 "search-bar.c"
		GearyAccount* _tmp6_;
		GearyAccountInformation* _tmp7_;
		GearyAccountInformation* _tmp8_;
		guint _tmp9_;
#line 66 "../src/client/components/search-bar.vala"
		_tmp6_ = self->priv->current_account;
#line 66 "../src/client/components/search-bar.vala"
		_tmp7_ = geary_account_get_information (_tmp6_);
#line 66 "../src/client/components/search-bar.vala"
		_tmp8_ = _tmp7_;
#line 66 "../src/client/components/search-bar.vala"
		g_signal_parse_name ("changed", GEARY_TYPE_ACCOUNT_INFORMATION, &_tmp9_, NULL, FALSE);
#line 66 "../src/client/components/search-bar.vala"
		g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _search_bar_on_information_changed_geary_account_information_changed, self);
#line 411 "search-bar.c"
	}
#line 70 "../src/client/components/search-bar.vala"
	if (account != NULL) {
#line 415 "search-bar.c"
		GearyProgressMonitor* _tmp10_;
		GearyProgressMonitor* _tmp11_;
		GearyProgressMonitor* _tmp12_;
		MonitoredProgressBar* _tmp13_;
		GearyProgressMonitor* _tmp14_;
		GearyProgressMonitor* _tmp15_;
		GearyProgressMonitor* _tmp16_;
		GearyProgressMonitor* _tmp17_;
		gboolean _tmp18_;
		gboolean _tmp19_;
		GearyAccountInformation* _tmp20_;
		GearyAccountInformation* _tmp21_;
		MonitoredProgressBar* _tmp22_;
		GearyAccountInformation* _tmp23_;
		GearyAccountInformation* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
#line 71 "../src/client/components/search-bar.vala"
		_tmp10_ = geary_account_get_search_upgrade_monitor (account);
#line 71 "../src/client/components/search-bar.vala"
		_tmp11_ = _tmp10_;
#line 71 "../src/client/components/search-bar.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 71 "../src/client/components/search-bar.vala"
		_g_object_unref0 (self->priv->search_upgrade_progress_monitor);
#line 71 "../src/client/components/search-bar.vala"
		self->priv->search_upgrade_progress_monitor = _tmp12_;
#line 72 "../src/client/components/search-bar.vala"
		_tmp13_ = self->priv->search_upgrade_progress_bar;
#line 72 "../src/client/components/search-bar.vala"
		_tmp14_ = self->priv->search_upgrade_progress_monitor;
#line 72 "../src/client/components/search-bar.vala"
		monitored_progress_bar_set_progress_monitor (_tmp13_, _tmp14_);
#line 74 "../src/client/components/search-bar.vala"
		_tmp15_ = self->priv->search_upgrade_progress_monitor;
#line 74 "../src/client/components/search-bar.vala"
		g_signal_connect_object (_tmp15_, "start", (GCallback) _search_bar_on_search_upgrade_start_geary_progress_monitor_start, self, 0);
#line 75 "../src/client/components/search-bar.vala"
		_tmp16_ = self->priv->search_upgrade_progress_monitor;
#line 75 "../src/client/components/search-bar.vala"
		g_signal_connect_object (_tmp16_, "finish", (GCallback) _search_bar_on_search_upgrade_finished_geary_progress_monitor_finish, self, 0);
#line 76 "../src/client/components/search-bar.vala"
		_tmp17_ = self->priv->search_upgrade_progress_monitor;
#line 76 "../src/client/components/search-bar.vala"
		_tmp18_ = geary_progress_monitor_get_is_in_progress (_tmp17_);
#line 76 "../src/client/components/search-bar.vala"
		_tmp19_ = _tmp18_;
#line 76 "../src/client/components/search-bar.vala"
		if (_tmp19_) {
#line 77 "../src/client/components/search-bar.vala"
			search_bar_on_search_upgrade_start (self);
#line 469 "search-bar.c"
		}
#line 79 "../src/client/components/search-bar.vala"
		_tmp20_ = geary_account_get_information (account);
#line 79 "../src/client/components/search-bar.vala"
		_tmp21_ = _tmp20_;
#line 79 "../src/client/components/search-bar.vala"
		g_signal_connect_object (_tmp21_, "changed", (GCallback) _search_bar_on_information_changed_geary_account_information_changed, self, 0);
#line 82 "../src/client/components/search-bar.vala"
		_tmp22_ = self->priv->search_upgrade_progress_bar;
#line 82 "../src/client/components/search-bar.vala"
		_tmp23_ = geary_account_get_information (account);
#line 82 "../src/client/components/search-bar.vala"
		_tmp24_ = _tmp23_;
#line 82 "../src/client/components/search-bar.vala"
		_tmp25_ = geary_account_information_get_display_name (_tmp24_);
#line 82 "../src/client/components/search-bar.vala"
		_tmp26_ = _tmp25_;
#line 82 "../src/client/components/search-bar.vala"
		_tmp27_ = g_strdup_printf (_ ("Indexing %s account"), _tmp26_);
#line 82 "../src/client/components/search-bar.vala"
		_tmp28_ = _tmp27_;
#line 82 "../src/client/components/search-bar.vala"
		gtk_progress_bar_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_progress_bar_get_type (), GtkProgressBar), _tmp28_);
#line 82 "../src/client/components/search-bar.vala"
		_g_free0 (_tmp28_);
#line 495 "search-bar.c"
	}
#line 86 "../src/client/components/search-bar.vala"
	_tmp29_ = _g_object_ref0 (account);
#line 86 "../src/client/components/search-bar.vala"
	_g_object_unref0 (self->priv->current_account);
#line 86 "../src/client/components/search-bar.vala"
	self->priv->current_account = _tmp29_;
#line 88 "../src/client/components/search-bar.vala"
	search_bar_on_information_changed (self);
#line 505 "search-bar.c"
}

static void
search_bar_on_search_upgrade_start (SearchBar* self)
{
	gint minimum_width = 0;
	gint natural_width = 0;
	GtkSearchEntry* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	MonitoredProgressBar* _tmp3_;
	GtkSearchEntry* _tmp4_;
	MonitoredProgressBar* _tmp5_;
#line 91 "../src/client/components/search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 93 "../src/client/components/search-bar.vala"
	minimum_width = 0;
#line 94 "../src/client/components/search-bar.vala"
	natural_width = 0;
#line 95 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 95 "../src/client/components/search-bar.vala"
	gtk_widget_get_preferred_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), &_tmp1_, &_tmp2_);
#line 95 "../src/client/components/search-bar.vala"
	minimum_width = _tmp1_;
#line 95 "../src/client/components/search-bar.vala"
	natural_width = _tmp2_;
#line 96 "../src/client/components/search-bar.vala"
	_tmp3_ = self->priv->search_upgrade_progress_bar;
#line 96 "../src/client/components/search-bar.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), "width-request", minimum_width, NULL);
#line 98 "../src/client/components/search-bar.vala"
	_tmp4_ = self->priv->search_entry;
#line 98 "../src/client/components/search-bar.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 99 "../src/client/components/search-bar.vala"
	_tmp5_ = self->priv->search_upgrade_progress_bar;
#line 99 "../src/client/components/search-bar.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget));
#line 545 "search-bar.c"
}

static void
search_bar_on_search_upgrade_finished (SearchBar* self)
{
	GtkSearchEntry* _tmp0_;
	MonitoredProgressBar* _tmp1_;
#line 102 "../src/client/components/search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 103 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 103 "../src/client/components/search-bar.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 104 "../src/client/components/search-bar.vala"
	_tmp1_ = self->priv->search_upgrade_progress_bar;
#line 104 "../src/client/components/search-bar.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 563 "search-bar.c"
}

static void
search_bar_on_information_changed (SearchBar* self)
{
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GearyAccount* _tmp2_;
#line 107 "../src/client/components/search-bar.vala"
	g_return_if_fail (IS_SEARCH_BAR (self));
#line 108 "../src/client/components/search-bar.vala"
	_tmp2_ = self->priv->current_account;
#line 108 "../src/client/components/search-bar.vala"
	if (_tmp2_ == NULL) {
#line 108 "../src/client/components/search-bar.vala"
		_tmp1_ = TRUE;
#line 580 "search-bar.c"
	} else {
		GearyApplication* _tmp3_;
		GearyApplication* _tmp4_;
		ApplicationController* _tmp5_;
		ApplicationController* _tmp6_;
#line 109 "../src/client/components/search-bar.vala"
		_tmp3_ = geary_application_get_instance ();
#line 109 "../src/client/components/search-bar.vala"
		_tmp4_ = _tmp3_;
#line 109 "../src/client/components/search-bar.vala"
		_tmp5_ = geary_application_get_controller (_tmp4_);
#line 109 "../src/client/components/search-bar.vala"
		_tmp6_ = _tmp5_;
#line 109 "../src/client/components/search-bar.vala"
		_tmp1_ = application_controller_get_num_accounts (_tmp6_) == 1;
#line 596 "search-bar.c"
	}
#line 108 "../src/client/components/search-bar.vala"
	if (_tmp1_) {
#line 600 "search-bar.c"
		gchar* _tmp7_;
#line 109 "../src/client/components/search-bar.vala"
		_tmp7_ = g_strdup (SEARCH_BAR_DEFAULT_SEARCH_TEXT);
#line 109 "../src/client/components/search-bar.vala"
		_g_free0 (_tmp0_);
#line 109 "../src/client/components/search-bar.vala"
		_tmp0_ = _tmp7_;
#line 608 "search-bar.c"
	} else {
		GearyAccount* _tmp8_;
		GearyAccountInformation* _tmp9_;
		GearyAccountInformation* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 110 "../src/client/components/search-bar.vala"
		_tmp8_ = self->priv->current_account;
#line 110 "../src/client/components/search-bar.vala"
		_tmp9_ = geary_account_get_information (_tmp8_);
#line 110 "../src/client/components/search-bar.vala"
		_tmp10_ = _tmp9_;
#line 110 "../src/client/components/search-bar.vala"
		_tmp11_ = geary_account_information_get_display_name (_tmp10_);
#line 110 "../src/client/components/search-bar.vala"
		_tmp12_ = _tmp11_;
#line 110 "../src/client/components/search-bar.vala"
		_tmp13_ = g_strdup_printf (_ ("Search %s account"), _tmp12_);
#line 110 "../src/client/components/search-bar.vala"
		_g_free0 (_tmp0_);
#line 110 "../src/client/components/search-bar.vala"
		_tmp0_ = _tmp13_;
#line 632 "search-bar.c"
	}
#line 108 "../src/client/components/search-bar.vala"
	search_bar_set_search_placeholder_text (self, _tmp0_);
#line 107 "../src/client/components/search-bar.vala"
	_g_free0 (_tmp0_);
#line 638 "search-bar.c"
}

const gchar*
search_bar_get_search_text (SearchBar* self)
{
	const gchar* result;
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 10 "../src/client/components/search-bar.vala"
	g_return_val_if_fail (IS_SEARCH_BAR (self), NULL);
#line 10 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 10 "../src/client/components/search-bar.vala"
	_tmp1_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_entry_get_type (), GtkEntry));
#line 10 "../src/client/components/search-bar.vala"
	_tmp2_ = _tmp1_;
#line 10 "../src/client/components/search-bar.vala"
	result = _tmp2_;
#line 10 "../src/client/components/search-bar.vala"
	return result;
#line 660 "search-bar.c"
}

gboolean
search_bar_get_search_entry_has_focus (SearchBar* self)
{
	gboolean result;
	GtkSearchEntry* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 11 "../src/client/components/search-bar.vala"
	g_return_val_if_fail (IS_SEARCH_BAR (self), FALSE);
#line 11 "../src/client/components/search-bar.vala"
	_tmp0_ = self->priv->search_entry;
#line 11 "../src/client/components/search-bar.vala"
	g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), "has-focus", &_tmp1_, NULL);
#line 11 "../src/client/components/search-bar.vala"
	_tmp2_ = _tmp1_;
#line 11 "../src/client/components/search-bar.vala"
	result = _tmp2_;
#line 11 "../src/client/components/search-bar.vala"
	return result;
#line 682 "search-bar.c"
}

static void
search_bar_class_init (SearchBarClass * klass,
                       gpointer klass_data)
{
#line 7 "../src/client/components/search-bar.vala"
	search_bar_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/client/components/search-bar.vala"
	g_type_class_adjust_private_offset (klass, &SearchBar_private_offset);
#line 7 "../src/client/components/search-bar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_search_bar_get_property;
#line 7 "../src/client/components/search-bar.vala"
	G_OBJECT_CLASS (klass)->finalize = search_bar_finalize;
#line 7 "../src/client/components/search-bar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEARCH_BAR_SEARCH_TEXT_PROPERTY, search_bar_properties[SEARCH_BAR_SEARCH_TEXT_PROPERTY] = g_param_spec_string ("search-text", "search-text", "search-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7 "../src/client/components/search-bar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEARCH_BAR_SEARCH_ENTRY_HAS_FOCUS_PROPERTY, search_bar_properties[SEARCH_BAR_SEARCH_ENTRY_HAS_FOCUS_PROPERTY] = g_param_spec_boolean ("search-entry-has-focus", "search-entry-has-focus", "search-entry-has-focus", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7 "../src/client/components/search-bar.vala"
	search_bar_signals[SEARCH_BAR_SEARCH_TEXT_CHANGED_SIGNAL] = g_signal_new ("search-text-changed", TYPE_SEARCH_BAR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 703 "search-bar.c"
}

static void
search_bar_instance_init (SearchBar * self,
                          gpointer klass)
{
	GtkSearchEntry* _tmp0_;
	MonitoredProgressBar* _tmp1_;
#line 7 "../src/client/components/search-bar.vala"
	self->priv = search_bar_get_instance_private (self);
#line 13 "../src/client/components/search-bar.vala"
	_tmp0_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 13 "../src/client/components/search-bar.vala"
	g_object_ref_sink (_tmp0_);
#line 13 "../src/client/components/search-bar.vala"
	self->priv->search_entry = _tmp0_;
#line 14 "../src/client/components/search-bar.vala"
	self->priv->search_upgrade_progress_monitor = NULL;
#line 15 "../src/client/components/search-bar.vala"
	_tmp1_ = monitored_progress_bar_new ();
#line 15 "../src/client/components/search-bar.vala"
	g_object_ref_sink (_tmp1_);
#line 15 "../src/client/components/search-bar.vala"
	self->priv->search_upgrade_progress_bar = _tmp1_;
#line 16 "../src/client/components/search-bar.vala"
	self->priv->current_account = NULL;
#line 730 "search-bar.c"
}

static void
search_bar_finalize (GObject * obj)
{
	SearchBar * self;
#line 7 "../src/client/components/search-bar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SEARCH_BAR, SearchBar);
#line 13 "../src/client/components/search-bar.vala"
	_g_object_unref0 (self->priv->search_entry);
#line 14 "../src/client/components/search-bar.vala"
	_g_object_unref0 (self->priv->search_upgrade_progress_monitor);
#line 15 "../src/client/components/search-bar.vala"
	_g_object_unref0 (self->priv->search_upgrade_progress_bar);
#line 16 "../src/client/components/search-bar.vala"
	_g_object_unref0 (self->priv->current_account);
#line 7 "../src/client/components/search-bar.vala"
	G_OBJECT_CLASS (search_bar_parent_class)->finalize (obj);
#line 749 "search-bar.c"
}

GType
search_bar_get_type (void)
{
	static volatile gsize search_bar_type_id__volatile = 0;
	if (g_once_init_enter (&search_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SearchBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) search_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SearchBar), 0, (GInstanceInitFunc) search_bar_instance_init, NULL };
		GType search_bar_type_id;
		search_bar_type_id = g_type_register_static (gtk_search_bar_get_type (), "SearchBar", &g_define_type_info, 0);
		SearchBar_private_offset = g_type_add_instance_private (search_bar_type_id, sizeof (SearchBarPrivate));
		g_once_init_leave (&search_bar_type_id__volatile, search_bar_type_id);
	}
	return search_bar_type_id__volatile;
}

static void
_vala_search_bar_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	SearchBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SEARCH_BAR, SearchBar);
#line 7 "../src/client/components/search-bar.vala"
	switch (property_id) {
#line 7 "../src/client/components/search-bar.vala"
		case SEARCH_BAR_SEARCH_TEXT_PROPERTY:
#line 7 "../src/client/components/search-bar.vala"
		g_value_set_string (value, search_bar_get_search_text (self));
#line 7 "../src/client/components/search-bar.vala"
		break;
#line 7 "../src/client/components/search-bar.vala"
		case SEARCH_BAR_SEARCH_ENTRY_HAS_FOCUS_PROPERTY:
#line 7 "../src/client/components/search-bar.vala"
		g_value_set_boolean (value, search_bar_get_search_entry_has_focus (self));
#line 7 "../src/client/components/search-bar.vala"
		break;
#line 788 "search-bar.c"
		default:
#line 7 "../src/client/components/search-bar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/client/components/search-bar.vala"
		break;
#line 794 "search-bar.c"
	}
}

