/* new-messages-monitor.c generated by valac 0.46.0, the Vala compiler
 * generated from new-messages-monitor.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* NewMessagesMonitor is a central data store for new message information that the various*/
/* notification methods (GLibNotification, libunity, etc.) can monitor to do their thing.*/
/* Subclasses should trap the "notify::count" signal and use that to perform whatever magic*/
/* they need for their implementation, or trap "new-messages" to receive notifications of the emails*/
/* themselves as they're added.  In the latter case, subscribers should add required Email.Field*/
/* flags to the object with add_required_fields().*/

#include "geary-engine.h"
#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <gio/gio.h>

#define TYPE_NEW_MESSAGES_MONITOR (new_messages_monitor_get_type ())
#define NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor))
#define NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))
#define IS_NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_MESSAGES_MONITOR))
#define IS_NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_MESSAGES_MONITOR))
#define NEW_MESSAGES_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))

typedef struct _NewMessagesMonitor NewMessagesMonitor;
typedef struct _NewMessagesMonitorClass NewMessagesMonitorClass;
typedef struct _NewMessagesMonitorPrivate NewMessagesMonitorPrivate;

#define APPLICATION_TYPE_AVATAR_STORE (application_avatar_store_get_type ())
#define APPLICATION_AVATAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_AVATAR_STORE, ApplicationAvatarStore))
#define APPLICATION_AVATAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_AVATAR_STORE, ApplicationAvatarStoreClass))
#define APPLICATION_IS_AVATAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_AVATAR_STORE))
#define APPLICATION_IS_AVATAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_AVATAR_STORE))
#define APPLICATION_AVATAR_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_AVATAR_STORE, ApplicationAvatarStoreClass))

typedef struct _ApplicationAvatarStore ApplicationAvatarStore;
typedef struct _ApplicationAvatarStoreClass ApplicationAvatarStoreClass;

#define NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION (new_messages_monitor_monitor_information_get_type ())
#define NEW_MESSAGES_MONITOR_MONITOR_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformation))
#define NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformationClass))
#define NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION))
#define NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION))
#define NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformationClass))

typedef struct _NewMessagesMonitorMonitorInformation NewMessagesMonitorMonitorInformation;
typedef struct _NewMessagesMonitorMonitorInformationClass NewMessagesMonitorMonitorInformationClass;

#define APPLICATION_TYPE_CONTACT_STORE (application_contact_store_get_type ())
#define APPLICATION_CONTACT_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_CONTACT_STORE, ApplicationContactStore))
#define APPLICATION_CONTACT_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_CONTACT_STORE, ApplicationContactStoreClass))
#define APPLICATION_IS_CONTACT_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_CONTACT_STORE))
#define APPLICATION_IS_CONTACT_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_CONTACT_STORE))
#define APPLICATION_CONTACT_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_CONTACT_STORE, ApplicationContactStoreClass))

typedef struct _ApplicationContactStore ApplicationContactStore;
typedef struct _ApplicationContactStoreClass ApplicationContactStoreClass;
typedef ApplicationContactStore* (*NewMessagesMonitorGetContactStore) (GearyAccount* account, gpointer user_data);
typedef gboolean (*NewMessagesMonitorShouldNotifyNewMessages) (GearyFolder* folder, gpointer user_data);
enum  {
	NEW_MESSAGES_MONITOR_0_PROPERTY,
	NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY,
	NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY,
	NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY,
	NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY,
	NEW_MESSAGES_MONITOR_AVATARS_PROPERTY,
	NEW_MESSAGES_MONITOR_NUM_PROPERTIES
};
static GParamSpec* new_messages_monitor_properties[NEW_MESSAGES_MONITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _NewMessagesMonitorMonitorInformationPrivate NewMessagesMonitorMonitorInformationPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NewMessagesMonitorDoProcessNewEmailData NewMessagesMonitorDoProcessNewEmailData;
enum  {
	NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_0_PROPERTY,
	NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_NUM_PROPERTIES
};
static GParamSpec* new_messages_monitor_monitor_information_properties[NEW_MESSAGES_MONITOR_MONITOR_INFORMATION_NUM_PROPERTIES];
enum  {
	NEW_MESSAGES_MONITOR_FOLDER_ADDED_SIGNAL,
	NEW_MESSAGES_MONITOR_FOLDER_REMOVED_SIGNAL,
	NEW_MESSAGES_MONITOR_NEW_MESSAGES_ARRIVED_SIGNAL,
	NEW_MESSAGES_MONITOR_NEW_MESSAGES_RETIRED_SIGNAL,
	NEW_MESSAGES_MONITOR_NUM_SIGNALS
};
static guint new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NewMessagesMonitor {
	GearyBaseObject parent_instance;
	NewMessagesMonitorPrivate * priv;
};

struct _NewMessagesMonitorClass {
	GearyBaseObjectClass parent_class;
};

struct _NewMessagesMonitorPrivate {
	GearyEmailField _required_fields;
	gint _total_new_messages;
	GearyFolder* _last_new_message_folder;
	GearyEmail* _last_new_message;
	ApplicationAvatarStore* _avatars;
	GeeMap* folder_information;
	NewMessagesMonitorGetContactStore contact_store_delegate;
	gpointer contact_store_delegate_target;
	NewMessagesMonitorShouldNotifyNewMessages notify_delegate;
	gpointer notify_delegate_target;
};

struct _NewMessagesMonitorMonitorInformation {
	GearyBaseObject parent_instance;
	NewMessagesMonitorMonitorInformationPrivate * priv;
	GearyFolder* folder;
	GCancellable* cancellable;
	gint count;
	GeeHashSet* new_ids;
};

struct _NewMessagesMonitorMonitorInformationClass {
	GearyBaseObjectClass parent_class;
};

struct _NewMessagesMonitorDoProcessNewEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	NewMessagesMonitor* self;
	GearyFolder* folder;
	GeeCollection* email_ids;
	NewMessagesMonitorMonitorInformation* info;
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	GeeList* list;
	GearyEmailField _tmp2_;
	NewMessagesMonitorMonitorInformation* _tmp3_;
	GCancellable* _tmp4_;
	GeeList* _tmp5_;
	gboolean _tmp6_;
	GeeList* _tmp7_;
	GeeList* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	NewMessagesMonitorMonitorInformation* _tmp13_;
	GeeList* _tmp14_;
	GeeList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	NewMessagesMonitorMonitorInformation* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GError* err;
	GError* _tmp21_;
	const gchar* _tmp22_;
	GError* _inner_error0_;
};

static gint NewMessagesMonitor_private_offset;
static gpointer new_messages_monitor_parent_class = NULL;
static gpointer new_messages_monitor_monitor_information_parent_class = NULL;

GType new_messages_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewMessagesMonitor, g_object_unref)
GType application_avatar_store_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ApplicationAvatarStore, g_object_unref)
static GType new_messages_monitor_monitor_information_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewMessagesMonitorMonitorInformation, g_object_unref)
GType application_contact_store_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ApplicationContactStore, g_object_unref)
NewMessagesMonitor* new_messages_monitor_new (ApplicationAvatarStore* avatars,
                                              NewMessagesMonitorGetContactStore contact_store_delegate,
                                              gpointer contact_store_delegate_target,
                                              NewMessagesMonitorShouldNotifyNewMessages notify_delegate,
                                              gpointer notify_delegate_target);
NewMessagesMonitor* new_messages_monitor_construct (GType object_type,
                                                    ApplicationAvatarStore* avatars,
                                                    NewMessagesMonitorGetContactStore contact_store_delegate,
                                                    gpointer contact_store_delegate_target,
                                                    NewMessagesMonitorShouldNotifyNewMessages notify_delegate,
                                                    gpointer notify_delegate_target);
static void new_messages_monitor_set_avatars (NewMessagesMonitor* self,
                                       ApplicationAvatarStore* value);
gboolean new_messages_monitor_should_notify_new_messages (NewMessagesMonitor* self,
                                                          GearyFolder* folder);
ApplicationContactStore* new_messages_monitor_get_contact_store (NewMessagesMonitor* self,
                                                                 GearyAccount* account);
void new_messages_monitor_add_folder (NewMessagesMonitor* self,
                                      GearyFolder* folder,
                                      GCancellable* cancellable);
static void new_messages_monitor_on_email_locally_appended (NewMessagesMonitor* self,
                                                     GearyFolder* folder,
                                                     GeeCollection* email_ids);
static void _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended (GearyFolder* _sender,
                                                                                          GeeCollection* ids,
                                                                                          gpointer self);
static void new_messages_monitor_on_email_flags_changed (NewMessagesMonitor* self,
                                                  GearyFolder* folder,
                                                  GeeMap* ids);
static void _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed (GearyFolder* _sender,
                                                                                    GeeMap* map,
                                                                                    gpointer self);
static void new_messages_monitor_on_email_removed (NewMessagesMonitor* self,
                                            GearyFolder* folder,
                                            GeeCollection* ids);
static void _new_messages_monitor_on_email_removed_geary_folder_email_removed (GearyFolder* _sender,
                                                                        GeeCollection* ids,
                                                                        gpointer self);
static NewMessagesMonitorMonitorInformation* new_messages_monitor_monitor_information_new (GearyFolder* folder,
                                                                                    GCancellable* cancellable);
static NewMessagesMonitorMonitorInformation* new_messages_monitor_monitor_information_construct (GType object_type,
                                                                                          GearyFolder* folder,
                                                                                          GCancellable* cancellable);
void new_messages_monitor_remove_folder (NewMessagesMonitor* self,
                                         GearyFolder* folder);
gint new_messages_monitor_get_total_new_messages (NewMessagesMonitor* self);
static void new_messages_monitor_set_total_new_messages (NewMessagesMonitor* self,
                                                  gint value);
void new_messages_monitor_clear_folders (NewMessagesMonitor* self);
GeeCollection* new_messages_monitor_get_folders (NewMessagesMonitor* self);
gint new_messages_monitor_get_new_message_count (NewMessagesMonitor* self,
                                                 GearyFolder* folder);
void new_messages_monitor_add_required_fields (NewMessagesMonitor* self,
                                               GearyEmailField fields);
GearyEmailField new_messages_monitor_get_required_fields (NewMessagesMonitor* self);
static void new_messages_monitor_set_required_fields (NewMessagesMonitor* self,
                                               GearyEmailField value);
gboolean new_messages_monitor_are_any_new_messages (NewMessagesMonitor* self,
                                                    GearyFolder* folder,
                                                    GeeCollection* ids);
static void new_messages_monitor_do_process_new_email (NewMessagesMonitor* self,
                                                GearyFolder* folder,
                                                GeeCollection* email_ids,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void new_messages_monitor_do_process_new_email_finish (NewMessagesMonitor* self,
                                                       GAsyncResult* _res_);
static void new_messages_monitor_retire_new_messages (NewMessagesMonitor* self,
                                               GearyFolder* folder,
                                               GeeCollection* email_ids);
static void new_messages_monitor_do_process_new_email_data_free (gpointer _data);
static gboolean new_messages_monitor_do_process_new_email_co (NewMessagesMonitorDoProcessNewEmailData* _data_);
static void new_messages_monitor_do_process_new_email_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void new_messages_monitor_new_messages (NewMessagesMonitor* self,
                                        NewMessagesMonitorMonitorInformation* info,
                                        GeeCollection* emails);
static void new_messages_monitor_set_last_new_message_folder (NewMessagesMonitor* self,
                                                       GearyFolder* value);
static void new_messages_monitor_set_last_new_message (NewMessagesMonitor* self,
                                                GearyEmail* value);
static void new_messages_monitor_update_count (NewMessagesMonitor* self,
                                        NewMessagesMonitorMonitorInformation* info,
                                        gboolean arrived,
                                        gint delta);
GearyEmail* new_messages_monitor_get_last_new_message (NewMessagesMonitor* self);
void new_messages_monitor_clear_new_messages (NewMessagesMonitor* self,
                                              GearyFolder* folder);
void new_messages_monitor_clear_all_new_messages (NewMessagesMonitor* self);
GearyFolder* new_messages_monitor_get_last_new_message_folder (NewMessagesMonitor* self);
ApplicationAvatarStore* new_messages_monitor_get_avatars (NewMessagesMonitor* self);
static void g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void new_messages_monitor_monitor_information_finalize (GObject * obj);
static void new_messages_monitor_finalize (GObject * obj);
static void _vala_new_messages_monitor_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_new_messages_monitor_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
new_messages_monitor_get_instance_private (NewMessagesMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, NewMessagesMonitor_private_offset);
}

NewMessagesMonitor*
new_messages_monitor_construct (GType object_type,
                                ApplicationAvatarStore* avatars,
                                NewMessagesMonitorGetContactStore contact_store_delegate,
                                gpointer contact_store_delegate_target,
                                NewMessagesMonitorShouldNotifyNewMessages notify_delegate,
                                gpointer notify_delegate_target)
{
	NewMessagesMonitor * self = NULL;
#line 70 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (APPLICATION_IS_AVATAR_STORE (avatars), NULL);
#line 70 "../src/client/notification/new-messages-monitor.vala"
	self = (NewMessagesMonitor*) geary_base_object_construct (object_type);
#line 73 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_avatars (self, avatars);
#line 74 "../src/client/notification/new-messages-monitor.vala"
	self->priv->contact_store_delegate = contact_store_delegate;
#line 74 "../src/client/notification/new-messages-monitor.vala"
	self->priv->contact_store_delegate_target = contact_store_delegate_target;
#line 75 "../src/client/notification/new-messages-monitor.vala"
	self->priv->notify_delegate = notify_delegate;
#line 75 "../src/client/notification/new-messages-monitor.vala"
	self->priv->notify_delegate_target = notify_delegate_target;
#line 70 "../src/client/notification/new-messages-monitor.vala"
	return self;
#line 334 "new-messages-monitor.c"
}

NewMessagesMonitor*
new_messages_monitor_new (ApplicationAvatarStore* avatars,
                          NewMessagesMonitorGetContactStore contact_store_delegate,
                          gpointer contact_store_delegate_target,
                          NewMessagesMonitorShouldNotifyNewMessages notify_delegate,
                          gpointer notify_delegate_target)
{
#line 70 "../src/client/notification/new-messages-monitor.vala"
	return new_messages_monitor_construct (TYPE_NEW_MESSAGES_MONITOR, avatars, contact_store_delegate, contact_store_delegate_target, notify_delegate, notify_delegate_target);
#line 346 "new-messages-monitor.c"
}

/** Determines if notifications should be made for a specific folder. */
gboolean
new_messages_monitor_should_notify_new_messages (NewMessagesMonitor* self,
                                                 GearyFolder* folder)
{
	NewMessagesMonitorShouldNotifyNewMessages _tmp0_;
	gpointer _tmp0__target;
	gboolean result = FALSE;
#line 79 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), FALSE);
#line 79 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER), FALSE);
#line 80 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->notify_delegate;
#line 80 "../src/client/notification/new-messages-monitor.vala"
	_tmp0__target = self->priv->notify_delegate_target;
#line 80 "../src/client/notification/new-messages-monitor.vala"
	result = _tmp0_ (folder, _tmp0__target);
#line 80 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 369 "new-messages-monitor.c"
}

/** Returns a contact store to lookup contacts for notifications. */
ApplicationContactStore*
new_messages_monitor_get_contact_store (NewMessagesMonitor* self,
                                        GearyAccount* account)
{
	NewMessagesMonitorGetContactStore _tmp0_;
	gpointer _tmp0__target;
	ApplicationContactStore* _tmp1_;
	ApplicationContactStore* result = NULL;
#line 84 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 84 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT), NULL);
#line 85 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->contact_store_delegate;
#line 85 "../src/client/notification/new-messages-monitor.vala"
	_tmp0__target = self->priv->contact_store_delegate_target;
#line 85 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _tmp0_ (account, _tmp0__target);
#line 85 "../src/client/notification/new-messages-monitor.vala"
	result = _tmp1_;
#line 85 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 395 "new-messages-monitor.c"
}

static void
_new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended (GearyFolder* _sender,
                                                                                     GeeCollection* ids,
                                                                                     gpointer self)
{
#line 91 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_locally_appended ((NewMessagesMonitor*) self, _sender, ids);
#line 405 "new-messages-monitor.c"
}

static void
_new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed (GearyFolder* _sender,
                                                                               GeeMap* map,
                                                                               gpointer self)
{
#line 92 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_flags_changed ((NewMessagesMonitor*) self, _sender, map);
#line 415 "new-messages-monitor.c"
}

static void
_new_messages_monitor_on_email_removed_geary_folder_email_removed (GearyFolder* _sender,
                                                                   GeeCollection* ids,
                                                                   gpointer self)
{
#line 93 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_on_email_removed ((NewMessagesMonitor*) self, _sender, ids);
#line 425 "new-messages-monitor.c"
}

void
new_messages_monitor_add_folder (NewMessagesMonitor* self,
                                 GearyFolder* folder,
                                 GCancellable* cancellable)
{
	GeeMap* _tmp0_;
	GeeMap* _tmp1_;
	NewMessagesMonitorMonitorInformation* _tmp2_;
	NewMessagesMonitorMonitorInformation* _tmp3_;
#line 88 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 88 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 88 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 89 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 89 "../src/client/notification/new-messages-monitor.vala"
	_vala_assert (!gee_map_has_key (_tmp0_, folder), "!folder_information.has_key(folder)");
#line 91 "../src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (folder, "email-locally-appended", (GCallback) _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended, self, 0);
#line 92 "../src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (folder, "email-flags-changed", (GCallback) _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed, self, 0);
#line 93 "../src/client/notification/new-messages-monitor.vala"
	g_signal_connect_object (folder, "email-removed", (GCallback) _new_messages_monitor_on_email_removed_geary_folder_email_removed, self, 0);
#line 95 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->folder_information;
#line 95 "../src/client/notification/new-messages-monitor.vala"
	_tmp2_ = new_messages_monitor_monitor_information_new (folder, cancellable);
#line 95 "../src/client/notification/new-messages-monitor.vala"
	_tmp3_ = _tmp2_;
#line 95 "../src/client/notification/new-messages-monitor.vala"
	gee_map_set (_tmp1_, folder, _tmp3_);
#line 95 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp3_);
#line 97 "../src/client/notification/new-messages-monitor.vala"
	g_signal_emit (self, new_messages_monitor_signals[NEW_MESSAGES_MONITOR_FOLDER_ADDED_SIGNAL], 0, folder);
#line 465 "new-messages-monitor.c"
}

void
new_messages_monitor_remove_folder (NewMessagesMonitor* self,
                                    GearyFolder* folder)
{
	GeeMap* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gint _tmp4_;
	GeeMap* _tmp5_;
	gpointer _tmp6_;
	NewMessagesMonitorMonitorInformation* _tmp7_;
	GeeMap* _tmp8_;
#line 100 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 100 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 101 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 101 "../src/client/notification/new-messages-monitor.vala"
	if (!gee_map_has_key (_tmp0_, folder)) {
#line 102 "../src/client/notification/new-messages-monitor.vala"
		return;
#line 491 "new-messages-monitor.c"
	}
#line 104 "../src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-locally-appended", GEARY_TYPE_FOLDER, &_tmp1_, NULL, FALSE);
#line 104 "../src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (folder, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _new_messages_monitor_on_email_locally_appended_geary_folder_email_locally_appended, self);
#line 105 "../src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-flags-changed", GEARY_TYPE_FOLDER, &_tmp2_, NULL, FALSE);
#line 105 "../src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (folder, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _new_messages_monitor_on_email_flags_changed_geary_folder_email_flags_changed, self);
#line 106 "../src/client/notification/new-messages-monitor.vala"
	g_signal_parse_name ("email-removed", GEARY_TYPE_FOLDER, &_tmp3_, NULL, FALSE);
#line 106 "../src/client/notification/new-messages-monitor.vala"
	g_signal_handlers_disconnect_matched (folder, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _new_messages_monitor_on_email_removed_geary_folder_email_removed, self);
#line 108 "../src/client/notification/new-messages-monitor.vala"
	_tmp4_ = self->priv->_total_new_messages;
#line 108 "../src/client/notification/new-messages-monitor.vala"
	_tmp5_ = self->priv->folder_information;
#line 108 "../src/client/notification/new-messages-monitor.vala"
	_tmp6_ = gee_map_get (_tmp5_, folder);
#line 108 "../src/client/notification/new-messages-monitor.vala"
	_tmp7_ = (NewMessagesMonitorMonitorInformation*) _tmp6_;
#line 108 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_total_new_messages (self, _tmp4_ - _tmp7_->count);
#line 108 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp7_);
#line 110 "../src/client/notification/new-messages-monitor.vala"
	_tmp8_ = self->priv->folder_information;
#line 110 "../src/client/notification/new-messages-monitor.vala"
	gee_map_unset (_tmp8_, folder, NULL);
#line 112 "../src/client/notification/new-messages-monitor.vala"
	g_signal_emit (self, new_messages_monitor_signals[NEW_MESSAGES_MONITOR_FOLDER_REMOVED_SIGNAL], 0, folder);
#line 523 "new-messages-monitor.c"
}

/** Releases all monitored folders. */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 118 "../src/client/notification/new-messages-monitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 532 "new-messages-monitor.c"
}

void
new_messages_monitor_clear_folders (NewMessagesMonitor* self)
{
	GeeMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	gint _tmp4_ = 0;
	gpointer* _tmp5_;
	GearyFolder** _tmp6_;
	gint _tmp6__length1;
#line 116 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 118 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 118 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = gee_map_get_keys (_tmp0_);
#line 118 "../src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _tmp1_;
#line 118 "../src/client/notification/new-messages-monitor.vala"
	_tmp3_ = _tmp2_;
#line 118 "../src/client/notification/new-messages-monitor.vala"
	_tmp5_ = gee_collection_to_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection), &_tmp4_);
#line 118 "../src/client/notification/new-messages-monitor.vala"
	_tmp6_ = _tmp5_;
#line 118 "../src/client/notification/new-messages-monitor.vala"
	_tmp6__length1 = _tmp4_;
#line 118 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp3_);
#line 564 "new-messages-monitor.c"
	{
		GearyFolder** monitored_collection = NULL;
		gint monitored_collection_length1 = 0;
		gint _monitored_collection_size_ = 0;
		gint monitored_it = 0;
#line 118 "../src/client/notification/new-messages-monitor.vala"
		monitored_collection = _tmp6_;
#line 118 "../src/client/notification/new-messages-monitor.vala"
		monitored_collection_length1 = _tmp6__length1;
#line 118 "../src/client/notification/new-messages-monitor.vala"
		for (monitored_it = 0; monitored_it < monitored_collection_length1; monitored_it = monitored_it + 1) {
#line 576 "new-messages-monitor.c"
			GearyFolder* _tmp7_;
			GearyFolder* monitored = NULL;
#line 118 "../src/client/notification/new-messages-monitor.vala"
			_tmp7_ = _g_object_ref0 (monitored_collection[monitored_it]);
#line 118 "../src/client/notification/new-messages-monitor.vala"
			monitored = _tmp7_;
#line 583 "new-messages-monitor.c"
			{
				GearyFolder* _tmp8_;
#line 119 "../src/client/notification/new-messages-monitor.vala"
				_tmp8_ = monitored;
#line 119 "../src/client/notification/new-messages-monitor.vala"
				new_messages_monitor_remove_folder (self, _tmp8_);
#line 118 "../src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (monitored);
#line 592 "new-messages-monitor.c"
			}
		}
#line 118 "../src/client/notification/new-messages-monitor.vala"
		monitored_collection = (_vala_array_free (monitored_collection, monitored_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 597 "new-messages-monitor.c"
	}
}

GeeCollection*
new_messages_monitor_get_folders (NewMessagesMonitor* self)
{
	GeeMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeCollection* result = NULL;
#line 123 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 124 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 124 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = gee_map_get_keys (_tmp0_);
#line 124 "../src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _tmp1_;
#line 124 "../src/client/notification/new-messages-monitor.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection);
#line 124 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 620 "new-messages-monitor.c"
}

gint
new_messages_monitor_get_new_message_count (NewMessagesMonitor* self,
                                            GearyFolder* folder)
{
	GeeMap* _tmp0_;
	GeeMap* _tmp1_;
	gpointer _tmp2_;
	NewMessagesMonitorMonitorInformation* _tmp3_;
	gint _tmp4_;
	gint result = 0;
#line 127 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 127 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER), 0);
#line 128 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 128 "../src/client/notification/new-messages-monitor.vala"
	_vala_assert (gee_map_has_key (_tmp0_, folder), "folder_information.has_key(folder)");
#line 130 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->folder_information;
#line 130 "../src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_map_get (_tmp1_, folder);
#line 130 "../src/client/notification/new-messages-monitor.vala"
	_tmp3_ = (NewMessagesMonitorMonitorInformation*) _tmp2_;
#line 130 "../src/client/notification/new-messages-monitor.vala"
	_tmp4_ = _tmp3_->count;
#line 130 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp3_);
#line 130 "../src/client/notification/new-messages-monitor.vala"
	result = _tmp4_;
#line 130 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 655 "new-messages-monitor.c"
}

void
new_messages_monitor_add_required_fields (NewMessagesMonitor* self,
                                          GearyEmailField fields)
{
	GearyEmailField _tmp0_;
#line 133 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 134 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_required_fields;
#line 134 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_required_fields (self, _tmp0_ | fields);
#line 669 "new-messages-monitor.c"
}

gboolean
new_messages_monitor_are_any_new_messages (NewMessagesMonitor* self,
                                           GearyFolder* folder,
                                           GeeCollection* ids)
{
	GeeMap* _tmp0_;
	NewMessagesMonitorMonitorInformation* info = NULL;
	GeeMap* _tmp1_;
	gpointer _tmp2_;
	gboolean result = FALSE;
#line 137 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), FALSE);
#line 137 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER), FALSE);
#line 137 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_COLLECTION), FALSE);
#line 139 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 139 "../src/client/notification/new-messages-monitor.vala"
	_vala_assert (gee_map_has_key (_tmp0_, folder), "folder_information.has_key(folder)");
#line 140 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->folder_information;
#line 140 "../src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_map_get (_tmp1_, folder);
#line 140 "../src/client/notification/new-messages-monitor.vala"
	info = (NewMessagesMonitorMonitorInformation*) _tmp2_;
#line 698 "new-messages-monitor.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp3_;
#line 142 "../src/client/notification/new-messages-monitor.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 142 "../src/client/notification/new-messages-monitor.vala"
		_id_it = _tmp3_;
#line 142 "../src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 708 "new-messages-monitor.c"
			GeeIterator* _tmp4_;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			NewMessagesMonitorMonitorInformation* _tmp7_;
			GeeHashSet* _tmp8_;
			GearyEmailIdentifier* _tmp9_;
#line 142 "../src/client/notification/new-messages-monitor.vala"
			_tmp4_ = _id_it;
#line 142 "../src/client/notification/new-messages-monitor.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 142 "../src/client/notification/new-messages-monitor.vala"
				break;
#line 722 "new-messages-monitor.c"
			}
#line 142 "../src/client/notification/new-messages-monitor.vala"
			_tmp5_ = _id_it;
#line 142 "../src/client/notification/new-messages-monitor.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 142 "../src/client/notification/new-messages-monitor.vala"
			id = (GearyEmailIdentifier*) _tmp6_;
#line 143 "../src/client/notification/new-messages-monitor.vala"
			_tmp7_ = info;
#line 143 "../src/client/notification/new-messages-monitor.vala"
			_tmp8_ = _tmp7_->new_ids;
#line 143 "../src/client/notification/new-messages-monitor.vala"
			_tmp9_ = id;
#line 143 "../src/client/notification/new-messages-monitor.vala"
			if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp9_)) {
#line 144 "../src/client/notification/new-messages-monitor.vala"
				result = TRUE;
#line 144 "../src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (id);
#line 144 "../src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (_id_it);
#line 144 "../src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (info);
#line 144 "../src/client/notification/new-messages-monitor.vala"
				return result;
#line 748 "new-messages-monitor.c"
			}
#line 142 "../src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (id);
#line 752 "new-messages-monitor.c"
		}
#line 142 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_id_it);
#line 756 "new-messages-monitor.c"
	}
#line 147 "../src/client/notification/new-messages-monitor.vala"
	result = FALSE;
#line 147 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (info);
#line 147 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 764 "new-messages-monitor.c"
}

static void
new_messages_monitor_on_email_locally_appended (NewMessagesMonitor* self,
                                                GearyFolder* folder,
                                                GeeCollection* email_ids)
{
#line 150 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 150 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 150 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email_ids, GEE_TYPE_COLLECTION));
#line 152 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email (self, folder, email_ids, NULL, NULL);
#line 780 "new-messages-monitor.c"
}

static void
new_messages_monitor_on_email_flags_changed (NewMessagesMonitor* self,
                                             GearyFolder* folder,
                                             GeeMap* ids)
{
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 155 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 155 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 155 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_MAP));
#line 157 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = gee_map_get_keys (ids);
#line 157 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _tmp0_;
#line 157 "../src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _tmp1_;
#line 157 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_retire_new_messages (self, folder, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 157 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_tmp2_);
#line 807 "new-messages-monitor.c"
}

static void
new_messages_monitor_on_email_removed (NewMessagesMonitor* self,
                                       GearyFolder* folder,
                                       GeeCollection* ids)
{
#line 160 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 160 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 160 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (ids, GEE_TYPE_COLLECTION));
#line 161 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_retire_new_messages (self, folder, ids);
#line 823 "new-messages-monitor.c"
}

static void
new_messages_monitor_do_process_new_email_data_free (gpointer _data)
{
	NewMessagesMonitorDoProcessNewEmailData* _data_;
	_data_ = _data;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->folder);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->self);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_slice_free (NewMessagesMonitorDoProcessNewEmailData, _data_);
#line 839 "new-messages-monitor.c"
}

static void
new_messages_monitor_do_process_new_email (NewMessagesMonitor* self,
                                           GearyFolder* folder,
                                           GeeCollection* email_ids,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	NewMessagesMonitorDoProcessNewEmailData* _data_;
	NewMessagesMonitor* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* _tmp2_;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_data_ = g_slice_new0 (NewMessagesMonitorDoProcessNewEmailData);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_task_set_task_data (_data_->_async_result, _data_, new_messages_monitor_do_process_new_email_data_free);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_data_->self = _tmp0_;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _g_object_ref0 (folder);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->folder);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_data_->folder = _tmp1_;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _g_object_ref0 (email_ids);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_data_->email_ids = _tmp2_;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email_co (_data_);
#line 877 "new-messages-monitor.c"
}

static void
new_messages_monitor_do_process_new_email_finish (NewMessagesMonitor* self,
                                                  GAsyncResult* _res_)
{
	NewMessagesMonitorDoProcessNewEmailData* _data_;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 887 "new-messages-monitor.c"
}

static void
new_messages_monitor_do_process_new_email_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	NewMessagesMonitorDoProcessNewEmailData* _data_;
#line 169 "../src/client/notification/new-messages-monitor.vala"
	_data_ = _user_data_;
#line 169 "../src/client/notification/new-messages-monitor.vala"
	_data_->_source_object_ = source_object;
#line 169 "../src/client/notification/new-messages-monitor.vala"
	_data_->_res_ = _res_;
#line 169 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_do_process_new_email_co (_data_);
#line 904 "new-messages-monitor.c"
}

static gboolean
new_messages_monitor_do_process_new_email_co (NewMessagesMonitorDoProcessNewEmailData* _data_)
{
#line 164 "../src/client/notification/new-messages-monitor.vala"
	switch (_data_->_state_) {
#line 164 "../src/client/notification/new-messages-monitor.vala"
		case 0:
#line 914 "new-messages-monitor.c"
		goto _state_0;
#line 164 "../src/client/notification/new-messages-monitor.vala"
		case 1:
#line 918 "new-messages-monitor.c"
		goto _state_1;
		default:
#line 164 "../src/client/notification/new-messages-monitor.vala"
		g_assert_not_reached ();
#line 923 "new-messages-monitor.c"
	}
	_state_0:
#line 166 "../src/client/notification/new-messages-monitor.vala"
	_data_->_tmp0_ = _data_->self->priv->folder_information;
#line 166 "../src/client/notification/new-messages-monitor.vala"
	_data_->_tmp1_ = gee_map_get (_data_->_tmp0_, _data_->folder);
#line 166 "../src/client/notification/new-messages-monitor.vala"
	_data_->info = (NewMessagesMonitorMonitorInformation*) _data_->_tmp1_;
#line 932 "new-messages-monitor.c"
	{
#line 169 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp2_ = _data_->self->priv->_required_fields;
#line 169 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp3_ = _data_->info;
#line 169 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp4_ = _data_->_tmp3_->cancellable;
#line 169 "../src/client/notification/new-messages-monitor.vala"
		_data_->_state_ = 1;
#line 169 "../src/client/notification/new-messages-monitor.vala"
		geary_folder_list_email_by_sparse_id_async (_data_->folder, _data_->email_ids, _data_->_tmp2_, GEARY_FOLDER_LIST_FLAGS_NONE, _data_->_tmp4_, new_messages_monitor_do_process_new_email_ready, _data_);
#line 169 "../src/client/notification/new-messages-monitor.vala"
		return FALSE;
#line 946 "new-messages-monitor.c"
		_state_1:
#line 169 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp5_ = geary_folder_list_email_by_sparse_id_finish (_data_->folder, _data_->_res_, &_data_->_inner_error0_);
#line 169 "../src/client/notification/new-messages-monitor.vala"
		_data_->list = _data_->_tmp5_;
#line 169 "../src/client/notification/new-messages-monitor.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 954 "new-messages-monitor.c"
			goto __catch186_g_error;
		}
#line 171 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp7_ = _data_->list;
#line 171 "../src/client/notification/new-messages-monitor.vala"
		if (_data_->_tmp7_ == NULL) {
#line 171 "../src/client/notification/new-messages-monitor.vala"
			_data_->_tmp6_ = TRUE;
#line 963 "new-messages-monitor.c"
		} else {
#line 171 "../src/client/notification/new-messages-monitor.vala"
			_data_->_tmp8_ = _data_->list;
#line 171 "../src/client/notification/new-messages-monitor.vala"
			_data_->_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 171 "../src/client/notification/new-messages-monitor.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 171 "../src/client/notification/new-messages-monitor.vala"
			_data_->_tmp6_ = _data_->_tmp10_ == 0;
#line 973 "new-messages-monitor.c"
		}
#line 171 "../src/client/notification/new-messages-monitor.vala"
		if (_data_->_tmp6_) {
#line 172 "../src/client/notification/new-messages-monitor.vala"
			_data_->_tmp11_ = gee_collection_get_size (_data_->email_ids);
#line 172 "../src/client/notification/new-messages-monitor.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 172 "../src/client/notification/new-messages-monitor.vala"
			g_debug ("new-messages-monitor.vala:172: Warning: %d new emails, but none could " \
"be listed", _data_->_tmp12_);
#line 174 "../src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (_data_->list);
#line 174 "../src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (_data_->info);
#line 174 "../src/client/notification/new-messages-monitor.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 174 "../src/client/notification/new-messages-monitor.vala"
			if (_data_->_state_ != 0) {
#line 174 "../src/client/notification/new-messages-monitor.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 174 "../src/client/notification/new-messages-monitor.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 995 "new-messages-monitor.c"
				}
			}
#line 174 "../src/client/notification/new-messages-monitor.vala"
			g_object_unref (_data_->_async_result);
#line 174 "../src/client/notification/new-messages-monitor.vala"
			return FALSE;
#line 1002 "new-messages-monitor.c"
		}
#line 177 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp13_ = _data_->info;
#line 177 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp14_ = _data_->list;
#line 177 "../src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_new_messages (_data_->self, _data_->_tmp13_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEE_TYPE_COLLECTION, GeeCollection));
#line 179 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp15_ = _data_->list;
#line 179 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp16_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 179 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 179 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp18_ = _data_->info;
#line 179 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp19_ = geary_folder_to_string (_data_->folder);
#line 179 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 179 "../src/client/notification/new-messages-monitor.vala"
		g_debug ("new-messages-monitor.vala:179: do_process_new_email: %d messages liste" \
"d, %d unread in folder %s", _data_->_tmp17_, _data_->_tmp18_->count, _data_->_tmp20_);
#line 179 "../src/client/notification/new-messages-monitor.vala"
		_g_free0 (_data_->_tmp20_);
#line 168 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_data_->list);
#line 1028 "new-messages-monitor.c"
	}
	goto __finally186;
	__catch186_g_error:
	{
#line 168 "../src/client/notification/new-messages-monitor.vala"
		_data_->err = _data_->_inner_error0_;
#line 168 "../src/client/notification/new-messages-monitor.vala"
		_data_->_inner_error0_ = NULL;
#line 182 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp21_ = _data_->err;
#line 182 "../src/client/notification/new-messages-monitor.vala"
		_data_->_tmp22_ = _data_->_tmp21_->message;
#line 182 "../src/client/notification/new-messages-monitor.vala"
		g_debug ("new-messages-monitor.vala:182: Unable to notify of new email: %s", _data_->_tmp22_);
#line 168 "../src/client/notification/new-messages-monitor.vala"
		_g_error_free0 (_data_->err);
#line 1045 "new-messages-monitor.c"
	}
	__finally186:
#line 168 "../src/client/notification/new-messages-monitor.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 168 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_data_->info);
#line 168 "../src/client/notification/new-messages-monitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 168 "../src/client/notification/new-messages-monitor.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 168 "../src/client/notification/new-messages-monitor.vala"
		g_object_unref (_data_->_async_result);
#line 168 "../src/client/notification/new-messages-monitor.vala"
		return FALSE;
#line 1060 "new-messages-monitor.c"
	}
#line 164 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (_data_->info);
#line 164 "../src/client/notification/new-messages-monitor.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 164 "../src/client/notification/new-messages-monitor.vala"
	if (_data_->_state_ != 0) {
#line 164 "../src/client/notification/new-messages-monitor.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 164 "../src/client/notification/new-messages-monitor.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1072 "new-messages-monitor.c"
		}
	}
#line 164 "../src/client/notification/new-messages-monitor.vala"
	g_object_unref (_data_->_async_result);
#line 164 "../src/client/notification/new-messages-monitor.vala"
	return FALSE;
#line 1079 "new-messages-monitor.c"
}

static void
new_messages_monitor_new_messages (NewMessagesMonitor* self,
                                   NewMessagesMonitorMonitorInformation* info,
                                   GeeCollection* emails)
{
	gint appended_count = 0;
#line 186 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 186 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION (info));
#line 186 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (emails, GEE_TYPE_COLLECTION));
#line 187 "../src/client/notification/new-messages-monitor.vala"
	appended_count = 0;
#line 1096 "new-messages-monitor.c"
	{
		GeeIterator* _email_it = NULL;
		GeeIterator* _tmp0_;
#line 188 "../src/client/notification/new-messages-monitor.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (emails, GEE_TYPE_ITERABLE, GeeIterable));
#line 188 "../src/client/notification/new-messages-monitor.vala"
		_email_it = _tmp0_;
#line 188 "../src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 1106 "new-messages-monitor.c"
			GeeIterator* _tmp1_;
			GearyEmail* email = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GearyEmail* _tmp4_;
			GearyEmailField _tmp5_;
			GearyEmailField _tmp6_;
			GearyEmailField _tmp7_;
			GeeHashSet* _tmp17_;
			GearyEmail* _tmp18_;
			GearyEmailIdentifier* _tmp19_;
			GearyEmailIdentifier* _tmp20_;
			GearyEmail* _tmp21_;
			GearyEmailFlags* _tmp22_;
			GearyEmailFlags* _tmp23_;
			GearyFolder* _tmp24_;
			GearyEmail* _tmp25_;
			GeeHashSet* _tmp26_;
			GearyEmail* _tmp27_;
			GearyEmailIdentifier* _tmp28_;
			GearyEmailIdentifier* _tmp29_;
			gint _tmp30_;
#line 188 "../src/client/notification/new-messages-monitor.vala"
			_tmp1_ = _email_it;
#line 188 "../src/client/notification/new-messages-monitor.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 188 "../src/client/notification/new-messages-monitor.vala"
				break;
#line 1135 "new-messages-monitor.c"
			}
#line 188 "../src/client/notification/new-messages-monitor.vala"
			_tmp2_ = _email_it;
#line 188 "../src/client/notification/new-messages-monitor.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 188 "../src/client/notification/new-messages-monitor.vala"
			email = (GearyEmail*) _tmp3_;
#line 189 "../src/client/notification/new-messages-monitor.vala"
			_tmp4_ = email;
#line 189 "../src/client/notification/new-messages-monitor.vala"
			_tmp5_ = geary_email_get_fields (_tmp4_);
#line 189 "../src/client/notification/new-messages-monitor.vala"
			_tmp6_ = _tmp5_;
#line 189 "../src/client/notification/new-messages-monitor.vala"
			_tmp7_ = self->priv->_required_fields;
#line 189 "../src/client/notification/new-messages-monitor.vala"
			if (!geary_email_field_fulfills (_tmp6_, _tmp7_)) {
#line 1153 "new-messages-monitor.c"
				GearyEmail* _tmp8_;
				GearyEmailIdentifier* _tmp9_;
				GearyEmailIdentifier* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				GearyEmail* _tmp13_;
				GearyEmailField _tmp14_;
				GearyEmailField _tmp15_;
				GearyEmailField _tmp16_;
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_tmp8_ = email;
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_tmp9_ = geary_email_get_id (_tmp8_);
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_tmp10_ = _tmp9_;
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_tmp11_ = geary_email_identifier_to_string (_tmp10_);
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_tmp12_ = _tmp11_;
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_tmp13_ = email;
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_tmp14_ = geary_email_get_fields (_tmp13_);
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_tmp15_ = _tmp14_;
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_tmp16_ = self->priv->_required_fields;
#line 190 "../src/client/notification/new-messages-monitor.vala"
				g_debug ("new-messages-monitor.vala:190: Warning: new message %s (%Xh) does not " \
"fulfill NewMessagesMonitor required fields of %Xh", _tmp12_, (guint) _tmp15_, (guint) _tmp16_);
#line 190 "../src/client/notification/new-messages-monitor.vala"
				_g_free0 (_tmp12_);
#line 1185 "new-messages-monitor.c"
			}
#line 194 "../src/client/notification/new-messages-monitor.vala"
			_tmp17_ = info->new_ids;
#line 194 "../src/client/notification/new-messages-monitor.vala"
			_tmp18_ = email;
#line 194 "../src/client/notification/new-messages-monitor.vala"
			_tmp19_ = geary_email_get_id (_tmp18_);
#line 194 "../src/client/notification/new-messages-monitor.vala"
			_tmp20_ = _tmp19_;
#line 194 "../src/client/notification/new-messages-monitor.vala"
			if (gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp20_)) {
#line 195 "../src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (email);
#line 195 "../src/client/notification/new-messages-monitor.vala"
				continue;
#line 1201 "new-messages-monitor.c"
			}
#line 197 "../src/client/notification/new-messages-monitor.vala"
			_tmp21_ = email;
#line 197 "../src/client/notification/new-messages-monitor.vala"
			_tmp22_ = geary_email_get_email_flags (_tmp21_);
#line 197 "../src/client/notification/new-messages-monitor.vala"
			_tmp23_ = _tmp22_;
#line 197 "../src/client/notification/new-messages-monitor.vala"
			if (!geary_email_flags_is_unread (_tmp23_)) {
#line 198 "../src/client/notification/new-messages-monitor.vala"
				_g_object_unref0 (email);
#line 198 "../src/client/notification/new-messages-monitor.vala"
				continue;
#line 1215 "new-messages-monitor.c"
			}
#line 200 "../src/client/notification/new-messages-monitor.vala"
			_tmp24_ = info->folder;
#line 200 "../src/client/notification/new-messages-monitor.vala"
			new_messages_monitor_set_last_new_message_folder (self, _tmp24_);
#line 201 "../src/client/notification/new-messages-monitor.vala"
			_tmp25_ = email;
#line 201 "../src/client/notification/new-messages-monitor.vala"
			new_messages_monitor_set_last_new_message (self, _tmp25_);
#line 203 "../src/client/notification/new-messages-monitor.vala"
			_tmp26_ = info->new_ids;
#line 203 "../src/client/notification/new-messages-monitor.vala"
			_tmp27_ = email;
#line 203 "../src/client/notification/new-messages-monitor.vala"
			_tmp28_ = geary_email_get_id (_tmp27_);
#line 203 "../src/client/notification/new-messages-monitor.vala"
			_tmp29_ = _tmp28_;
#line 203 "../src/client/notification/new-messages-monitor.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp29_);
#line 204 "../src/client/notification/new-messages-monitor.vala"
			_tmp30_ = appended_count;
#line 204 "../src/client/notification/new-messages-monitor.vala"
			appended_count = _tmp30_ + 1;
#line 188 "../src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (email);
#line 1241 "new-messages-monitor.c"
		}
#line 188 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_email_it);
#line 1245 "new-messages-monitor.c"
	}
#line 207 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, info, TRUE, appended_count);
#line 1249 "new-messages-monitor.c"
}

static void
new_messages_monitor_retire_new_messages (NewMessagesMonitor* self,
                                          GearyFolder* folder,
                                          GeeCollection* email_ids)
{
	NewMessagesMonitorMonitorInformation* info = NULL;
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	gint removed_count = 0;
	NewMessagesMonitorMonitorInformation* _tmp16_;
#line 210 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 210 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 210 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email_ids, GEE_TYPE_COLLECTION));
#line 212 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 212 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = gee_map_get (_tmp0_, folder);
#line 212 "../src/client/notification/new-messages-monitor.vala"
	info = (NewMessagesMonitorMonitorInformation*) _tmp1_;
#line 214 "../src/client/notification/new-messages-monitor.vala"
	removed_count = 0;
#line 1276 "new-messages-monitor.c"
	{
		GeeIterator* _email_id_it = NULL;
		GeeIterator* _tmp2_;
#line 215 "../src/client/notification/new-messages-monitor.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (email_ids, GEE_TYPE_ITERABLE, GeeIterable));
#line 215 "../src/client/notification/new-messages-monitor.vala"
		_email_id_it = _tmp2_;
#line 215 "../src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 1286 "new-messages-monitor.c"
			GeeIterator* _tmp3_;
			GearyEmailIdentifier* email_id = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			gboolean _tmp6_ = FALSE;
			GearyEmail* _tmp7_;
			NewMessagesMonitorMonitorInformation* _tmp12_;
			GeeHashSet* _tmp13_;
			GearyEmailIdentifier* _tmp14_;
#line 215 "../src/client/notification/new-messages-monitor.vala"
			_tmp3_ = _email_id_it;
#line 215 "../src/client/notification/new-messages-monitor.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 215 "../src/client/notification/new-messages-monitor.vala"
				break;
#line 1302 "new-messages-monitor.c"
			}
#line 215 "../src/client/notification/new-messages-monitor.vala"
			_tmp4_ = _email_id_it;
#line 215 "../src/client/notification/new-messages-monitor.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 215 "../src/client/notification/new-messages-monitor.vala"
			email_id = (GearyEmailIdentifier*) _tmp5_;
#line 216 "../src/client/notification/new-messages-monitor.vala"
			_tmp7_ = self->priv->_last_new_message;
#line 216 "../src/client/notification/new-messages-monitor.vala"
			if (_tmp7_ != NULL) {
#line 1314 "new-messages-monitor.c"
				GearyEmail* _tmp8_;
				GearyEmailIdentifier* _tmp9_;
				GearyEmailIdentifier* _tmp10_;
				GearyEmailIdentifier* _tmp11_;
#line 216 "../src/client/notification/new-messages-monitor.vala"
				_tmp8_ = self->priv->_last_new_message;
#line 216 "../src/client/notification/new-messages-monitor.vala"
				_tmp9_ = geary_email_get_id (_tmp8_);
#line 216 "../src/client/notification/new-messages-monitor.vala"
				_tmp10_ = _tmp9_;
#line 216 "../src/client/notification/new-messages-monitor.vala"
				_tmp11_ = email_id;
#line 216 "../src/client/notification/new-messages-monitor.vala"
				_tmp6_ = geary_email_identifier_equal_to (_tmp10_, _tmp11_);
#line 1329 "new-messages-monitor.c"
			} else {
#line 216 "../src/client/notification/new-messages-monitor.vala"
				_tmp6_ = FALSE;
#line 1333 "new-messages-monitor.c"
			}
#line 216 "../src/client/notification/new-messages-monitor.vala"
			if (_tmp6_) {
#line 217 "../src/client/notification/new-messages-monitor.vala"
				new_messages_monitor_set_last_new_message_folder (self, NULL);
#line 218 "../src/client/notification/new-messages-monitor.vala"
				new_messages_monitor_set_last_new_message (self, NULL);
#line 1341 "new-messages-monitor.c"
			}
#line 221 "../src/client/notification/new-messages-monitor.vala"
			_tmp12_ = info;
#line 221 "../src/client/notification/new-messages-monitor.vala"
			_tmp13_ = _tmp12_->new_ids;
#line 221 "../src/client/notification/new-messages-monitor.vala"
			_tmp14_ = email_id;
#line 221 "../src/client/notification/new-messages-monitor.vala"
			if (gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp14_)) {
#line 1351 "new-messages-monitor.c"
				gint _tmp15_;
#line 222 "../src/client/notification/new-messages-monitor.vala"
				_tmp15_ = removed_count;
#line 222 "../src/client/notification/new-messages-monitor.vala"
				removed_count = _tmp15_ + 1;
#line 1357 "new-messages-monitor.c"
			}
#line 215 "../src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (email_id);
#line 1361 "new-messages-monitor.c"
		}
#line 215 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_email_id_it);
#line 1365 "new-messages-monitor.c"
	}
#line 225 "../src/client/notification/new-messages-monitor.vala"
	_tmp16_ = info;
#line 225 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, _tmp16_, FALSE, removed_count);
#line 210 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (info);
#line 1373 "new-messages-monitor.c"
}

void
new_messages_monitor_clear_new_messages (NewMessagesMonitor* self,
                                         GearyFolder* folder)
{
	GeeMap* _tmp0_;
	NewMessagesMonitorMonitorInformation* info = NULL;
	GeeMap* _tmp1_;
	gpointer _tmp2_;
	GeeHashSet* _tmp3_;
#line 228 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 228 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
#line 229 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->folder_information;
#line 229 "../src/client/notification/new-messages-monitor.vala"
	_vala_assert (gee_map_has_key (_tmp0_, folder), "folder_information.has_key(folder)");
#line 230 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = self->priv->folder_information;
#line 230 "../src/client/notification/new-messages-monitor.vala"
	_tmp2_ = gee_map_get (_tmp1_, folder);
#line 230 "../src/client/notification/new-messages-monitor.vala"
	info = (NewMessagesMonitorMonitorInformation*) _tmp2_;
#line 232 "../src/client/notification/new-messages-monitor.vala"
	_tmp3_ = info->new_ids;
#line 232 "../src/client/notification/new-messages-monitor.vala"
	gee_abstract_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 233 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_last_new_message_folder (self, NULL);
#line 234 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_last_new_message (self, NULL);
#line 236 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_update_count (self, info, FALSE, 0);
#line 228 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (info);
#line 1411 "new-messages-monitor.c"
}

void
new_messages_monitor_clear_all_new_messages (NewMessagesMonitor* self)
{
#line 239 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 1419 "new-messages-monitor.c"
	{
		GeeIterator* _folder_it = NULL;
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 240 "../src/client/notification/new-messages-monitor.vala"
		_tmp0_ = self->priv->folder_information;
#line 240 "../src/client/notification/new-messages-monitor.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 240 "../src/client/notification/new-messages-monitor.vala"
		_tmp2_ = _tmp1_;
#line 240 "../src/client/notification/new-messages-monitor.vala"
		_tmp3_ = _tmp2_;
#line 240 "../src/client/notification/new-messages-monitor.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 240 "../src/client/notification/new-messages-monitor.vala"
		_tmp5_ = _tmp4_;
#line 240 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_tmp3_);
#line 240 "../src/client/notification/new-messages-monitor.vala"
		_folder_it = _tmp5_;
#line 240 "../src/client/notification/new-messages-monitor.vala"
		while (TRUE) {
#line 1446 "new-messages-monitor.c"
			GeeIterator* _tmp6_;
			GearyFolder* folder = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GearyFolder* _tmp9_;
#line 240 "../src/client/notification/new-messages-monitor.vala"
			_tmp6_ = _folder_it;
#line 240 "../src/client/notification/new-messages-monitor.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 240 "../src/client/notification/new-messages-monitor.vala"
				break;
#line 1458 "new-messages-monitor.c"
			}
#line 240 "../src/client/notification/new-messages-monitor.vala"
			_tmp7_ = _folder_it;
#line 240 "../src/client/notification/new-messages-monitor.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 240 "../src/client/notification/new-messages-monitor.vala"
			folder = (GearyFolder*) _tmp8_;
#line 241 "../src/client/notification/new-messages-monitor.vala"
			_tmp9_ = folder;
#line 241 "../src/client/notification/new-messages-monitor.vala"
			new_messages_monitor_clear_new_messages (self, _tmp9_);
#line 240 "../src/client/notification/new-messages-monitor.vala"
			_g_object_unref0 (folder);
#line 1472 "new-messages-monitor.c"
		}
#line 240 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (_folder_it);
#line 1476 "new-messages-monitor.c"
	}
}

static void
new_messages_monitor_update_count (NewMessagesMonitor* self,
                                   NewMessagesMonitorMonitorInformation* info,
                                   gboolean arrived,
                                   gint delta)
{
	gint new_size = 0;
	GeeHashSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 244 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 244 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (NEW_MESSAGES_MONITOR_IS_MONITOR_INFORMATION (info));
#line 245 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = info->new_ids;
#line 245 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 245 "../src/client/notification/new-messages-monitor.vala"
	_tmp2_ = _tmp1_;
#line 245 "../src/client/notification/new-messages-monitor.vala"
	new_size = _tmp2_;
#line 250 "../src/client/notification/new-messages-monitor.vala"
	if (info->count == new_size) {
#line 251 "../src/client/notification/new-messages-monitor.vala"
		return;
#line 1507 "new-messages-monitor.c"
	}
#line 253 "../src/client/notification/new-messages-monitor.vala"
	_tmp3_ = self->priv->_total_new_messages;
#line 253 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_set_total_new_messages (self, _tmp3_ + (new_size - info->count));
#line 254 "../src/client/notification/new-messages-monitor.vala"
	info->count = new_size;
#line 256 "../src/client/notification/new-messages-monitor.vala"
	if (arrived) {
#line 1517 "new-messages-monitor.c"
		GearyFolder* _tmp4_;
#line 257 "../src/client/notification/new-messages-monitor.vala"
		_tmp4_ = info->folder;
#line 257 "../src/client/notification/new-messages-monitor.vala"
		g_signal_emit (self, new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NEW_MESSAGES_ARRIVED_SIGNAL], 0, _tmp4_, info->count, delta);
#line 1523 "new-messages-monitor.c"
	} else {
		GearyFolder* _tmp5_;
#line 259 "../src/client/notification/new-messages-monitor.vala"
		_tmp5_ = info->folder;
#line 259 "../src/client/notification/new-messages-monitor.vala"
		g_signal_emit (self, new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NEW_MESSAGES_RETIRED_SIGNAL], 0, _tmp5_, info->count);
#line 1530 "new-messages-monitor.c"
	}
}

GearyEmailField
new_messages_monitor_get_required_fields (NewMessagesMonitor* self)
{
	GearyEmailField result;
	GearyEmailField _tmp0_;
#line 39 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 39 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_required_fields;
#line 39 "../src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 39 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 1547 "new-messages-monitor.c"
}

static void
new_messages_monitor_set_required_fields (NewMessagesMonitor* self,
                                          GearyEmailField value)
{
#line 39 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 39 "../src/client/notification/new-messages-monitor.vala"
	if (new_messages_monitor_get_required_fields (self) != value) {
#line 39 "../src/client/notification/new-messages-monitor.vala"
		self->priv->_required_fields = value;
#line 39 "../src/client/notification/new-messages-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY]);
#line 1562 "new-messages-monitor.c"
	}
}

gint
new_messages_monitor_get_total_new_messages (NewMessagesMonitor* self)
{
	gint result;
#line 40 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), 0);
#line 40 "../src/client/notification/new-messages-monitor.vala"
	result = self->priv->_total_new_messages;
#line 40 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 1576 "new-messages-monitor.c"
}

static void
new_messages_monitor_set_total_new_messages (NewMessagesMonitor* self,
                                             gint value)
{
#line 40 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 40 "../src/client/notification/new-messages-monitor.vala"
	if (new_messages_monitor_get_total_new_messages (self) != value) {
#line 40 "../src/client/notification/new-messages-monitor.vala"
		self->priv->_total_new_messages = value;
#line 40 "../src/client/notification/new-messages-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY]);
#line 1591 "new-messages-monitor.c"
	}
}

GearyFolder*
new_messages_monitor_get_last_new_message_folder (NewMessagesMonitor* self)
{
	GearyFolder* result;
	GearyFolder* _tmp0_;
#line 41 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 41 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_last_new_message_folder;
#line 41 "../src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 41 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 1608 "new-messages-monitor.c"
}

static void
new_messages_monitor_set_last_new_message_folder (NewMessagesMonitor* self,
                                                  GearyFolder* value)
{
#line 41 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 41 "../src/client/notification/new-messages-monitor.vala"
	if (new_messages_monitor_get_last_new_message_folder (self) != value) {
#line 1619 "new-messages-monitor.c"
		GearyFolder* _tmp0_;
#line 41 "../src/client/notification/new-messages-monitor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (self->priv->_last_new_message_folder);
#line 41 "../src/client/notification/new-messages-monitor.vala"
		self->priv->_last_new_message_folder = _tmp0_;
#line 41 "../src/client/notification/new-messages-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY]);
#line 1629 "new-messages-monitor.c"
	}
}

GearyEmail*
new_messages_monitor_get_last_new_message (NewMessagesMonitor* self)
{
	GearyEmail* result;
	GearyEmail* _tmp0_;
#line 42 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 42 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_last_new_message;
#line 42 "../src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 42 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 1646 "new-messages-monitor.c"
}

static void
new_messages_monitor_set_last_new_message (NewMessagesMonitor* self,
                                           GearyEmail* value)
{
#line 42 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 42 "../src/client/notification/new-messages-monitor.vala"
	if (new_messages_monitor_get_last_new_message (self) != value) {
#line 1657 "new-messages-monitor.c"
		GearyEmail* _tmp0_;
#line 42 "../src/client/notification/new-messages-monitor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 42 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (self->priv->_last_new_message);
#line 42 "../src/client/notification/new-messages-monitor.vala"
		self->priv->_last_new_message = _tmp0_;
#line 42 "../src/client/notification/new-messages-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY]);
#line 1667 "new-messages-monitor.c"
	}
}

ApplicationAvatarStore*
new_messages_monitor_get_avatars (NewMessagesMonitor* self)
{
	ApplicationAvatarStore* result;
	ApplicationAvatarStore* _tmp0_;
#line 45 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (self), NULL);
#line 45 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = self->priv->_avatars;
#line 45 "../src/client/notification/new-messages-monitor.vala"
	result = _tmp0_;
#line 45 "../src/client/notification/new-messages-monitor.vala"
	return result;
#line 1684 "new-messages-monitor.c"
}

static void
new_messages_monitor_set_avatars (NewMessagesMonitor* self,
                                  ApplicationAvatarStore* value)
{
#line 45 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (IS_NEW_MESSAGES_MONITOR (self));
#line 45 "../src/client/notification/new-messages-monitor.vala"
	if (new_messages_monitor_get_avatars (self) != value) {
#line 1695 "new-messages-monitor.c"
		ApplicationAvatarStore* _tmp0_;
#line 45 "../src/client/notification/new-messages-monitor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 45 "../src/client/notification/new-messages-monitor.vala"
		_g_object_unref0 (self->priv->_avatars);
#line 45 "../src/client/notification/new-messages-monitor.vala"
		self->priv->_avatars = _tmp0_;
#line 45 "../src/client/notification/new-messages-monitor.vala"
		g_object_notify_by_pspec ((GObject *) self, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_AVATARS_PROPERTY]);
#line 1705 "new-messages-monitor.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (n_param_values == 4);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/client/notification/new-messages-monitor.vala"
		data1 = closure->data;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 1731 "new-messages-monitor.c"
	} else {
#line 14 "../src/client/notification/new-messages-monitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		data2 = closure->data;
#line 1737 "new-messages-monitor.c"
	}
#line 14 "../src/client/notification/new-messages-monitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 1743 "new-messages-monitor.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/client/notification/new-messages-monitor.vala"
		data1 = closure->data;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 1768 "new-messages-monitor.c"
	} else {
#line 14 "../src/client/notification/new-messages-monitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		data2 = closure->data;
#line 1774 "new-messages-monitor.c"
	}
#line 14 "../src/client/notification/new-messages-monitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 1780 "new-messages-monitor.c"
}

static NewMessagesMonitorMonitorInformation*
new_messages_monitor_monitor_information_construct (GType object_type,
                                                    GearyFolder* folder,
                                                    GCancellable* cancellable)
{
	NewMessagesMonitorMonitorInformation * self = NULL;
	GearyFolder* _tmp0_;
	GCancellable* _tmp1_;
#line 33 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER), NULL);
#line 33 "../src/client/notification/new-messages-monitor.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 33 "../src/client/notification/new-messages-monitor.vala"
	self = (NewMessagesMonitorMonitorInformation*) geary_base_object_construct (object_type);
#line 34 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = _g_object_ref0 (folder);
#line 34 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->folder);
#line 34 "../src/client/notification/new-messages-monitor.vala"
	self->folder = _tmp0_;
#line 35 "../src/client/notification/new-messages-monitor.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 35 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->cancellable);
#line 35 "../src/client/notification/new-messages-monitor.vala"
	self->cancellable = _tmp1_;
#line 33 "../src/client/notification/new-messages-monitor.vala"
	return self;
#line 1811 "new-messages-monitor.c"
}

static NewMessagesMonitorMonitorInformation*
new_messages_monitor_monitor_information_new (GearyFolder* folder,
                                              GCancellable* cancellable)
{
#line 33 "../src/client/notification/new-messages-monitor.vala"
	return new_messages_monitor_monitor_information_construct (NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, folder, cancellable);
#line 1820 "new-messages-monitor.c"
}

static void
new_messages_monitor_monitor_information_class_init (NewMessagesMonitorMonitorInformationClass * klass,
                                                     gpointer klass_data)
{
#line 26 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_monitor_information_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = new_messages_monitor_monitor_information_finalize;
#line 1831 "new-messages-monitor.c"
}

static void
new_messages_monitor_monitor_information_instance_init (NewMessagesMonitorMonitorInformation * self,
                                                        gpointer klass)
{
	GeeHashSet* _tmp0_;
#line 28 "../src/client/notification/new-messages-monitor.vala"
	self->cancellable = NULL;
#line 29 "../src/client/notification/new-messages-monitor.vala"
	self->count = 0;
#line 30 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = gee_hash_set_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 30 "../src/client/notification/new-messages-monitor.vala"
	self->new_ids = _tmp0_;
#line 1847 "new-messages-monitor.c"
}

static void
new_messages_monitor_monitor_information_finalize (GObject * obj)
{
	NewMessagesMonitorMonitorInformation * self;
#line 26 "../src/client/notification/new-messages-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, NewMessagesMonitorMonitorInformation);
#line 27 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->folder);
#line 28 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->cancellable);
#line 30 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->new_ids);
#line 26 "../src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (new_messages_monitor_monitor_information_parent_class)->finalize (obj);
#line 1864 "new-messages-monitor.c"
}

static GType
new_messages_monitor_monitor_information_get_type (void)
{
	static volatile gsize new_messages_monitor_monitor_information_type_id__volatile = 0;
	if (g_once_init_enter (&new_messages_monitor_monitor_information_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NewMessagesMonitorMonitorInformationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_messages_monitor_monitor_information_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewMessagesMonitorMonitorInformation), 0, (GInstanceInitFunc) new_messages_monitor_monitor_information_instance_init, NULL };
		GType new_messages_monitor_monitor_information_type_id;
		new_messages_monitor_monitor_information_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "NewMessagesMonitorMonitorInformation", &g_define_type_info, 0);
		g_once_init_leave (&new_messages_monitor_monitor_information_type_id__volatile, new_messages_monitor_monitor_information_type_id);
	}
	return new_messages_monitor_monitor_information_type_id__volatile;
}

static void
new_messages_monitor_class_init (NewMessagesMonitorClass * klass,
                                 gpointer klass_data)
{
#line 14 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_type_class_adjust_private_offset (klass, &NewMessagesMonitor_private_offset);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_new_messages_monitor_get_property;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_new_messages_monitor_set_property;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = new_messages_monitor_finalize;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY] = g_param_spec_enum ("required-fields", "required-fields", "required-fields", GEARY_EMAIL_TYPE_FIELD, GEARY_EMAIL_FIELD_FLAGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY] = g_param_spec_int ("total-new-messages", "total-new-messages", "total-new-messages", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY] = g_param_spec_object ("last-new-message-folder", "last-new-message-folder", "last-new-message-folder", GEARY_TYPE_FOLDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY] = g_param_spec_object ("last-new-message", "last-new-message", "last-new-message", GEARY_TYPE_EMAIL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1902 "new-messages-monitor.c"
	/** Returns an avatar store to lookup avatars for notifications. */
#line 14 "../src/client/notification/new-messages-monitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NEW_MESSAGES_MONITOR_AVATARS_PROPERTY, new_messages_monitor_properties[NEW_MESSAGES_MONITOR_AVATARS_PROPERTY] = g_param_spec_object ("avatars", "avatars", "avatars", APPLICATION_TYPE_AVATAR_STORE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_signals[NEW_MESSAGES_MONITOR_FOLDER_ADDED_SIGNAL] = g_signal_new ("folder-added", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_FOLDER);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_signals[NEW_MESSAGES_MONITOR_FOLDER_REMOVED_SIGNAL] = g_signal_new ("folder-removed", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_FOLDER);
#line 1910 "new-messages-monitor.c"
	/**
	     * Fired when the monitor finds new messages on a folder.
	     */
#line 14 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NEW_MESSAGES_ARRIVED_SIGNAL] = g_signal_new ("new-messages-arrived", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT_INT, G_TYPE_NONE, 3, GEARY_TYPE_FOLDER, G_TYPE_INT, G_TYPE_INT);
#line 1916 "new-messages-monitor.c"
	/**
	     * Fired when the monitor clears the "new" status of some messages in the
	     * folder.
	     */
#line 14 "../src/client/notification/new-messages-monitor.vala"
	new_messages_monitor_signals[NEW_MESSAGES_MONITOR_NEW_MESSAGES_RETIRED_SIGNAL] = g_signal_new ("new-messages-retired", TYPE_NEW_MESSAGES_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, G_TYPE_INT);
#line 1923 "new-messages-monitor.c"
}

static void
new_messages_monitor_instance_init (NewMessagesMonitor * self,
                                    gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	self->priv = new_messages_monitor_get_instance_private (self);
#line 39 "../src/client/notification/new-messages-monitor.vala"
	self->priv->_required_fields = GEARY_EMAIL_FIELD_FLAGS;
#line 40 "../src/client/notification/new-messages-monitor.vala"
	self->priv->_total_new_messages = 0;
#line 41 "../src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message_folder = NULL;
#line 42 "../src/client/notification/new-messages-monitor.vala"
	self->priv->_last_new_message = NULL;
#line 48 "../src/client/notification/new-messages-monitor.vala"
	_tmp0_ = gee_hash_map_new (GEARY_TYPE_FOLDER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NEW_MESSAGES_MONITOR_TYPE_MONITOR_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/client/notification/new-messages-monitor.vala"
	self->priv->folder_information = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 1945 "new-messages-monitor.c"
}

static void
new_messages_monitor_finalize (GObject * obj)
{
	NewMessagesMonitor * self;
#line 14 "../src/client/notification/new-messages-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 41 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message_folder);
#line 42 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_last_new_message);
#line 45 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->_avatars);
#line 48 "../src/client/notification/new-messages-monitor.vala"
	_g_object_unref0 (self->priv->folder_information);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	G_OBJECT_CLASS (new_messages_monitor_parent_class)->finalize (obj);
#line 1964 "new-messages-monitor.c"
}

GType
new_messages_monitor_get_type (void)
{
	static volatile gsize new_messages_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&new_messages_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NewMessagesMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) new_messages_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NewMessagesMonitor), 0, (GInstanceInitFunc) new_messages_monitor_instance_init, NULL };
		GType new_messages_monitor_type_id;
		new_messages_monitor_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "NewMessagesMonitor", &g_define_type_info, 0);
		NewMessagesMonitor_private_offset = g_type_add_instance_private (new_messages_monitor_type_id, sizeof (NewMessagesMonitorPrivate));
		g_once_init_leave (&new_messages_monitor_type_id__volatile, new_messages_monitor_type_id);
	}
	return new_messages_monitor_type_id__volatile;
}

static void
_vala_new_messages_monitor_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	NewMessagesMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	switch (property_id) {
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		g_value_set_enum (value, new_messages_monitor_get_required_fields (self));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		g_value_set_int (value, new_messages_monitor_get_total_new_messages (self));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		g_value_set_object (value, new_messages_monitor_get_last_new_message_folder (self));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		g_value_set_object (value, new_messages_monitor_get_last_new_message (self));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_AVATARS_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		g_value_set_object (value, new_messages_monitor_get_avatars (self));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 2021 "new-messages-monitor.c"
		default:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 2027 "new-messages-monitor.c"
	}
}

static void
_vala_new_messages_monitor_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	NewMessagesMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor);
#line 14 "../src/client/notification/new-messages-monitor.vala"
	switch (property_id) {
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_REQUIRED_FIELDS_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_required_fields (self, g_value_get_enum (value));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_TOTAL_NEW_MESSAGES_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_total_new_messages (self, g_value_get_int (value));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_FOLDER_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_last_new_message_folder (self, g_value_get_object (value));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_LAST_NEW_MESSAGE_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_last_new_message (self, g_value_get_object (value));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 14 "../src/client/notification/new-messages-monitor.vala"
		case NEW_MESSAGES_MONITOR_AVATARS_PROPERTY:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		new_messages_monitor_set_avatars (self, g_value_get_object (value));
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 2071 "new-messages-monitor.c"
		default:
#line 14 "../src/client/notification/new-messages-monitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/client/notification/new-messages-monitor.vala"
		break;
#line 2077 "new-messages-monitor.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

