/* util-email.c generated by valac 0.46.0, the Vala compiler
 * generated from util-email.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "geary-engine.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	UTIL_DATE_CLOCK_FORMAT_TWELVE_HOURS,
	UTIL_DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS,
	UTIL_DATE_CLOCK_FORMAT_LOCALE_DEFAULT,
	UTIL_DATE_CLOCK_FORMAT_TOTAL
} UtilDateClockFormat;

#define UTIL_DATE_TYPE_CLOCK_FORMAT (util_date_clock_format_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

gint util_email_compare_conversation_ascending (GearyAppConversation* a,
                                                GearyAppConversation* b);
gint util_email_compare_conversation_descending (GearyAppConversation* a,
                                                 GearyAppConversation* b);
gchar* util_email_strip_subject_prefixes (GearyEmail* email);
GearyRFC822MailboxAddress* util_email_get_primary_originator (GearyEmailHeaderSet* email);
gchar* util_email_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes);
GType util_date_clock_format_get_type (void) G_GNUC_CONST;
gchar* util_email_quote_email_for_reply (GearyEmail* email,
                                         const gchar* quote,
                                         UtilDateClockFormat clock_format,
                                         GearyRFC822TextFormat format);
gchar* util_date_get_full_date (UtilDateClockFormat clock_format);
gchar* util_email_quote_body (GearyEmail* email,
                              const gchar* html_quote,
                              gboolean use_quotes,
                              GearyRFC822TextFormat format,
                              GError** error);
gchar* util_email_quote_email_for_forward (GearyEmail* email,
                                           const gchar* quote,
                                           GearyRFC822TextFormat format);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

gint
util_email_compare_conversation_ascending (GearyAppConversation* a,
                                           GearyAppConversation* b)
{
	GearyEmail* a_latest = NULL;
	GearyEmail* _tmp0_;
	GearyEmail* b_latest = NULL;
	GearyEmail* _tmp1_;
	GearyEmail* _tmp2_;
	GearyEmail* _tmp6_;
	GearyEmail* _tmp7_;
	gint result = 0;
#line 9 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (a, GEARY_APP_TYPE_CONVERSATION), 0);
#line 9 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (b, GEARY_APP_TYPE_CONVERSATION), 0);
#line 11 "../src/client/util/util-email.vala"
	_tmp0_ = geary_app_conversation_get_latest_recv_email (a, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
#line 11 "../src/client/util/util-email.vala"
	a_latest = _tmp0_;
#line 14 "../src/client/util/util-email.vala"
	_tmp1_ = geary_app_conversation_get_latest_recv_email (b, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
#line 14 "../src/client/util/util-email.vala"
	b_latest = _tmp1_;
#line 18 "../src/client/util/util-email.vala"
	_tmp2_ = a_latest;
#line 18 "../src/client/util/util-email.vala"
	if (_tmp2_ == NULL) {
#line 88 "util-email.c"
		gint _tmp3_ = 0;
		GearyEmail* _tmp4_;
#line 19 "../src/client/util/util-email.vala"
		_tmp4_ = b_latest;
#line 19 "../src/client/util/util-email.vala"
		if (_tmp4_ == NULL) {
#line 19 "../src/client/util/util-email.vala"
			_tmp3_ = 0;
#line 97 "util-email.c"
		} else {
#line 19 "../src/client/util/util-email.vala"
			_tmp3_ = -1;
#line 101 "util-email.c"
		}
#line 19 "../src/client/util/util-email.vala"
		result = _tmp3_;
#line 19 "../src/client/util/util-email.vala"
		_g_object_unref0 (b_latest);
#line 19 "../src/client/util/util-email.vala"
		_g_object_unref0 (a_latest);
#line 19 "../src/client/util/util-email.vala"
		return result;
#line 111 "util-email.c"
	} else {
		GearyEmail* _tmp5_;
#line 20 "../src/client/util/util-email.vala"
		_tmp5_ = b_latest;
#line 20 "../src/client/util/util-email.vala"
		if (_tmp5_ == NULL) {
#line 21 "../src/client/util/util-email.vala"
			result = 1;
#line 21 "../src/client/util/util-email.vala"
			_g_object_unref0 (b_latest);
#line 21 "../src/client/util/util-email.vala"
			_g_object_unref0 (a_latest);
#line 21 "../src/client/util/util-email.vala"
			return result;
#line 126 "util-email.c"
		}
	}
#line 27 "../src/client/util/util-email.vala"
	_tmp6_ = a_latest;
#line 27 "../src/client/util/util-email.vala"
	_tmp7_ = b_latest;
#line 27 "../src/client/util/util-email.vala"
	result = geary_email_compare_recv_date_ascending (_tmp6_, _tmp7_);
#line 27 "../src/client/util/util-email.vala"
	_g_object_unref0 (b_latest);
#line 27 "../src/client/util/util-email.vala"
	_g_object_unref0 (a_latest);
#line 27 "../src/client/util/util-email.vala"
	return result;
#line 141 "util-email.c"
}

gint
util_email_compare_conversation_descending (GearyAppConversation* a,
                                            GearyAppConversation* b)
{
	gint result = 0;
#line 30 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (a, GEARY_APP_TYPE_CONVERSATION), 0);
#line 30 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (b, GEARY_APP_TYPE_CONVERSATION), 0);
#line 32 "../src/client/util/util-email.vala"
	result = util_email_compare_conversation_ascending (b, a);
#line 32 "../src/client/util/util-email.vala"
	return result;
#line 157 "util-email.c"
}

/** Returns the stripped subject line, or a placeholder if none. */
gchar*
util_email_strip_subject_prefixes (GearyEmail* email)
{
	gchar* _tmp0_ = NULL;
	GearyRFC822Subject* _tmp1_;
	GearyRFC822Subject* _tmp2_;
	gchar* cleaned = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp10_;
	gchar* result = NULL;
#line 36 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), NULL);
#line 37 "../src/client/util/util-email.vala"
	_tmp1_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 37 "../src/client/util/util-email.vala"
	_tmp2_ = _tmp1_;
#line 37 "../src/client/util/util-email.vala"
	if (_tmp2_ != NULL) {
#line 181 "util-email.c"
		GearyRFC822Subject* _tmp3_;
		GearyRFC822Subject* _tmp4_;
		gchar* _tmp5_;
#line 37 "../src/client/util/util-email.vala"
		_tmp3_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 37 "../src/client/util/util-email.vala"
		_tmp4_ = _tmp3_;
#line 37 "../src/client/util/util-email.vala"
		_tmp5_ = geary_rf_c822_subject_strip_prefixes (_tmp4_);
#line 37 "../src/client/util/util-email.vala"
		_g_free0 (_tmp0_);
#line 37 "../src/client/util/util-email.vala"
		_tmp0_ = _tmp5_;
#line 195 "util-email.c"
	} else {
#line 37 "../src/client/util/util-email.vala"
		_g_free0 (_tmp0_);
#line 37 "../src/client/util/util-email.vala"
		_tmp0_ = NULL;
#line 201 "util-email.c"
	}
#line 37 "../src/client/util/util-email.vala"
	_tmp6_ = g_strdup (_tmp0_);
#line 37 "../src/client/util/util-email.vala"
	cleaned = _tmp6_;
#line 38 "../src/client/util/util-email.vala"
	_tmp8_ = cleaned;
#line 38 "../src/client/util/util-email.vala"
	if (!geary_string_is_empty (_tmp8_)) {
#line 211 "util-email.c"
		const gchar* _tmp9_;
#line 38 "../src/client/util/util-email.vala"
		_tmp9_ = cleaned;
#line 38 "../src/client/util/util-email.vala"
		_tmp7_ = _tmp9_;
#line 217 "util-email.c"
	} else {
#line 38 "../src/client/util/util-email.vala"
		_tmp7_ = _ ("(no subject)");
#line 221 "util-email.c"
	}
#line 38 "../src/client/util/util-email.vala"
	_tmp10_ = g_strdup (_tmp7_);
#line 38 "../src/client/util/util-email.vala"
	result = _tmp10_;
#line 38 "../src/client/util/util-email.vala"
	_g_free0 (cleaned);
#line 38 "../src/client/util/util-email.vala"
	_g_free0 (_tmp0_);
#line 38 "../src/client/util/util-email.vala"
	return result;
#line 233 "util-email.c"
}

/**
     * Returns a mailbox for the primary originator of an email.
     *
     * RFC 822 allows multiple and absent From header values, and
     * software such as Mailman and GitLab will mangle the names in
     * From mailboxes. This provides a canonical means to obtain a
     * mailbox (that is, name and email address) for the first
     * originator, and with the mailbox's name having been fixed up
     * where possible.
     *
     * The first From mailbox is used and de-mangled if found, if not
     * the Sender mailbox is used if present, else the first Reply-To
     * mailbox is used.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 60 "../src/client/util/util-email.vala"
	return self ? g_object_ref (self) : NULL;
#line 255 "util-email.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 274 "util-email.c"
}

GearyRFC822MailboxAddress*
util_email_get_primary_originator (GearyEmailHeaderSet* email)
{
	GearyRFC822MailboxAddress* primary = NULL;
	gboolean _tmp0_ = FALSE;
	GearyRFC822MailboxAddresses* _tmp1_;
	GearyRFC822MailboxAddresses* _tmp2_;
	GearyRFC822MailboxAddress* result = NULL;
#line 55 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL_HEADER_SET), NULL);
#line 57 "../src/client/util/util-email.vala"
	primary = NULL;
#line 58 "../src/client/util/util-email.vala"
	_tmp1_ = geary_email_header_set_get_from (email);
#line 58 "../src/client/util/util-email.vala"
	_tmp2_ = _tmp1_;
#line 58 "../src/client/util/util-email.vala"
	if (_tmp2_ != NULL) {
#line 295 "util-email.c"
		GearyRFC822MailboxAddresses* _tmp3_;
		GearyRFC822MailboxAddresses* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 58 "../src/client/util/util-email.vala"
		_tmp3_ = geary_email_header_set_get_from (email);
#line 58 "../src/client/util/util-email.vala"
		_tmp4_ = _tmp3_;
#line 58 "../src/client/util/util-email.vala"
		_tmp5_ = geary_rf_c822_mailbox_addresses_get_size (_tmp4_);
#line 58 "../src/client/util/util-email.vala"
		_tmp6_ = _tmp5_;
#line 58 "../src/client/util/util-email.vala"
		_tmp0_ = _tmp6_ > 0;
#line 310 "util-email.c"
	} else {
#line 58 "../src/client/util/util-email.vala"
		_tmp0_ = FALSE;
#line 314 "util-email.c"
	}
#line 58 "../src/client/util/util-email.vala"
	if (_tmp0_) {
#line 318 "util-email.c"
		GearyRFC822MailboxAddresses* from = NULL;
		GearyRFC822MailboxAddresses* _tmp7_;
		GearyRFC822MailboxAddresses* _tmp8_;
		GearyRFC822MailboxAddresses* _tmp9_;
		gchar* from_name = NULL;
		gchar* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp12_;
		GearyRFC822MailboxAddresses* reply_to = NULL;
		GearyRFC822MailboxAddresses* _tmp23_;
		GearyRFC822MailboxAddresses* _tmp24_;
		GearyRFC822MailboxAddresses* _tmp25_;
		GearyRFC822MailboxAddress* primary_reply_to = NULL;
		gchar* reply_to_name = NULL;
		gchar* _tmp26_;
		gboolean _tmp27_ = FALSE;
		GearyRFC822MailboxAddresses* _tmp28_;
#line 77 "../src/client/util/util-email.vala"
		static const char VIA[] = " via ";
#line 338 "util-email.c"
		gboolean _tmp39_ = FALSE;
		const gchar* _tmp40_;
#line 60 "../src/client/util/util-email.vala"
		_tmp7_ = geary_email_header_set_get_from (email);
#line 60 "../src/client/util/util-email.vala"
		_tmp8_ = _tmp7_;
#line 60 "../src/client/util/util-email.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 60 "../src/client/util/util-email.vala"
		from = _tmp9_;
#line 62 "../src/client/util/util-email.vala"
		_tmp10_ = g_strdup ("");
#line 62 "../src/client/util/util-email.vala"
		from_name = _tmp10_;
#line 63 "../src/client/util/util-email.vala"
		_tmp12_ = from;
#line 63 "../src/client/util/util-email.vala"
		if (_tmp12_ != NULL) {
#line 357 "util-email.c"
			GearyRFC822MailboxAddresses* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 63 "../src/client/util/util-email.vala"
			_tmp13_ = from;
#line 63 "../src/client/util/util-email.vala"
			_tmp14_ = geary_rf_c822_mailbox_addresses_get_size (_tmp13_);
#line 63 "../src/client/util/util-email.vala"
			_tmp15_ = _tmp14_;
#line 63 "../src/client/util/util-email.vala"
			_tmp11_ = _tmp15_ > 0;
#line 369 "util-email.c"
		} else {
#line 63 "../src/client/util/util-email.vala"
			_tmp11_ = FALSE;
#line 373 "util-email.c"
		}
#line 63 "../src/client/util/util-email.vala"
		if (_tmp11_) {
#line 377 "util-email.c"
			GearyRFC822MailboxAddresses* _tmp16_;
			GearyRFC822MailboxAddress* _tmp17_;
			const gchar* _tmp18_ = NULL;
			GearyRFC822MailboxAddress* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 64 "../src/client/util/util-email.vala"
			_tmp16_ = from;
#line 64 "../src/client/util/util-email.vala"
			_tmp17_ = geary_rf_c822_mailbox_addresses_get (_tmp16_, 0);
#line 64 "../src/client/util/util-email.vala"
			_g_object_unref0 (primary);
#line 64 "../src/client/util/util-email.vala"
			primary = _tmp17_;
#line 65 "../src/client/util/util-email.vala"
			_tmp19_ = primary;
#line 65 "../src/client/util/util-email.vala"
			_tmp20_ = geary_rf_c822_mailbox_address_get_name (_tmp19_);
#line 65 "../src/client/util/util-email.vala"
			_tmp21_ = _tmp20_;
#line 65 "../src/client/util/util-email.vala"
			_tmp18_ = _tmp21_;
#line 65 "../src/client/util/util-email.vala"
			if (_tmp18_ == NULL) {
#line 65 "../src/client/util/util-email.vala"
				_tmp18_ = "";
#line 405 "util-email.c"
			}
#line 65 "../src/client/util/util-email.vala"
			_tmp22_ = g_strdup (_tmp18_);
#line 65 "../src/client/util/util-email.vala"
			_g_free0 (from_name);
#line 65 "../src/client/util/util-email.vala"
			from_name = _tmp22_;
#line 413 "util-email.c"
		}
#line 68 "../src/client/util/util-email.vala"
		_tmp23_ = geary_email_header_set_get_reply_to (email);
#line 68 "../src/client/util/util-email.vala"
		_tmp24_ = _tmp23_;
#line 68 "../src/client/util/util-email.vala"
		_tmp25_ = _g_object_ref0 (_tmp24_);
#line 68 "../src/client/util/util-email.vala"
		reply_to = _tmp25_;
#line 69 "../src/client/util/util-email.vala"
		primary_reply_to = NULL;
#line 70 "../src/client/util/util-email.vala"
		_tmp26_ = g_strdup ("");
#line 70 "../src/client/util/util-email.vala"
		reply_to_name = _tmp26_;
#line 71 "../src/client/util/util-email.vala"
		_tmp28_ = reply_to;
#line 71 "../src/client/util/util-email.vala"
		if (_tmp28_ != NULL) {
#line 433 "util-email.c"
			GearyRFC822MailboxAddresses* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
#line 71 "../src/client/util/util-email.vala"
			_tmp29_ = reply_to;
#line 71 "../src/client/util/util-email.vala"
			_tmp30_ = geary_rf_c822_mailbox_addresses_get_size (_tmp29_);
#line 71 "../src/client/util/util-email.vala"
			_tmp31_ = _tmp30_;
#line 71 "../src/client/util/util-email.vala"
			_tmp27_ = _tmp31_ > 0;
#line 445 "util-email.c"
		} else {
#line 71 "../src/client/util/util-email.vala"
			_tmp27_ = FALSE;
#line 449 "util-email.c"
		}
#line 71 "../src/client/util/util-email.vala"
		if (_tmp27_) {
#line 453 "util-email.c"
			GearyRFC822MailboxAddresses* _tmp32_;
			GearyRFC822MailboxAddress* _tmp33_;
			const gchar* _tmp34_ = NULL;
			GearyRFC822MailboxAddress* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
#line 72 "../src/client/util/util-email.vala"
			_tmp32_ = reply_to;
#line 72 "../src/client/util/util-email.vala"
			_tmp33_ = geary_rf_c822_mailbox_addresses_get (_tmp32_, 0);
#line 72 "../src/client/util/util-email.vala"
			_g_object_unref0 (primary_reply_to);
#line 72 "../src/client/util/util-email.vala"
			primary_reply_to = _tmp33_;
#line 73 "../src/client/util/util-email.vala"
			_tmp35_ = primary_reply_to;
#line 73 "../src/client/util/util-email.vala"
			_tmp36_ = geary_rf_c822_mailbox_address_get_name (_tmp35_);
#line 73 "../src/client/util/util-email.vala"
			_tmp37_ = _tmp36_;
#line 73 "../src/client/util/util-email.vala"
			_tmp34_ = _tmp37_;
#line 73 "../src/client/util/util-email.vala"
			if (_tmp34_ == NULL) {
#line 73 "../src/client/util/util-email.vala"
				_tmp34_ = "";
#line 481 "util-email.c"
			}
#line 73 "../src/client/util/util-email.vala"
			_tmp38_ = g_strdup (_tmp34_);
#line 73 "../src/client/util/util-email.vala"
			_g_free0 (reply_to_name);
#line 73 "../src/client/util/util-email.vala"
			reply_to_name = _tmp38_;
#line 489 "util-email.c"
		}
#line 79 "../src/client/util/util-email.vala"
		_tmp40_ = reply_to_name;
#line 79 "../src/client/util/util-email.vala"
		if (g_strcmp0 (_tmp40_, "") != 0) {
#line 495 "util-email.c"
			const gchar* _tmp41_;
			const gchar* _tmp42_;
#line 79 "../src/client/util/util-email.vala"
			_tmp41_ = from_name;
#line 79 "../src/client/util/util-email.vala"
			_tmp42_ = reply_to_name;
#line 79 "../src/client/util/util-email.vala"
			_tmp39_ = g_str_has_prefix (_tmp41_, _tmp42_);
#line 504 "util-email.c"
		} else {
#line 79 "../src/client/util/util-email.vala"
			_tmp39_ = FALSE;
#line 508 "util-email.c"
		}
#line 79 "../src/client/util/util-email.vala"
		if (_tmp39_) {
#line 512 "util-email.c"
			GearyRFC822MailboxAddress* _tmp43_;
			GearyRFC822MailboxAddress* _tmp44_;
#line 82 "../src/client/util/util-email.vala"
			_tmp43_ = primary_reply_to;
#line 82 "../src/client/util/util-email.vala"
			_tmp44_ = _g_object_ref0 (_tmp43_);
#line 82 "../src/client/util/util-email.vala"
			_g_object_unref0 (primary);
#line 82 "../src/client/util/util-email.vala"
			primary = _tmp44_;
#line 523 "util-email.c"
		} else {
			const gchar* _tmp45_;
#line 83 "../src/client/util/util-email.vala"
			_tmp45_ = from_name;
#line 83 "../src/client/util/util-email.vala"
			if (string_contains (_tmp45_, VIA)) {
#line 530 "util-email.c"
				const gchar* _tmp46_;
				gchar** _tmp47_;
				gchar** _tmp48_;
				gchar** _tmp49_;
				gint _tmp49__length1;
				const gchar* _tmp50_;
				GearyRFC822MailboxAddress* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				GearyRFC822MailboxAddress* _tmp54_;
#line 87 "../src/client/util/util-email.vala"
				_tmp46_ = from_name;
#line 87 "../src/client/util/util-email.vala"
				_tmp48_ = _tmp47_ = g_strsplit (_tmp46_, VIA, 2);
#line 87 "../src/client/util/util-email.vala"
				_tmp49_ = _tmp48_;
#line 87 "../src/client/util/util-email.vala"
				_tmp49__length1 = _vala_array_length (_tmp47_);
#line 87 "../src/client/util/util-email.vala"
				_tmp50_ = _tmp49_[0];
#line 87 "../src/client/util/util-email.vala"
				_tmp51_ = primary;
#line 87 "../src/client/util/util-email.vala"
				_tmp52_ = geary_rf_c822_mailbox_address_get_address (_tmp51_);
#line 87 "../src/client/util/util-email.vala"
				_tmp53_ = _tmp52_;
#line 87 "../src/client/util/util-email.vala"
				_tmp54_ = geary_rf_c822_mailbox_address_new (_tmp50_, _tmp53_);
#line 87 "../src/client/util/util-email.vala"
				_g_object_unref0 (primary);
#line 87 "../src/client/util/util-email.vala"
				primary = _tmp54_;
#line 87 "../src/client/util/util-email.vala"
				_tmp49_ = (_vala_array_free (_tmp49_, _tmp49__length1, (GDestroyNotify) g_free), NULL);
#line 565 "util-email.c"
			}
		}
#line 58 "../src/client/util/util-email.vala"
		_g_free0 (reply_to_name);
#line 58 "../src/client/util/util-email.vala"
		_g_object_unref0 (primary_reply_to);
#line 58 "../src/client/util/util-email.vala"
		_g_object_unref0 (reply_to);
#line 58 "../src/client/util/util-email.vala"
		_g_free0 (from_name);
#line 58 "../src/client/util/util-email.vala"
		_g_object_unref0 (from);
#line 578 "util-email.c"
	} else {
		GearyRFC822MailboxAddress* _tmp55_;
		GearyRFC822MailboxAddress* _tmp56_;
#line 91 "../src/client/util/util-email.vala"
		_tmp55_ = geary_email_header_set_get_sender (email);
#line 91 "../src/client/util/util-email.vala"
		_tmp56_ = _tmp55_;
#line 91 "../src/client/util/util-email.vala"
		if (_tmp56_ != NULL) {
#line 588 "util-email.c"
			GearyRFC822MailboxAddress* _tmp57_;
			GearyRFC822MailboxAddress* _tmp58_;
			GearyRFC822MailboxAddress* _tmp59_;
#line 92 "../src/client/util/util-email.vala"
			_tmp57_ = geary_email_header_set_get_sender (email);
#line 92 "../src/client/util/util-email.vala"
			_tmp58_ = _tmp57_;
#line 92 "../src/client/util/util-email.vala"
			_tmp59_ = _g_object_ref0 (_tmp58_);
#line 92 "../src/client/util/util-email.vala"
			_g_object_unref0 (primary);
#line 92 "../src/client/util/util-email.vala"
			primary = _tmp59_;
#line 602 "util-email.c"
		} else {
			gboolean _tmp60_ = FALSE;
			GearyRFC822MailboxAddresses* _tmp61_;
			GearyRFC822MailboxAddresses* _tmp62_;
#line 93 "../src/client/util/util-email.vala"
			_tmp61_ = geary_email_header_set_get_reply_to (email);
#line 93 "../src/client/util/util-email.vala"
			_tmp62_ = _tmp61_;
#line 93 "../src/client/util/util-email.vala"
			if (_tmp62_ != NULL) {
#line 613 "util-email.c"
				GearyRFC822MailboxAddresses* _tmp63_;
				GearyRFC822MailboxAddresses* _tmp64_;
				gint _tmp65_;
				gint _tmp66_;
#line 93 "../src/client/util/util-email.vala"
				_tmp63_ = geary_email_header_set_get_reply_to (email);
#line 93 "../src/client/util/util-email.vala"
				_tmp64_ = _tmp63_;
#line 93 "../src/client/util/util-email.vala"
				_tmp65_ = geary_rf_c822_mailbox_addresses_get_size (_tmp64_);
#line 93 "../src/client/util/util-email.vala"
				_tmp66_ = _tmp65_;
#line 93 "../src/client/util/util-email.vala"
				_tmp60_ = _tmp66_ > 0;
#line 628 "util-email.c"
			} else {
#line 93 "../src/client/util/util-email.vala"
				_tmp60_ = FALSE;
#line 632 "util-email.c"
			}
#line 93 "../src/client/util/util-email.vala"
			if (_tmp60_) {
#line 636 "util-email.c"
				GearyRFC822MailboxAddresses* _tmp67_;
				GearyRFC822MailboxAddresses* _tmp68_;
				GearyRFC822MailboxAddress* _tmp69_;
#line 94 "../src/client/util/util-email.vala"
				_tmp67_ = geary_email_header_set_get_reply_to (email);
#line 94 "../src/client/util/util-email.vala"
				_tmp68_ = _tmp67_;
#line 94 "../src/client/util/util-email.vala"
				_tmp69_ = geary_rf_c822_mailbox_addresses_get (_tmp68_, 0);
#line 94 "../src/client/util/util-email.vala"
				_g_object_unref0 (primary);
#line 94 "../src/client/util/util-email.vala"
				primary = _tmp69_;
#line 650 "util-email.c"
			}
		}
	}
#line 97 "../src/client/util/util-email.vala"
	result = primary;
#line 97 "../src/client/util/util-email.vala"
	return result;
#line 658 "util-email.c"
}

/**
     * Returns a shortened recipient list suitable for display.
     *
     * This is useful in case there are a lot of recipients, or there
     * is little room for the display.
     *
     * @return a string containing at least the first mailbox
     * serialised by {@link MailboxAddress.to_short_display}, if the
     * list contains more mailboxes then an indication of how many
     * additional are present.
     */
gchar*
util_email_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* first_recipient = NULL;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	const gchar* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gchar* _tmp14_;
	gchar* result = NULL;
#line 111 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (mailboxes, GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES), NULL);
#line 112 "../src/client/util/util-email.vala"
	_tmp0_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 112 "../src/client/util/util-email.vala"
	_tmp1_ = _tmp0_;
#line 112 "../src/client/util/util-email.vala"
	if (_tmp1_ == 0) {
#line 699 "util-email.c"
		gchar* _tmp2_;
#line 116 "../src/client/util/util-email.vala"
		_tmp2_ = g_strdup (_ ("(No recipients)"));
#line 116 "../src/client/util/util-email.vala"
		result = _tmp2_;
#line 116 "../src/client/util/util-email.vala"
		return result;
#line 707 "util-email.c"
	}
#line 120 "../src/client/util/util-email.vala"
	_tmp3_ = geary_rf_c822_mailbox_addresses_get (mailboxes, 0);
#line 120 "../src/client/util/util-email.vala"
	_tmp4_ = _tmp3_;
#line 120 "../src/client/util/util-email.vala"
	_tmp5_ = geary_rf_c822_mailbox_address_to_short_display (_tmp4_);
#line 120 "../src/client/util/util-email.vala"
	_tmp6_ = _tmp5_;
#line 120 "../src/client/util/util-email.vala"
	_g_object_unref0 (_tmp4_);
#line 120 "../src/client/util/util-email.vala"
	first_recipient = _tmp6_;
#line 121 "../src/client/util/util-email.vala"
	_tmp7_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 121 "../src/client/util/util-email.vala"
	_tmp8_ = _tmp7_;
#line 121 "../src/client/util/util-email.vala"
	if (_tmp8_ == 1) {
#line 122 "../src/client/util/util-email.vala"
		result = first_recipient;
#line 122 "../src/client/util/util-email.vala"
		return result;
#line 731 "util-email.c"
	}
#line 129 "../src/client/util/util-email.vala"
	_tmp9_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 129 "../src/client/util/util-email.vala"
	_tmp10_ = _tmp9_;
#line 129 "../src/client/util/util-email.vala"
	_tmp11_ = first_recipient;
#line 129 "../src/client/util/util-email.vala"
	_tmp12_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 129 "../src/client/util/util-email.vala"
	_tmp13_ = _tmp12_;
#line 129 "../src/client/util/util-email.vala"
	_tmp14_ = g_strdup_printf (ngettext ("%s and %d other", "%s and %d others", (gulong) (_tmp10_ - 1)), _tmp11_, _tmp13_ - 1);
#line 129 "../src/client/util/util-email.vala"
	result = _tmp14_;
#line 129 "../src/client/util/util-email.vala"
	_g_free0 (first_recipient);
#line 129 "../src/client/util/util-email.vala"
	return result;
#line 751 "util-email.c"
}

/**
     * Returns a quoted text string needed for a reply.
     *
     * If there's no message body in the supplied email or quote text, this
     * function will return the empty string.
     *
     * If html_format is true, the message will be quoted in HTML format.
     * Otherwise it will be in plain text.
     */
gchar*
util_email_quote_email_for_reply (GearyEmail* email,
                                  const gchar* quote,
                                  UtilDateClockFormat clock_format,
                                  GearyRFC822TextFormat format)
{
	gboolean _tmp0_ = FALSE;
	GearyRFC822Text* _tmp1_;
	GearyRFC822Text* _tmp2_;
	gchar* quoted = NULL;
	gchar* _tmp4_;
	gchar* DATE_FORMAT = NULL;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GearyRFC822Date* _tmp7_;
	GearyRFC822Date* _tmp8_;
	const gchar* _tmp55_;
	gchar* _tmp56_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 145 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), NULL);
#line 149 "../src/client/util/util-email.vala"
	_tmp1_ = geary_email_get_body (email);
#line 149 "../src/client/util/util-email.vala"
	_tmp2_ = _tmp1_;
#line 149 "../src/client/util/util-email.vala"
	if (_tmp2_ == NULL) {
#line 149 "../src/client/util/util-email.vala"
		_tmp0_ = quote == NULL;
#line 793 "util-email.c"
	} else {
#line 149 "../src/client/util/util-email.vala"
		_tmp0_ = FALSE;
#line 797 "util-email.c"
	}
#line 149 "../src/client/util/util-email.vala"
	if (_tmp0_) {
#line 801 "util-email.c"
		gchar* _tmp3_;
#line 150 "../src/client/util/util-email.vala"
		_tmp3_ = g_strdup ("");
#line 150 "../src/client/util/util-email.vala"
		result = _tmp3_;
#line 150 "../src/client/util/util-email.vala"
		return result;
#line 809 "util-email.c"
	}
#line 152 "../src/client/util/util-email.vala"
	_tmp4_ = g_strdup ("");
#line 152 "../src/client/util/util-email.vala"
	quoted = _tmp4_;
#line 154 "../src/client/util/util-email.vala"
	_tmp5_ = util_date_get_full_date (clock_format);
#line 154 "../src/client/util/util-email.vala"
	DATE_FORMAT = _tmp5_;
#line 156 "../src/client/util/util-email.vala"
	_tmp7_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 156 "../src/client/util/util-email.vala"
	_tmp8_ = _tmp7_;
#line 156 "../src/client/util/util-email.vala"
	if (_tmp8_ != NULL) {
#line 825 "util-email.c"
		GearyRFC822MailboxAddresses* _tmp9_;
		GearyRFC822MailboxAddresses* _tmp10_;
#line 156 "../src/client/util/util-email.vala"
		_tmp9_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 156 "../src/client/util/util-email.vala"
		_tmp10_ = _tmp9_;
#line 156 "../src/client/util/util-email.vala"
		_tmp6_ = _tmp10_ != NULL;
#line 834 "util-email.c"
	} else {
#line 156 "../src/client/util/util-email.vala"
		_tmp6_ = FALSE;
#line 838 "util-email.c"
	}
#line 156 "../src/client/util/util-email.vala"
	if (_tmp6_) {
#line 842 "util-email.c"
		gchar* QUOTED_LABEL = NULL;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GearyRFC822Date* _tmp14_;
		GearyRFC822Date* _tmp15_;
		GDateTime* _tmp16_;
		GDateTime* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GearyRFC822MailboxAddresses* _tmp21_;
		GearyRFC822MailboxAddresses* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 160 "../src/client/util/util-email.vala"
		_tmp11_ = g_strdup (_ ("On %1$s, %2$s wrote:"));
#line 160 "../src/client/util/util-email.vala"
		QUOTED_LABEL = _tmp11_;
#line 161 "../src/client/util/util-email.vala"
		_tmp12_ = quoted;
#line 161 "../src/client/util/util-email.vala"
		_tmp13_ = QUOTED_LABEL;
#line 161 "../src/client/util/util-email.vala"
		_tmp14_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 161 "../src/client/util/util-email.vala"
		_tmp15_ = _tmp14_;
#line 161 "../src/client/util/util-email.vala"
		_tmp16_ = geary_rf_c822_date_get_value (_tmp15_);
#line 161 "../src/client/util/util-email.vala"
		_tmp17_ = _tmp16_;
#line 161 "../src/client/util/util-email.vala"
		_tmp18_ = DATE_FORMAT;
#line 161 "../src/client/util/util-email.vala"
		_tmp19_ = g_date_time_format (_tmp17_, _tmp18_);
#line 161 "../src/client/util/util-email.vala"
		_tmp20_ = _tmp19_;
#line 161 "../src/client/util/util-email.vala"
		_tmp21_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 161 "../src/client/util/util-email.vala"
		_tmp22_ = _tmp21_;
#line 161 "../src/client/util/util-email.vala"
		_tmp23_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp22_, format);
#line 161 "../src/client/util/util-email.vala"
		_tmp24_ = _tmp23_;
#line 161 "../src/client/util/util-email.vala"
		_tmp25_ = g_strdup_printf (_tmp13_, _tmp20_, _tmp24_);
#line 161 "../src/client/util/util-email.vala"
		_tmp26_ = _tmp25_;
#line 161 "../src/client/util/util-email.vala"
		_tmp27_ = g_strconcat (_tmp12_, _tmp26_, NULL);
#line 161 "../src/client/util/util-email.vala"
		_g_free0 (quoted);
#line 161 "../src/client/util/util-email.vala"
		quoted = _tmp27_;
#line 161 "../src/client/util/util-email.vala"
		_g_free0 (_tmp26_);
#line 161 "../src/client/util/util-email.vala"
		_g_free0 (_tmp24_);
#line 161 "../src/client/util/util-email.vala"
		_g_free0 (_tmp20_);
#line 156 "../src/client/util/util-email.vala"
		_g_free0 (QUOTED_LABEL);
#line 909 "util-email.c"
	} else {
		GearyRFC822MailboxAddresses* _tmp28_;
		GearyRFC822MailboxAddresses* _tmp29_;
#line 164 "../src/client/util/util-email.vala"
		_tmp28_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 164 "../src/client/util/util-email.vala"
		_tmp29_ = _tmp28_;
#line 164 "../src/client/util/util-email.vala"
		if (_tmp29_ != NULL) {
#line 919 "util-email.c"
			gchar* QUOTED_LABEL = NULL;
			gchar* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			GearyRFC822MailboxAddresses* _tmp33_;
			GearyRFC822MailboxAddresses* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 167 "../src/client/util/util-email.vala"
			_tmp30_ = g_strdup (_ ("%s wrote:"));
#line 167 "../src/client/util/util-email.vala"
			QUOTED_LABEL = _tmp30_;
#line 168 "../src/client/util/util-email.vala"
			_tmp31_ = quoted;
#line 168 "../src/client/util/util-email.vala"
			_tmp32_ = QUOTED_LABEL;
#line 168 "../src/client/util/util-email.vala"
			_tmp33_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 168 "../src/client/util/util-email.vala"
			_tmp34_ = _tmp33_;
#line 168 "../src/client/util/util-email.vala"
			_tmp35_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp34_, format);
#line 168 "../src/client/util/util-email.vala"
			_tmp36_ = _tmp35_;
#line 168 "../src/client/util/util-email.vala"
			_tmp37_ = g_strdup_printf (_tmp32_, _tmp36_);
#line 168 "../src/client/util/util-email.vala"
			_tmp38_ = _tmp37_;
#line 168 "../src/client/util/util-email.vala"
			_tmp39_ = g_strconcat (_tmp31_, _tmp38_, NULL);
#line 168 "../src/client/util/util-email.vala"
			_g_free0 (quoted);
#line 168 "../src/client/util/util-email.vala"
			quoted = _tmp39_;
#line 168 "../src/client/util/util-email.vala"
			_g_free0 (_tmp38_);
#line 168 "../src/client/util/util-email.vala"
			_g_free0 (_tmp36_);
#line 164 "../src/client/util/util-email.vala"
			_g_free0 (QUOTED_LABEL);
#line 963 "util-email.c"
		} else {
			GearyRFC822Date* _tmp40_;
			GearyRFC822Date* _tmp41_;
#line 170 "../src/client/util/util-email.vala"
			_tmp40_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 170 "../src/client/util/util-email.vala"
			_tmp41_ = _tmp40_;
#line 170 "../src/client/util/util-email.vala"
			if (_tmp41_ != NULL) {
#line 973 "util-email.c"
				gchar* QUOTED_LABEL = NULL;
				gchar* _tmp42_;
				const gchar* _tmp43_;
				const gchar* _tmp44_;
				GearyRFC822Date* _tmp45_;
				GearyRFC822Date* _tmp46_;
				GDateTime* _tmp47_;
				GDateTime* _tmp48_;
				const gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				gchar* _tmp54_;
#line 173 "../src/client/util/util-email.vala"
				_tmp42_ = g_strdup (_ ("On %s:"));
#line 173 "../src/client/util/util-email.vala"
				QUOTED_LABEL = _tmp42_;
#line 174 "../src/client/util/util-email.vala"
				_tmp43_ = quoted;
#line 174 "../src/client/util/util-email.vala"
				_tmp44_ = QUOTED_LABEL;
#line 174 "../src/client/util/util-email.vala"
				_tmp45_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 174 "../src/client/util/util-email.vala"
				_tmp46_ = _tmp45_;
#line 174 "../src/client/util/util-email.vala"
				_tmp47_ = geary_rf_c822_date_get_value (_tmp46_);
#line 174 "../src/client/util/util-email.vala"
				_tmp48_ = _tmp47_;
#line 174 "../src/client/util/util-email.vala"
				_tmp49_ = DATE_FORMAT;
#line 174 "../src/client/util/util-email.vala"
				_tmp50_ = g_date_time_format (_tmp48_, _tmp49_);
#line 174 "../src/client/util/util-email.vala"
				_tmp51_ = _tmp50_;
#line 174 "../src/client/util/util-email.vala"
				_tmp52_ = g_strdup_printf (_tmp44_, _tmp51_);
#line 174 "../src/client/util/util-email.vala"
				_tmp53_ = _tmp52_;
#line 174 "../src/client/util/util-email.vala"
				_tmp54_ = g_strconcat (_tmp43_, _tmp53_, NULL);
#line 174 "../src/client/util/util-email.vala"
				_g_free0 (quoted);
#line 174 "../src/client/util/util-email.vala"
				quoted = _tmp54_;
#line 174 "../src/client/util/util-email.vala"
				_g_free0 (_tmp53_);
#line 174 "../src/client/util/util-email.vala"
				_g_free0 (_tmp51_);
#line 170 "../src/client/util/util-email.vala"
				_g_free0 (QUOTED_LABEL);
#line 1026 "util-email.c"
			}
		}
	}
#line 177 "../src/client/util/util-email.vala"
	_tmp55_ = quoted;
#line 177 "../src/client/util/util-email.vala"
	_tmp56_ = g_strconcat (_tmp55_, "<br />", NULL);
#line 177 "../src/client/util/util-email.vala"
	_g_free0 (quoted);
#line 177 "../src/client/util/util-email.vala"
	quoted = _tmp56_;
#line 1038 "util-email.c"
	{
		gchar* _tmp57_ = NULL;
		gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
#line 179 "../src/client/util/util-email.vala"
		_tmp58_ = util_email_quote_body (email, quote, TRUE, format, &_inner_error0_);
#line 179 "../src/client/util/util-email.vala"
		_tmp57_ = _tmp58_;
#line 179 "../src/client/util/util-email.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1052 "util-email.c"
			goto __catch187_g_error;
		}
#line 179 "../src/client/util/util-email.vala"
		_tmp59_ = quoted;
#line 179 "../src/client/util/util-email.vala"
		_tmp60_ = _tmp57_;
#line 179 "../src/client/util/util-email.vala"
		_tmp57_ = NULL;
#line 179 "../src/client/util/util-email.vala"
		_tmp61_ = _tmp60_;
#line 179 "../src/client/util/util-email.vala"
		_tmp62_ = g_strconcat (_tmp59_, _tmp61_, NULL);
#line 179 "../src/client/util/util-email.vala"
		_g_free0 (quoted);
#line 179 "../src/client/util/util-email.vala"
		quoted = _tmp62_;
#line 179 "../src/client/util/util-email.vala"
		_g_free0 (_tmp61_);
#line 178 "../src/client/util/util-email.vala"
		_g_free0 (_tmp57_);
#line 1073 "util-email.c"
	}
	goto __finally187;
	__catch187_g_error:
	{
		GError* err = NULL;
		GError* _tmp63_;
		const gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
#line 178 "../src/client/util/util-email.vala"
		err = _inner_error0_;
#line 178 "../src/client/util/util-email.vala"
		_inner_error0_ = NULL;
#line 181 "../src/client/util/util-email.vala"
		_tmp63_ = err;
#line 181 "../src/client/util/util-email.vala"
		_tmp64_ = _tmp63_->message;
#line 181 "../src/client/util/util-email.vala"
		_tmp65_ = g_strdup_printf ("Failed to quote body for replying: %s", _tmp64_);
#line 181 "../src/client/util/util-email.vala"
		_tmp66_ = _tmp65_;
#line 181 "../src/client/util/util-email.vala"
		g_debug ("util-email.vala:181: %s", _tmp66_);
#line 181 "../src/client/util/util-email.vala"
		_g_free0 (_tmp66_);
#line 178 "../src/client/util/util-email.vala"
		_g_error_free0 (err);
#line 1101 "util-email.c"
	}
	__finally187:
#line 178 "../src/client/util/util-email.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "../src/client/util/util-email.vala"
		_g_free0 (DATE_FORMAT);
#line 178 "../src/client/util/util-email.vala"
		_g_free0 (quoted);
#line 178 "../src/client/util/util-email.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 178 "../src/client/util/util-email.vala"
		g_clear_error (&_inner_error0_);
#line 178 "../src/client/util/util-email.vala"
		return NULL;
#line 1116 "util-email.c"
	}
#line 184 "../src/client/util/util-email.vala"
	result = quoted;
#line 184 "../src/client/util/util-email.vala"
	_g_free0 (DATE_FORMAT);
#line 184 "../src/client/util/util-email.vala"
	return result;
#line 1124 "util-email.c"
}

/**
     * Returns a quoted text string needed for a forward.
     *
     * If there's no message body in the supplied email or quote text, this
     * function will return the empty string.
     *
     * If html_format is true, the message will be quoted in HTML format.
     * Otherwise it will be in plain text.
     */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1155 "util-email.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1159 "util-email.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1165 "util-email.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1169 "util-email.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1173 "util-email.c"
		gchar* _tmp2_;
#line 1482 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1482 "glib-2.0.vapi"
		result = _tmp2_;
#line 1482 "glib-2.0.vapi"
		return result;
#line 1181 "util-email.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1485 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1485 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1485 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1485 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1485 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1485 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1485 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1209 "util-email.c"
				goto __catch188_g_regex_error;
			}
#line 1485 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "glib-2.0.vapi"
			return NULL;
#line 1218 "util-email.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1486 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1486 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1486 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1232 "util-email.c"
				goto __catch188_g_regex_error;
			}
#line 1486 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
			return NULL;
#line 1241 "util-email.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1486 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1486 "glib-2.0.vapi"
		result = _tmp10_;
#line 1486 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1486 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
		return result;
#line 1255 "util-email.c"
	}
	goto __finally188;
	__catch188_g_regex_error:
	{
		GError* e = NULL;
#line 1484 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1484 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1488 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1484 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 1269 "util-email.c"
	}
	__finally188:
#line 1484 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1484 "glib-2.0.vapi"
		return NULL;
#line 1280 "util-email.c"
	}
}

gchar*
util_email_quote_email_for_forward (GearyEmail* email,
                                    const gchar* quote,
                                    GearyRFC822TextFormat format)
{
	gboolean _tmp0_ = FALSE;
	GearyRFC822Text* _tmp1_;
	GearyRFC822Text* _tmp2_;
#line 200 "../src/client/util/util-email.vala"
	static const char HEADER_FORMAT[] = "%s %s\n";
#line 1294 "util-email.c"
	gchar* quoted = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* from_line = NULL;
	GearyRFC822MailboxAddresses* _tmp7_;
	GearyRFC822MailboxAddresses* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp16_ = NULL;
	GearyRFC822Subject* _tmp17_;
	GearyRFC822Subject* _tmp18_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_ = NULL;
	GearyRFC822Date* _tmp28_;
	GearyRFC822Date* _tmp29_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* to_line = NULL;
	GearyRFC822MailboxAddresses* _tmp38_;
	GearyRFC822MailboxAddresses* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	gchar* cc_line = NULL;
	GearyRFC822MailboxAddresses* _tmp47_;
	GearyRFC822MailboxAddresses* _tmp48_;
	gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp56_;
	gchar* _tmp57_;
	const gchar* _tmp58_;
	gchar* _tmp59_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 196 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), NULL);
#line 197 "../src/client/util/util-email.vala"
	_tmp1_ = geary_email_get_body (email);
#line 197 "../src/client/util/util-email.vala"
	_tmp2_ = _tmp1_;
#line 197 "../src/client/util/util-email.vala"
	if (_tmp2_ == NULL) {
#line 197 "../src/client/util/util-email.vala"
		_tmp0_ = quote == NULL;
#line 1344 "util-email.c"
	} else {
#line 197 "../src/client/util/util-email.vala"
		_tmp0_ = FALSE;
#line 1348 "util-email.c"
	}
#line 197 "../src/client/util/util-email.vala"
	if (_tmp0_) {
#line 1352 "util-email.c"
		gchar* _tmp3_;
#line 198 "../src/client/util/util-email.vala"
		_tmp3_ = g_strdup ("");
#line 198 "../src/client/util/util-email.vala"
		result = _tmp3_;
#line 198 "../src/client/util/util-email.vala"
		return result;
#line 1360 "util-email.c"
	}
#line 202 "../src/client/util/util-email.vala"
	_tmp4_ = g_strdup (_ ("---------- Forwarded message ----------"));
#line 202 "../src/client/util/util-email.vala"
	quoted = _tmp4_;
#line 203 "../src/client/util/util-email.vala"
	_tmp5_ = quoted;
#line 203 "../src/client/util/util-email.vala"
	_tmp6_ = g_strconcat (_tmp5_, "\n", NULL);
#line 203 "../src/client/util/util-email.vala"
	_g_free0 (quoted);
#line 203 "../src/client/util/util-email.vala"
	quoted = _tmp6_;
#line 204 "../src/client/util/util-email.vala"
	_tmp7_ = geary_email_header_set_get_from (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 204 "../src/client/util/util-email.vala"
	_tmp8_ = _tmp7_;
#line 204 "../src/client/util/util-email.vala"
	_tmp9_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp8_, format);
#line 204 "../src/client/util/util-email.vala"
	from_line = _tmp9_;
#line 205 "../src/client/util/util-email.vala"
	_tmp10_ = from_line;
#line 205 "../src/client/util/util-email.vala"
	if (!geary_string_is_empty_or_whitespace (_tmp10_)) {
#line 1386 "util-email.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 207 "../src/client/util/util-email.vala"
		_tmp11_ = quoted;
#line 207 "../src/client/util/util-email.vala"
		_tmp12_ = from_line;
#line 207 "../src/client/util/util-email.vala"
		_tmp13_ = g_strdup_printf (HEADER_FORMAT, _ ("From:"), _tmp12_);
#line 207 "../src/client/util/util-email.vala"
		_tmp14_ = _tmp13_;
#line 207 "../src/client/util/util-email.vala"
		_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 207 "../src/client/util/util-email.vala"
		_g_free0 (quoted);
#line 207 "../src/client/util/util-email.vala"
		quoted = _tmp15_;
#line 207 "../src/client/util/util-email.vala"
		_g_free0 (_tmp14_);
#line 1408 "util-email.c"
	}
#line 210 "../src/client/util/util-email.vala"
	_tmp17_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 210 "../src/client/util/util-email.vala"
	_tmp18_ = _tmp17_;
#line 210 "../src/client/util/util-email.vala"
	if (_tmp18_ != NULL) {
#line 1416 "util-email.c"
		GearyRFC822Subject* _tmp19_;
		GearyRFC822Subject* _tmp20_;
		gchar* _tmp21_;
#line 210 "../src/client/util/util-email.vala"
		_tmp19_ = geary_email_header_set_get_subject (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 210 "../src/client/util/util-email.vala"
		_tmp20_ = _tmp19_;
#line 210 "../src/client/util/util-email.vala"
		_tmp21_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 210 "../src/client/util/util-email.vala"
		_g_free0 (_tmp16_);
#line 210 "../src/client/util/util-email.vala"
		_tmp16_ = _tmp21_;
#line 1430 "util-email.c"
	} else {
		gchar* _tmp22_;
#line 210 "../src/client/util/util-email.vala"
		_tmp22_ = g_strdup ("");
#line 210 "../src/client/util/util-email.vala"
		_g_free0 (_tmp16_);
#line 210 "../src/client/util/util-email.vala"
		_tmp16_ = _tmp22_;
#line 1439 "util-email.c"
	}
#line 210 "../src/client/util/util-email.vala"
	_tmp23_ = quoted;
#line 210 "../src/client/util/util-email.vala"
	_tmp24_ = g_strdup_printf (HEADER_FORMAT, _ ("Subject:"), _tmp16_);
#line 210 "../src/client/util/util-email.vala"
	_tmp25_ = _tmp24_;
#line 210 "../src/client/util/util-email.vala"
	_tmp26_ = g_strconcat (_tmp23_, _tmp25_, NULL);
#line 210 "../src/client/util/util-email.vala"
	_g_free0 (quoted);
#line 210 "../src/client/util/util-email.vala"
	quoted = _tmp26_;
#line 210 "../src/client/util/util-email.vala"
	_g_free0 (_tmp25_);
#line 212 "../src/client/util/util-email.vala"
	_tmp28_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 212 "../src/client/util/util-email.vala"
	_tmp29_ = _tmp28_;
#line 212 "../src/client/util/util-email.vala"
	if (_tmp29_ != NULL) {
#line 1461 "util-email.c"
		GearyRFC822Date* _tmp30_;
		GearyRFC822Date* _tmp31_;
		gchar* _tmp32_;
#line 212 "../src/client/util/util-email.vala"
		_tmp30_ = geary_email_header_set_get_date (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 212 "../src/client/util/util-email.vala"
		_tmp31_ = _tmp30_;
#line 212 "../src/client/util/util-email.vala"
		_tmp32_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 212 "../src/client/util/util-email.vala"
		_g_free0 (_tmp27_);
#line 212 "../src/client/util/util-email.vala"
		_tmp27_ = _tmp32_;
#line 1475 "util-email.c"
	} else {
		gchar* _tmp33_;
#line 212 "../src/client/util/util-email.vala"
		_tmp33_ = g_strdup ("");
#line 212 "../src/client/util/util-email.vala"
		_g_free0 (_tmp27_);
#line 212 "../src/client/util/util-email.vala"
		_tmp27_ = _tmp33_;
#line 1484 "util-email.c"
	}
#line 212 "../src/client/util/util-email.vala"
	_tmp34_ = quoted;
#line 212 "../src/client/util/util-email.vala"
	_tmp35_ = g_strdup_printf (HEADER_FORMAT, _ ("Date:"), _tmp27_);
#line 212 "../src/client/util/util-email.vala"
	_tmp36_ = _tmp35_;
#line 212 "../src/client/util/util-email.vala"
	_tmp37_ = g_strconcat (_tmp34_, _tmp36_, NULL);
#line 212 "../src/client/util/util-email.vala"
	_g_free0 (quoted);
#line 212 "../src/client/util/util-email.vala"
	quoted = _tmp37_;
#line 212 "../src/client/util/util-email.vala"
	_g_free0 (_tmp36_);
#line 213 "../src/client/util/util-email.vala"
	_tmp38_ = geary_email_header_set_get_to (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 213 "../src/client/util/util-email.vala"
	_tmp39_ = _tmp38_;
#line 213 "../src/client/util/util-email.vala"
	_tmp40_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp39_, format);
#line 213 "../src/client/util/util-email.vala"
	to_line = _tmp40_;
#line 214 "../src/client/util/util-email.vala"
	_tmp41_ = to_line;
#line 214 "../src/client/util/util-email.vala"
	if (!geary_string_is_empty_or_whitespace (_tmp41_)) {
#line 1512 "util-email.c"
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
#line 216 "../src/client/util/util-email.vala"
		_tmp42_ = quoted;
#line 216 "../src/client/util/util-email.vala"
		_tmp43_ = to_line;
#line 216 "../src/client/util/util-email.vala"
		_tmp44_ = g_strdup_printf (HEADER_FORMAT, _ ("To:"), _tmp43_);
#line 216 "../src/client/util/util-email.vala"
		_tmp45_ = _tmp44_;
#line 216 "../src/client/util/util-email.vala"
		_tmp46_ = g_strconcat (_tmp42_, _tmp45_, NULL);
#line 216 "../src/client/util/util-email.vala"
		_g_free0 (quoted);
#line 216 "../src/client/util/util-email.vala"
		quoted = _tmp46_;
#line 216 "../src/client/util/util-email.vala"
		_g_free0 (_tmp45_);
#line 1534 "util-email.c"
	}
#line 218 "../src/client/util/util-email.vala"
	_tmp47_ = geary_email_header_set_get_cc (G_TYPE_CHECK_INSTANCE_CAST (email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
#line 218 "../src/client/util/util-email.vala"
	_tmp48_ = _tmp47_;
#line 218 "../src/client/util/util-email.vala"
	_tmp49_ = geary_rf_c822_utils_email_addresses_for_reply (_tmp48_, format);
#line 218 "../src/client/util/util-email.vala"
	cc_line = _tmp49_;
#line 219 "../src/client/util/util-email.vala"
	_tmp50_ = cc_line;
#line 219 "../src/client/util/util-email.vala"
	if (!geary_string_is_empty_or_whitespace (_tmp50_)) {
#line 1548 "util-email.c"
		const gchar* _tmp51_;
		const gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 221 "../src/client/util/util-email.vala"
		_tmp51_ = quoted;
#line 221 "../src/client/util/util-email.vala"
		_tmp52_ = cc_line;
#line 221 "../src/client/util/util-email.vala"
		_tmp53_ = g_strdup_printf (HEADER_FORMAT, _ ("Cc:"), _tmp52_);
#line 221 "../src/client/util/util-email.vala"
		_tmp54_ = _tmp53_;
#line 221 "../src/client/util/util-email.vala"
		_tmp55_ = g_strconcat (_tmp51_, _tmp54_, NULL);
#line 221 "../src/client/util/util-email.vala"
		_g_free0 (quoted);
#line 221 "../src/client/util/util-email.vala"
		quoted = _tmp55_;
#line 221 "../src/client/util/util-email.vala"
		_g_free0 (_tmp54_);
#line 1570 "util-email.c"
	}
#line 223 "../src/client/util/util-email.vala"
	_tmp56_ = quoted;
#line 223 "../src/client/util/util-email.vala"
	_tmp57_ = g_strconcat (_tmp56_, "\n", NULL);
#line 223 "../src/client/util/util-email.vala"
	_g_free0 (quoted);
#line 223 "../src/client/util/util-email.vala"
	quoted = _tmp57_;
#line 224 "../src/client/util/util-email.vala"
	_tmp58_ = quoted;
#line 224 "../src/client/util/util-email.vala"
	_tmp59_ = string_replace (_tmp58_, "\n", "<br />");
#line 224 "../src/client/util/util-email.vala"
	_g_free0 (quoted);
#line 224 "../src/client/util/util-email.vala"
	quoted = _tmp59_;
#line 1588 "util-email.c"
	{
		gchar* _tmp60_ = NULL;
		gchar* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		gchar* _tmp65_;
#line 226 "../src/client/util/util-email.vala"
		_tmp61_ = util_email_quote_body (email, quote, FALSE, format, &_inner_error0_);
#line 226 "../src/client/util/util-email.vala"
		_tmp60_ = _tmp61_;
#line 226 "../src/client/util/util-email.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1602 "util-email.c"
			goto __catch189_g_error;
		}
#line 226 "../src/client/util/util-email.vala"
		_tmp62_ = quoted;
#line 226 "../src/client/util/util-email.vala"
		_tmp63_ = _tmp60_;
#line 226 "../src/client/util/util-email.vala"
		_tmp60_ = NULL;
#line 226 "../src/client/util/util-email.vala"
		_tmp64_ = _tmp63_;
#line 226 "../src/client/util/util-email.vala"
		_tmp65_ = g_strconcat (_tmp62_, _tmp64_, NULL);
#line 226 "../src/client/util/util-email.vala"
		_g_free0 (quoted);
#line 226 "../src/client/util/util-email.vala"
		quoted = _tmp65_;
#line 226 "../src/client/util/util-email.vala"
		_g_free0 (_tmp64_);
#line 225 "../src/client/util/util-email.vala"
		_g_free0 (_tmp60_);
#line 1623 "util-email.c"
	}
	goto __finally189;
	__catch189_g_error:
	{
		GError* err = NULL;
		GError* _tmp66_;
		const gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
#line 225 "../src/client/util/util-email.vala"
		err = _inner_error0_;
#line 225 "../src/client/util/util-email.vala"
		_inner_error0_ = NULL;
#line 228 "../src/client/util/util-email.vala"
		_tmp66_ = err;
#line 228 "../src/client/util/util-email.vala"
		_tmp67_ = _tmp66_->message;
#line 228 "../src/client/util/util-email.vala"
		_tmp68_ = g_strdup_printf ("Failed to quote body for forwarding: %s", _tmp67_);
#line 228 "../src/client/util/util-email.vala"
		_tmp69_ = _tmp68_;
#line 228 "../src/client/util/util-email.vala"
		g_debug ("util-email.vala:228: %s", _tmp69_);
#line 228 "../src/client/util/util-email.vala"
		_g_free0 (_tmp69_);
#line 225 "../src/client/util/util-email.vala"
		_g_error_free0 (err);
#line 1651 "util-email.c"
	}
	__finally189:
#line 225 "../src/client/util/util-email.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../src/client/util/util-email.vala"
		_g_free0 (cc_line);
#line 225 "../src/client/util/util-email.vala"
		_g_free0 (to_line);
#line 225 "../src/client/util/util-email.vala"
		_g_free0 (_tmp27_);
#line 225 "../src/client/util/util-email.vala"
		_g_free0 (_tmp16_);
#line 225 "../src/client/util/util-email.vala"
		_g_free0 (from_line);
#line 225 "../src/client/util/util-email.vala"
		_g_free0 (quoted);
#line 225 "../src/client/util/util-email.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 225 "../src/client/util/util-email.vala"
		g_clear_error (&_inner_error0_);
#line 225 "../src/client/util/util-email.vala"
		return NULL;
#line 1674 "util-email.c"
	}
#line 230 "../src/client/util/util-email.vala"
	result = quoted;
#line 230 "../src/client/util/util-email.vala"
	_g_free0 (cc_line);
#line 230 "../src/client/util/util-email.vala"
	_g_free0 (to_line);
#line 230 "../src/client/util/util-email.vala"
	_g_free0 (_tmp27_);
#line 230 "../src/client/util/util-email.vala"
	_g_free0 (_tmp16_);
#line 230 "../src/client/util/util-email.vala"
	_g_free0 (from_line);
#line 230 "../src/client/util/util-email.vala"
	return result;
#line 1690 "util-email.c"
}

gchar*
util_email_quote_body (GearyEmail* email,
                       const gchar* html_quote,
                       gboolean use_quotes,
                       GearyRFC822TextFormat format,
                       GError** error)
{
	GearyRFC822Message* message = NULL;
	GearyRFC822Message* _tmp0_;
	gchar* body_text = NULL;
	gboolean _tmp16_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 233 "../src/client/util/util-email.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (email, GEARY_TYPE_EMAIL), NULL);
#line 238 "../src/client/util/util-email.vala"
	_tmp0_ = geary_email_get_message (email, &_inner_error0_);
#line 238 "../src/client/util/util-email.vala"
	message = _tmp0_;
#line 238 "../src/client/util/util-email.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 238 "../src/client/util/util-email.vala"
		g_propagate_error (error, _inner_error0_);
#line 238 "../src/client/util/util-email.vala"
		return NULL;
#line 1718 "util-email.c"
	}
#line 239 "../src/client/util/util-email.vala"
	body_text = NULL;
#line 240 "../src/client/util/util-email.vala"
	if (geary_string_is_empty (html_quote)) {
#line 241 "../src/client/util/util-email.vala"
		switch (format) {
#line 241 "../src/client/util/util-email.vala"
			case GEARY_RF_C822_TEXT_FORMAT_HTML:
#line 1728 "util-email.c"
			{
				gchar* _tmp1_ = NULL;
				GearyRFC822Message* _tmp2_;
				gchar* _tmp7_;
#line 243 "../src/client/util/util-email.vala"
				_tmp2_ = message;
#line 243 "../src/client/util/util-email.vala"
				if (geary_rf_c822_message_has_html_body (_tmp2_)) {
#line 1737 "util-email.c"
					GearyRFC822Message* _tmp3_;
					gchar* _tmp4_;
#line 244 "../src/client/util/util-email.vala"
					_tmp3_ = message;
#line 244 "../src/client/util/util-email.vala"
					_tmp4_ = geary_rf_c822_message_get_html_body (_tmp3_, NULL, NULL, &_inner_error0_);
#line 244 "../src/client/util/util-email.vala"
					_g_free0 (_tmp1_);
#line 244 "../src/client/util/util-email.vala"
					_tmp1_ = _tmp4_;
#line 244 "../src/client/util/util-email.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 244 "../src/client/util/util-email.vala"
						g_propagate_error (error, _inner_error0_);
#line 244 "../src/client/util/util-email.vala"
						_g_free0 (_tmp1_);
#line 244 "../src/client/util/util-email.vala"
						_g_free0 (body_text);
#line 244 "../src/client/util/util-email.vala"
						_g_object_unref0 (message);
#line 244 "../src/client/util/util-email.vala"
						return NULL;
#line 1760 "util-email.c"
					}
				} else {
					GearyRFC822Message* _tmp5_;
					gchar* _tmp6_;
#line 245 "../src/client/util/util-email.vala"
					_tmp5_ = message;
#line 245 "../src/client/util/util-email.vala"
					_tmp6_ = geary_rf_c822_message_get_plain_body (_tmp5_, TRUE, NULL, NULL, &_inner_error0_);
#line 245 "../src/client/util/util-email.vala"
					_g_free0 (_tmp1_);
#line 245 "../src/client/util/util-email.vala"
					_tmp1_ = _tmp6_;
#line 245 "../src/client/util/util-email.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 245 "../src/client/util/util-email.vala"
						g_propagate_error (error, _inner_error0_);
#line 245 "../src/client/util/util-email.vala"
						_g_free0 (_tmp1_);
#line 245 "../src/client/util/util-email.vala"
						_g_free0 (body_text);
#line 245 "../src/client/util/util-email.vala"
						_g_object_unref0 (message);
#line 245 "../src/client/util/util-email.vala"
						return NULL;
#line 1785 "util-email.c"
					}
				}
#line 243 "../src/client/util/util-email.vala"
				_tmp7_ = g_strdup (_tmp1_);
#line 243 "../src/client/util/util-email.vala"
				_g_free0 (body_text);
#line 243 "../src/client/util/util-email.vala"
				body_text = _tmp7_;
#line 246 "../src/client/util/util-email.vala"
				_g_free0 (_tmp1_);
#line 246 "../src/client/util/util-email.vala"
				break;
#line 1798 "util-email.c"
			}
#line 241 "../src/client/util/util-email.vala"
			case GEARY_RF_C822_TEXT_FORMAT_PLAIN:
#line 1802 "util-email.c"
			{
				gchar* _tmp8_ = NULL;
				GearyRFC822Message* _tmp9_;
				gchar* _tmp14_;
#line 249 "../src/client/util/util-email.vala"
				_tmp9_ = message;
#line 249 "../src/client/util/util-email.vala"
				if (geary_rf_c822_message_has_plain_body (_tmp9_)) {
#line 1811 "util-email.c"
					GearyRFC822Message* _tmp10_;
					gchar* _tmp11_;
#line 250 "../src/client/util/util-email.vala"
					_tmp10_ = message;
#line 250 "../src/client/util/util-email.vala"
					_tmp11_ = geary_rf_c822_message_get_plain_body (_tmp10_, TRUE, NULL, NULL, &_inner_error0_);
#line 250 "../src/client/util/util-email.vala"
					_g_free0 (_tmp8_);
#line 250 "../src/client/util/util-email.vala"
					_tmp8_ = _tmp11_;
#line 250 "../src/client/util/util-email.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "../src/client/util/util-email.vala"
						g_propagate_error (error, _inner_error0_);
#line 250 "../src/client/util/util-email.vala"
						_g_free0 (_tmp8_);
#line 250 "../src/client/util/util-email.vala"
						_g_free0 (body_text);
#line 250 "../src/client/util/util-email.vala"
						_g_object_unref0 (message);
#line 250 "../src/client/util/util-email.vala"
						return NULL;
#line 1834 "util-email.c"
					}
				} else {
					GearyRFC822Message* _tmp12_;
					gchar* _tmp13_;
#line 251 "../src/client/util/util-email.vala"
					_tmp12_ = message;
#line 251 "../src/client/util/util-email.vala"
					_tmp13_ = geary_rf_c822_message_get_html_body (_tmp12_, NULL, NULL, &_inner_error0_);
#line 251 "../src/client/util/util-email.vala"
					_g_free0 (_tmp8_);
#line 251 "../src/client/util/util-email.vala"
					_tmp8_ = _tmp13_;
#line 251 "../src/client/util/util-email.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "../src/client/util/util-email.vala"
						g_propagate_error (error, _inner_error0_);
#line 251 "../src/client/util/util-email.vala"
						_g_free0 (_tmp8_);
#line 251 "../src/client/util/util-email.vala"
						_g_free0 (body_text);
#line 251 "../src/client/util/util-email.vala"
						_g_object_unref0 (message);
#line 251 "../src/client/util/util-email.vala"
						return NULL;
#line 1859 "util-email.c"
					}
				}
#line 249 "../src/client/util/util-email.vala"
				_tmp14_ = g_strdup (_tmp8_);
#line 249 "../src/client/util/util-email.vala"
				_g_free0 (body_text);
#line 249 "../src/client/util/util-email.vala"
				body_text = _tmp14_;
#line 252 "../src/client/util/util-email.vala"
				_g_free0 (_tmp8_);
#line 252 "../src/client/util/util-email.vala"
				break;
#line 1872 "util-email.c"
			}
			default:
#line 241 "../src/client/util/util-email.vala"
			break;
#line 1877 "util-email.c"
		}
	} else {
		gchar* _tmp15_;
#line 255 "../src/client/util/util-email.vala"
		_tmp15_ = g_strdup (html_quote);
#line 255 "../src/client/util/util-email.vala"
		_g_free0 (body_text);
#line 255 "../src/client/util/util-email.vala"
		body_text = _tmp15_;
#line 1887 "util-email.c"
	}
#line 259 "../src/client/util/util-email.vala"
	if (use_quotes) {
#line 1891 "util-email.c"
		const gchar* _tmp17_;
#line 259 "../src/client/util/util-email.vala"
		_tmp17_ = body_text;
#line 259 "../src/client/util/util-email.vala"
		_tmp16_ = !geary_string_is_empty (_tmp17_);
#line 1897 "util-email.c"
	} else {
#line 259 "../src/client/util/util-email.vala"
		_tmp16_ = FALSE;
#line 1901 "util-email.c"
	}
#line 259 "../src/client/util/util-email.vala"
	if (_tmp16_) {
#line 1905 "util-email.c"
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 260 "../src/client/util/util-email.vala"
		_tmp18_ = body_text;
#line 260 "../src/client/util/util-email.vala"
		_tmp19_ = g_strdup_printf ("<blockquote type=\"cite\">%s</blockquote>", _tmp18_);
#line 260 "../src/client/util/util-email.vala"
		_g_free0 (body_text);
#line 260 "../src/client/util/util-email.vala"
		body_text = _tmp19_;
#line 1916 "util-email.c"
	}
#line 262 "../src/client/util/util-email.vala"
	result = body_text;
#line 262 "../src/client/util/util-email.vala"
	_g_object_unref0 (message);
#line 262 "../src/client/util/util-email.vala"
	return result;
#line 1924 "util-email.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

