/* util-international.c generated by valac 0.46.0, the Vala compiler
 * generated from util-international.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <enchant.h>
#include <gio/gio.h>
#include <libxml/tree.h>
#include <libxml/parser.h>

#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block58Data Block58Data;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _enchant_broker_free0(var) ((var == NULL) ? NULL : (var = (enchant_broker_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _Block58Data {
	int _ref_count_;
	gchar** dictionaries;
	gint dictionaries_length1;
	gint _dictionaries_size_;
};

extern GHashTable* util_international_language_names;
GHashTable* util_international_language_names = NULL;
extern GHashTable* util_international_country_names;
GHashTable* util_international_country_names = NULL;

#define TRANSLATABLE "translatable"
#define UTIL_INTERNATIONAL_SYSTEM_LOCALE ""
void util_international_init (const gchar* package_name,
                              const gchar* program_path,
                              const gchar* locale);
gchar* util_international_get_langpack_dir_path (const gchar* program_path);
gchar** util_international_get_available_dictionaries (gint* result_length1);
static Block58Data* block58_data_ref (Block58Data* _data58_);
static void block58_data_unref (void * _userdata_);
static void __lambda7_ (Block58Data* _data58_,
                 const gchar* lang_tag,
                 const gchar* provider_name,
                 const gchar* provider_desc,
                 const gchar* provider_file);
static void _vala_array_add10 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void ___lambda7__enchant_dict_describe_fn (const gchar* lang_tag,
                                           const gchar* provider_name,
                                           const gchar* provider_desc,
                                           const gchar* provider_file,
                                           gpointer self);
static void _g_free0_ (gpointer var);
static gint __lambda8_ (const gchar* dic_a,
                 const gchar* dic_b);
static gint ___lambda8__gcompare_func (gconstpointer a,
                                gconstpointer b);
static void _vala_array_add11 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static gchar** _vala_array_dup7 (gchar** self,
                          int length);
static inline void _g_list_free__g_free0_ (GList* self);
gchar** util_international_get_available_locales (gint* result_length1);
static void _vala_array_add12 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
gchar* util_international_strip_encoding (const gchar* locale);
gchar** util_international_get_user_preferred_languages (gint* result_length1);
static void _vala_array_add13 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
gchar* util_international_language_name_from_locale (const gchar* locale);
gchar* util_international_country_name_from_locale (const gchar* locale);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

void
util_international_init (const gchar* package_name,
                         const gchar* program_path,
                         const gchar* locale)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 19 "../src/client/util/util-international.vala"
	g_return_if_fail (package_name != NULL);
#line 19 "../src/client/util/util-international.vala"
	g_return_if_fail (program_path != NULL);
#line 19 "../src/client/util/util-international.vala"
	g_return_if_fail (locale != NULL);
#line 20 "../src/client/util/util-international.vala"
	setlocale (LC_ALL, locale);
#line 21 "../src/client/util/util-international.vala"
	_tmp0_ = util_international_get_langpack_dir_path (program_path);
#line 21 "../src/client/util/util-international.vala"
	_tmp1_ = _tmp0_;
#line 21 "../src/client/util/util-international.vala"
	bindtextdomain (package_name, _tmp1_);
#line 21 "../src/client/util/util-international.vala"
	_g_free0 (_tmp1_);
#line 22 "../src/client/util/util-international.vala"
	bind_textdomain_codeset (package_name, "UTF-8");
#line 23 "../src/client/util/util-international.vala"
	textdomain (package_name);
#line 123 "util-international.c"
}

gchar*
util_international_get_langpack_dir_path (const gchar* program_path)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 27 "../src/client/util/util-international.vala"
	g_return_val_if_fail (program_path != NULL, NULL);
#line 28 "../src/client/util/util-international.vala"
	_tmp0_ = g_strdup (LANGUAGE_SUPPORT_DIRECTORY);
#line 28 "../src/client/util/util-international.vala"
	result = _tmp0_;
#line 28 "../src/client/util/util-international.vala"
	return result;
#line 139 "util-international.c"
}

/**
     * Returns a sorted list of installed spell-check dictionary languages.
     *
     * Each language is a POSIX-style locale name (ISO/IEC 15897).
     * The list is generated by obtaining the list from Enchant via
     * {@link Enchant.Broker.list_dicts}, discarding generic languages
     * if a regional variant exists (for example, discard "en" if
     * "en_US" is included), then sorted.
     */
static Block58Data*
block58_data_ref (Block58Data* _data58_)
{
#line 40 "../src/client/util/util-international.vala"
	g_atomic_int_inc (&_data58_->_ref_count_);
#line 40 "../src/client/util/util-international.vala"
	return _data58_;
#line 158 "util-international.c"
}

static void
block58_data_unref (void * _userdata_)
{
	Block58Data* _data58_;
	_data58_ = (Block58Data*) _userdata_;
#line 40 "../src/client/util/util-international.vala"
	if (g_atomic_int_dec_and_test (&_data58_->_ref_count_)) {
#line 40 "../src/client/util/util-international.vala"
		_data58_->dictionaries = (_vala_array_free (_data58_->dictionaries, _data58_->dictionaries_length1, (GDestroyNotify) g_free), NULL);
#line 40 "../src/client/util/util-international.vala"
		g_slice_free (Block58Data, _data58_);
#line 172 "util-international.c"
	}
}

static void
_vala_array_add10 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 45 "../src/client/util/util-international.vala"
	if ((*length) == (*size)) {
#line 45 "../src/client/util/util-international.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 45 "../src/client/util/util-international.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 188 "util-international.c"
	}
#line 45 "../src/client/util/util-international.vala"
	(*array)[(*length)++] = value;
#line 45 "../src/client/util/util-international.vala"
	(*array)[*length] = NULL;
#line 194 "util-international.c"
}

static void
__lambda7_ (Block58Data* _data58_,
            const gchar* lang_tag,
            const gchar* provider_name,
            const gchar* provider_desc,
            const gchar* provider_file)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
#line 44 "../src/client/util/util-international.vala"
	g_return_if_fail (lang_tag != NULL);
#line 44 "../src/client/util/util-international.vala"
	g_return_if_fail (provider_name != NULL);
#line 44 "../src/client/util/util-international.vala"
	g_return_if_fail (provider_desc != NULL);
#line 44 "../src/client/util/util-international.vala"
	g_return_if_fail (provider_file != NULL);
#line 45 "../src/client/util/util-international.vala"
	_tmp0_ = _data58_->dictionaries;
#line 45 "../src/client/util/util-international.vala"
	_tmp0__length1 = _data58_->dictionaries_length1;
#line 45 "../src/client/util/util-international.vala"
	_tmp1_ = g_strdup (lang_tag);
#line 45 "../src/client/util/util-international.vala"
	_vala_array_add10 (&_data58_->dictionaries, &_data58_->dictionaries_length1, &_data58_->_dictionaries_size_, _tmp1_);
#line 223 "util-international.c"
}

static void
___lambda7__enchant_dict_describe_fn (const gchar* lang_tag,
                                      const gchar* provider_name,
                                      const gchar* provider_desc,
                                      const gchar* provider_file,
                                      gpointer self)
{
#line 44 "../src/client/util/util-international.vala"
	__lambda7_ (self, lang_tag, provider_name, provider_desc, provider_file);
#line 235 "util-international.c"
}

static void
_g_free0_ (gpointer var)
{
#line 51 "../src/client/util/util-international.vala"
	var = (g_free (var), NULL);
#line 243 "util-international.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 262 "util-international.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
#line 1101 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1102 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1102 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1104 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1104 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 284 "util-international.c"
		gchar* _tmp2_;
#line 1105 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1105 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1105 "glib-2.0.vapi"
		return result;
#line 292 "util-international.c"
	} else {
#line 1107 "glib-2.0.vapi"
		result = -1;
#line 1107 "glib-2.0.vapi"
		return result;
#line 298 "util-international.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 322 "util-international.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 331 "util-international.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 350 "util-international.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 354 "util-international.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 360 "util-international.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 370 "util-international.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 378 "util-international.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 382 "util-international.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 388 "util-international.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 398 "util-international.c"
}

static gint
__lambda8_ (const gchar* dic_a,
            const gchar* dic_b)
{
	gint _tmp0_ = 0;
	gint result = 0;
#line 66 "../src/client/util/util-international.vala"
	g_return_val_if_fail (dic_a != NULL, 0);
#line 66 "../src/client/util/util-international.vala"
	g_return_val_if_fail (dic_b != NULL, 0);
#line 66 "../src/client/util/util-international.vala"
	if (g_strcmp0 (dic_a, dic_b) < 0) {
#line 66 "../src/client/util/util-international.vala"
		_tmp0_ = -1;
#line 415 "util-international.c"
	} else {
#line 66 "../src/client/util/util-international.vala"
		_tmp0_ = 1;
#line 419 "util-international.c"
	}
#line 66 "../src/client/util/util-international.vala"
	result = _tmp0_;
#line 66 "../src/client/util/util-international.vala"
	return result;
#line 425 "util-international.c"
}

static gint
___lambda8__gcompare_func (gconstpointer a,
                           gconstpointer b)
{
	gint result;
	result = __lambda8_ ((const gchar*) a, (const gchar*) b);
#line 66 "../src/client/util/util-international.vala"
	return result;
#line 436 "util-international.c"
}

static void
_vala_array_add11 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 70 "../src/client/util/util-international.vala"
	if ((*length) == (*size)) {
#line 70 "../src/client/util/util-international.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 70 "../src/client/util/util-international.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 451 "util-international.c"
	}
#line 70 "../src/client/util/util-international.vala"
	(*array)[(*length)++] = value;
#line 70 "../src/client/util/util-international.vala"
	(*array)[*length] = NULL;
#line 457 "util-international.c"
}

static gchar**
_vala_array_dup7 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 73 "../src/client/util/util-international.vala"
	result = g_new0 (gchar*, length + 1);
#line 73 "../src/client/util/util-international.vala"
	for (i = 0; i < length; i++) {
#line 470 "util-international.c"
		gchar* _tmp0_;
#line 73 "../src/client/util/util-international.vala"
		_tmp0_ = g_strdup (self[i]);
#line 73 "../src/client/util/util-international.vala"
		result[i] = _tmp0_;
#line 476 "util-international.c"
	}
#line 73 "../src/client/util/util-international.vala"
	return result;
#line 480 "util-international.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 73 "../src/client/util/util-international.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 488 "util-international.c"
}

gchar**
util_international_get_available_dictionaries (gint* result_length1)
{
	Block58Data* _data58_;
	gchar** _tmp0_;
	EnchantBroker* broker = NULL;
	EnchantBroker* _tmp1_;
	EnchantBroker* _tmp2_;
	GHashTable* regional_dictionaries = NULL;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	GList* filtered_dictionaries = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar** _tmp21_;
	GList* _tmp22_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	gchar** _tmp28_;
	gint _tmp28__length1;
	gchar** _tmp29_;
	gint _tmp29__length1;
	gchar** result = NULL;
#line 40 "../src/client/util/util-international.vala"
	_data58_ = g_slice_new0 (Block58Data);
#line 40 "../src/client/util/util-international.vala"
	_data58_->_ref_count_ = 1;
#line 41 "../src/client/util/util-international.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 41 "../src/client/util/util-international.vala"
	_data58_->dictionaries = _tmp0_;
#line 41 "../src/client/util/util-international.vala"
	_data58_->dictionaries_length1 = 0;
#line 41 "../src/client/util/util-international.vala"
	_data58_->_dictionaries_size_ = _data58_->dictionaries_length1;
#line 43 "../src/client/util/util-international.vala"
	_tmp1_ = enchant_broker_init ();
#line 43 "../src/client/util/util-international.vala"
	broker = _tmp1_;
#line 44 "../src/client/util/util-international.vala"
	_tmp2_ = broker;
#line 44 "../src/client/util/util-international.vala"
	enchant_broker_list_dicts (_tmp2_, ___lambda7__enchant_dict_describe_fn, _data58_);
#line 51 "../src/client/util/util-international.vala"
	_tmp3_ = g_str_hash;
#line 51 "../src/client/util/util-international.vala"
	_tmp4_ = g_str_equal;
#line 51 "../src/client/util/util-international.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, NULL, _g_free0_);
#line 51 "../src/client/util/util-international.vala"
	regional_dictionaries = _tmp5_;
#line 53 "../src/client/util/util-international.vala"
	_tmp6_ = _data58_->dictionaries;
#line 53 "../src/client/util/util-international.vala"
	_tmp6__length1 = _data58_->dictionaries_length1;
#line 549 "util-international.c"
	{
		gchar** dic_collection = NULL;
		gint dic_collection_length1 = 0;
		gint _dic_collection_size_ = 0;
		gint dic_it = 0;
#line 53 "../src/client/util/util-international.vala"
		dic_collection = _tmp6_;
#line 53 "../src/client/util/util-international.vala"
		dic_collection_length1 = _tmp6__length1;
#line 53 "../src/client/util/util-international.vala"
		for (dic_it = 0; dic_it < dic_collection_length1; dic_it = dic_it + 1) {
#line 561 "util-international.c"
			gchar* _tmp7_;
			gchar* dic = NULL;
#line 53 "../src/client/util/util-international.vala"
			_tmp7_ = g_strdup (dic_collection[dic_it]);
#line 53 "../src/client/util/util-international.vala"
			dic = _tmp7_;
#line 568 "util-international.c"
			{
				const gchar* _tmp8_;
#line 54 "../src/client/util/util-international.vala"
				_tmp8_ = dic;
#line 54 "../src/client/util/util-international.vala"
				if (string_contains (_tmp8_, "_")) {
#line 575 "util-international.c"
					gint underscore = 0;
					const gchar* _tmp9_;
					GHashTable* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
#line 55 "../src/client/util/util-international.vala"
					_tmp9_ = dic;
#line 55 "../src/client/util/util-international.vala"
					underscore = string_index_of_char (_tmp9_, (gunichar) '_', 0);
#line 56 "../src/client/util/util-international.vala"
					_tmp10_ = regional_dictionaries;
#line 56 "../src/client/util/util-international.vala"
					_tmp11_ = dic;
#line 56 "../src/client/util/util-international.vala"
					_tmp12_ = string_substring (_tmp11_, (glong) 0, (glong) underscore);
#line 56 "../src/client/util/util-international.vala"
					g_hash_table_add (_tmp10_, _tmp12_);
#line 593 "util-international.c"
				}
#line 53 "../src/client/util/util-international.vala"
				_g_free0 (dic);
#line 597 "util-international.c"
			}
		}
	}
#line 60 "../src/client/util/util-international.vala"
	filtered_dictionaries = NULL;
#line 61 "../src/client/util/util-international.vala"
	_tmp13_ = _data58_->dictionaries;
#line 61 "../src/client/util/util-international.vala"
	_tmp13__length1 = _data58_->dictionaries_length1;
#line 607 "util-international.c"
	{
		gchar** dic_collection = NULL;
		gint dic_collection_length1 = 0;
		gint _dic_collection_size_ = 0;
		gint dic_it = 0;
#line 61 "../src/client/util/util-international.vala"
		dic_collection = _tmp13_;
#line 61 "../src/client/util/util-international.vala"
		dic_collection_length1 = _tmp13__length1;
#line 61 "../src/client/util/util-international.vala"
		for (dic_it = 0; dic_it < dic_collection_length1; dic_it = dic_it + 1) {
#line 619 "util-international.c"
			gchar* _tmp14_;
			gchar* dic = NULL;
#line 61 "../src/client/util/util-international.vala"
			_tmp14_ = g_strdup (dic_collection[dic_it]);
#line 61 "../src/client/util/util-international.vala"
			dic = _tmp14_;
#line 626 "util-international.c"
			{
				gboolean _tmp15_ = FALSE;
				const gchar* _tmp16_;
#line 62 "../src/client/util/util-international.vala"
				_tmp16_ = dic;
#line 62 "../src/client/util/util-international.vala"
				if (string_contains (_tmp16_, "_")) {
#line 62 "../src/client/util/util-international.vala"
					_tmp15_ = TRUE;
#line 636 "util-international.c"
				} else {
					GHashTable* _tmp17_;
					const gchar* _tmp18_;
#line 62 "../src/client/util/util-international.vala"
					_tmp17_ = regional_dictionaries;
#line 62 "../src/client/util/util-international.vala"
					_tmp18_ = dic;
#line 62 "../src/client/util/util-international.vala"
					_tmp15_ = !g_hash_table_contains (_tmp17_, _tmp18_);
#line 646 "util-international.c"
				}
#line 62 "../src/client/util/util-international.vala"
				if (_tmp15_) {
#line 650 "util-international.c"
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 63 "../src/client/util/util-international.vala"
					_tmp19_ = dic;
#line 63 "../src/client/util/util-international.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 63 "../src/client/util/util-international.vala"
					filtered_dictionaries = g_list_append (filtered_dictionaries, _tmp20_);
#line 659 "util-international.c"
				}
#line 61 "../src/client/util/util-international.vala"
				_g_free0 (dic);
#line 663 "util-international.c"
			}
		}
	}
#line 66 "../src/client/util/util-international.vala"
	filtered_dictionaries = g_list_sort (filtered_dictionaries, ___lambda8__gcompare_func);
#line 68 "../src/client/util/util-international.vala"
	_tmp21_ = g_new0 (gchar*, 0 + 1);
#line 68 "../src/client/util/util-international.vala"
	_data58_->dictionaries = (_vala_array_free (_data58_->dictionaries, _data58_->dictionaries_length1, (GDestroyNotify) g_free), NULL);
#line 68 "../src/client/util/util-international.vala"
	_data58_->dictionaries = _tmp21_;
#line 68 "../src/client/util/util-international.vala"
	_data58_->dictionaries_length1 = 0;
#line 68 "../src/client/util/util-international.vala"
	_data58_->_dictionaries_size_ = _data58_->dictionaries_length1;
#line 69 "../src/client/util/util-international.vala"
	_tmp22_ = filtered_dictionaries;
#line 681 "util-international.c"
	{
		GList* dic_collection = NULL;
		GList* dic_it = NULL;
#line 69 "../src/client/util/util-international.vala"
		dic_collection = _tmp22_;
#line 69 "../src/client/util/util-international.vala"
		for (dic_it = dic_collection; dic_it != NULL; dic_it = dic_it->next) {
#line 689 "util-international.c"
			gchar* _tmp23_;
			gchar* dic = NULL;
#line 69 "../src/client/util/util-international.vala"
			_tmp23_ = g_strdup ((const gchar*) dic_it->data);
#line 69 "../src/client/util/util-international.vala"
			dic = _tmp23_;
#line 696 "util-international.c"
			{
				gchar** _tmp24_;
				gint _tmp24__length1;
				const gchar* _tmp25_;
				gchar* _tmp26_;
#line 70 "../src/client/util/util-international.vala"
				_tmp24_ = _data58_->dictionaries;
#line 70 "../src/client/util/util-international.vala"
				_tmp24__length1 = _data58_->dictionaries_length1;
#line 70 "../src/client/util/util-international.vala"
				_tmp25_ = dic;
#line 70 "../src/client/util/util-international.vala"
				_tmp26_ = g_strdup (_tmp25_);
#line 70 "../src/client/util/util-international.vala"
				_vala_array_add11 (&_data58_->dictionaries, &_data58_->dictionaries_length1, &_data58_->_dictionaries_size_, _tmp26_);
#line 69 "../src/client/util/util-international.vala"
				_g_free0 (dic);
#line 714 "util-international.c"
			}
		}
	}
#line 73 "../src/client/util/util-international.vala"
	_tmp27_ = _data58_->dictionaries;
#line 73 "../src/client/util/util-international.vala"
	_tmp27__length1 = _data58_->dictionaries_length1;
#line 73 "../src/client/util/util-international.vala"
	_tmp28_ = (_tmp27_ != NULL) ? _vala_array_dup7 (_tmp27_, _tmp27__length1) : ((gpointer) _tmp27_);
#line 73 "../src/client/util/util-international.vala"
	_tmp28__length1 = _tmp27__length1;
#line 73 "../src/client/util/util-international.vala"
	_tmp29_ = _tmp28_;
#line 73 "../src/client/util/util-international.vala"
	_tmp29__length1 = _tmp28__length1;
#line 73 "../src/client/util/util-international.vala"
	if (result_length1) {
#line 73 "../src/client/util/util-international.vala"
		*result_length1 = _tmp29__length1;
#line 734 "util-international.c"
	}
#line 73 "../src/client/util/util-international.vala"
	result = _tmp29_;
#line 73 "../src/client/util/util-international.vala"
	(filtered_dictionaries == NULL) ? NULL : (filtered_dictionaries = (_g_list_free__g_free0_ (filtered_dictionaries), NULL));
#line 73 "../src/client/util/util-international.vala"
	_g_hash_table_unref0 (regional_dictionaries);
#line 73 "../src/client/util/util-international.vala"
	_enchant_broker_free0 (broker);
#line 73 "../src/client/util/util-international.vala"
	block58_data_unref (_data58_);
#line 73 "../src/client/util/util-international.vala"
	_data58_ = NULL;
#line 73 "../src/client/util/util-international.vala"
	return result;
#line 750 "util-international.c"
}

/**
     * Returns a list of installed locale languages.
     *
     * Each language is a POSIX-style locale name (ISO/IEC 15897).
     * The list is generated by executing `locale -a`.
     */
static void
_vala_array_add12 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 92 "../src/client/util/util-international.vala"
	if ((*length) == (*size)) {
#line 92 "../src/client/util/util-international.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 92 "../src/client/util/util-international.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 771 "util-international.c"
	}
#line 92 "../src/client/util/util-international.vala"
	(*array)[(*length)++] = value;
#line 92 "../src/client/util/util-international.vala"
	(*array)[*length] = NULL;
#line 777 "util-international.c"
}

gchar**
util_international_get_available_locales (gint* result_length1)
{
	gchar** locales = NULL;
	gchar** _tmp0_;
	gint locales_length1;
	gint _locales_size_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	GError* _inner_error0_ = NULL;
	gchar** result = NULL;
#line 83 "../src/client/util/util-international.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 83 "../src/client/util/util-international.vala"
	locales = _tmp0_;
#line 83 "../src/client/util/util-international.vala"
	locales_length1 = 0;
#line 83 "../src/client/util/util-international.vala"
	_locales_size_ = locales_length1;
#line 799 "util-international.c"
	{
		gchar* output = NULL;
		GSubprocess* p = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		GSubprocess* _tmp5_;
		GSubprocess* _tmp6_;
		GSubprocess* _tmp7_;
		gchar* _tmp8_ = NULL;
		const gchar* _tmp9_;
		gchar** _tmp10_;
		gchar** _tmp11_;
#line 86 "../src/client/util/util-international.vala"
		output = NULL;
#line 87 "../src/client/util/util-international.vala"
		_tmp1_ = g_strdup ("locale");
#line 87 "../src/client/util/util-international.vala"
		_tmp2_ = g_strdup ("-a");
#line 87 "../src/client/util/util-international.vala"
		_tmp3_ = g_new0 (gchar*, 2 + 1);
#line 87 "../src/client/util/util-international.vala"
		_tmp3_[0] = _tmp1_;
#line 87 "../src/client/util/util-international.vala"
		_tmp3_[1] = _tmp2_;
#line 87 "../src/client/util/util-international.vala"
		_tmp4_ = _tmp3_;
#line 87 "../src/client/util/util-international.vala"
		_tmp4__length1 = 2;
#line 87 "../src/client/util/util-international.vala"
		_tmp5_ = g_subprocess_newv (_tmp4_, G_SUBPROCESS_FLAGS_STDOUT_PIPE, &_inner_error0_);
#line 87 "../src/client/util/util-international.vala"
		_tmp6_ = _tmp5_;
#line 87 "../src/client/util/util-international.vala"
		_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 87 "../src/client/util/util-international.vala"
		p = _tmp6_;
#line 87 "../src/client/util/util-international.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 87 "../src/client/util/util-international.vala"
			_g_free0 (output);
#line 843 "util-international.c"
			goto __catch191_g_error;
		}
#line 89 "../src/client/util/util-international.vala"
		_tmp7_ = p;
#line 89 "../src/client/util/util-international.vala"
		g_subprocess_communicate_utf8 (_tmp7_, NULL, NULL, &_tmp8_, NULL, &_inner_error0_);
#line 89 "../src/client/util/util-international.vala"
		_g_free0 (output);
#line 89 "../src/client/util/util-international.vala"
		output = _tmp8_;
#line 89 "../src/client/util/util-international.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "../src/client/util/util-international.vala"
			_g_object_unref0 (p);
#line 89 "../src/client/util/util-international.vala"
			_g_free0 (output);
#line 860 "util-international.c"
			goto __catch191_g_error;
		}
#line 91 "../src/client/util/util-international.vala"
		_tmp9_ = output;
#line 91 "../src/client/util/util-international.vala"
		_tmp11_ = _tmp10_ = g_strsplit (_tmp9_, "\n", 0);
#line 867 "util-international.c"
		{
			gchar** l_collection = NULL;
			gint l_collection_length1 = 0;
			gint _l_collection_size_ = 0;
			gint l_it = 0;
#line 91 "../src/client/util/util-international.vala"
			l_collection = _tmp11_;
#line 91 "../src/client/util/util-international.vala"
			l_collection_length1 = _vala_array_length (_tmp10_);
#line 91 "../src/client/util/util-international.vala"
			for (l_it = 0; l_it < l_collection_length1; l_it = l_it + 1) {
#line 879 "util-international.c"
				gchar* _tmp12_;
				gchar* l = NULL;
#line 91 "../src/client/util/util-international.vala"
				_tmp12_ = g_strdup (l_collection[l_it]);
#line 91 "../src/client/util/util-international.vala"
				l = _tmp12_;
#line 886 "util-international.c"
				{
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 92 "../src/client/util/util-international.vala"
					_tmp13_ = locales;
#line 92 "../src/client/util/util-international.vala"
					_tmp13__length1 = locales_length1;
#line 92 "../src/client/util/util-international.vala"
					_tmp14_ = l;
#line 92 "../src/client/util/util-international.vala"
					_tmp15_ = g_strdup (_tmp14_);
#line 92 "../src/client/util/util-international.vala"
					_vala_array_add12 (&locales, &locales_length1, &_locales_size_, _tmp15_);
#line 91 "../src/client/util/util-international.vala"
					_g_free0 (l);
#line 904 "util-international.c"
				}
			}
#line 91 "../src/client/util/util-international.vala"
			l_collection = (_vala_array_free (l_collection, l_collection_length1, (GDestroyNotify) g_free), NULL);
#line 909 "util-international.c"
		}
#line 85 "../src/client/util/util-international.vala"
		_g_object_unref0 (p);
#line 85 "../src/client/util/util-international.vala"
		_g_free0 (output);
#line 915 "util-international.c"
	}
	goto __finally191;
	__catch191_g_error:
	{
		GError* e = NULL;
		gchar** _tmp16_;
		gint _tmp16__length1;
#line 85 "../src/client/util/util-international.vala"
		e = _inner_error0_;
#line 85 "../src/client/util/util-international.vala"
		_inner_error0_ = NULL;
#line 95 "../src/client/util/util-international.vala"
		_tmp16_ = locales;
#line 95 "../src/client/util/util-international.vala"
		_tmp16__length1 = locales_length1;
#line 95 "../src/client/util/util-international.vala"
		if (result_length1) {
#line 95 "../src/client/util/util-international.vala"
			*result_length1 = _tmp16__length1;
#line 935 "util-international.c"
		}
#line 95 "../src/client/util/util-international.vala"
		result = _tmp16_;
#line 95 "../src/client/util/util-international.vala"
		_g_error_free0 (e);
#line 95 "../src/client/util/util-international.vala"
		return result;
#line 943 "util-international.c"
	}
	__finally191:
#line 85 "../src/client/util/util-international.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/client/util/util-international.vala"
		locales = (_vala_array_free (locales, locales_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/client/util/util-international.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/client/util/util-international.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../src/client/util/util-international.vala"
		return NULL;
#line 956 "util-international.c"
	}
#line 98 "../src/client/util/util-international.vala"
	_tmp17_ = locales;
#line 98 "../src/client/util/util-international.vala"
	_tmp17__length1 = locales_length1;
#line 98 "../src/client/util/util-international.vala"
	if (result_length1) {
#line 98 "../src/client/util/util-international.vala"
		*result_length1 = _tmp17__length1;
#line 966 "util-international.c"
	}
#line 98 "../src/client/util/util-international.vala"
	result = _tmp17_;
#line 98 "../src/client/util/util-international.vala"
	return result;
#line 972 "util-international.c"
}

gchar*
util_international_strip_encoding (const gchar* locale)
{
	gint dot = 0;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 107 "../src/client/util/util-international.vala"
	g_return_val_if_fail (locale != NULL, NULL);
#line 108 "../src/client/util/util-international.vala"
	dot = string_index_of_char (locale, (gunichar) '.', 0);
#line 109 "../src/client/util/util-international.vala"
	_tmp0_ = string_substring (locale, (glong) 0, (glong) dot);
#line 109 "../src/client/util/util-international.vala"
	result = _tmp0_;
#line 109 "../src/client/util/util-international.vala"
	return result;
#line 991 "util-international.c"
}

/**
     * Returns a list of preferred spell-check languages.
     *
     * Each language is a POSIX-style locale name (ISO/IEC 15897).
     * The list is generated by obtaining the list of POSIX locales
     * specified by the `LANGUAGE` environment variable, and including
     * each that has both an available dictionary and locale.
     *
     * @see get_available_dictionaries
     * @see get_available_locales
     */
static void
_vala_array_add13 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 140 "../src/client/util/util-international.vala"
	if ((*length) == (*size)) {
#line 140 "../src/client/util/util-international.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 140 "../src/client/util/util-international.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1017 "util-international.c"
	}
#line 140 "../src/client/util/util-international.vala"
	(*array)[(*length)++] = value;
#line 140 "../src/client/util/util-international.vala"
	(*array)[*length] = NULL;
#line 1023 "util-international.c"
}

gchar**
util_international_get_user_preferred_languages (gint* result_length1)
{
	GHashTable* dicts = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	gint _tmp3_ = 0;
	gchar** _tmp4_;
	GHashTable* locales = NULL;
	GHashFunc _tmp9_;
	GEqualFunc _tmp10_;
	GHashTable* _tmp11_;
	gint _tmp12_ = 0;
	gchar** _tmp13_;
	gchar** output = NULL;
	gchar** _tmp18_;
	gint output_length1;
	gint _output_size_;
	gchar** language_names = NULL;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint language_names_length1;
	gint _language_names_size_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	gchar** _tmp33_;
	gint _tmp33__length1;
	gchar** result = NULL;
#line 124 "../src/client/util/util-international.vala"
	_tmp0_ = g_str_hash;
#line 124 "../src/client/util/util-international.vala"
	_tmp1_ = g_str_equal;
#line 124 "../src/client/util/util-international.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, _g_free0_);
#line 124 "../src/client/util/util-international.vala"
	dicts = _tmp2_;
#line 125 "../src/client/util/util-international.vala"
	_tmp4_ = util_international_get_available_dictionaries (&_tmp3_);
#line 1065 "util-international.c"
	{
		gchar** dict_collection = NULL;
		gint dict_collection_length1 = 0;
		gint _dict_collection_size_ = 0;
		gint dict_it = 0;
#line 125 "../src/client/util/util-international.vala"
		dict_collection = _tmp4_;
#line 125 "../src/client/util/util-international.vala"
		dict_collection_length1 = _tmp3_;
#line 125 "../src/client/util/util-international.vala"
		for (dict_it = 0; dict_it < dict_collection_length1; dict_it = dict_it + 1) {
#line 1077 "util-international.c"
			gchar* _tmp5_;
			gchar* dict = NULL;
#line 125 "../src/client/util/util-international.vala"
			_tmp5_ = g_strdup (dict_collection[dict_it]);
#line 125 "../src/client/util/util-international.vala"
			dict = _tmp5_;
#line 1084 "util-international.c"
			{
				GHashTable* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
#line 126 "../src/client/util/util-international.vala"
				_tmp6_ = dicts;
#line 126 "../src/client/util/util-international.vala"
				_tmp7_ = dict;
#line 126 "../src/client/util/util-international.vala"
				_tmp8_ = g_strdup (_tmp7_);
#line 126 "../src/client/util/util-international.vala"
				g_hash_table_add (_tmp6_, _tmp8_);
#line 125 "../src/client/util/util-international.vala"
				_g_free0 (dict);
#line 1099 "util-international.c"
			}
		}
#line 125 "../src/client/util/util-international.vala"
		dict_collection = (_vala_array_free (dict_collection, dict_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1104 "util-international.c"
	}
#line 129 "../src/client/util/util-international.vala"
	_tmp9_ = g_str_hash;
#line 129 "../src/client/util/util-international.vala"
	_tmp10_ = g_str_equal;
#line 129 "../src/client/util/util-international.vala"
	_tmp11_ = g_hash_table_new_full (_tmp9_, _tmp10_, NULL, _g_free0_);
#line 129 "../src/client/util/util-international.vala"
	locales = _tmp11_;
#line 130 "../src/client/util/util-international.vala"
	_tmp13_ = util_international_get_available_locales (&_tmp12_);
#line 1116 "util-international.c"
	{
		gchar** locale_collection = NULL;
		gint locale_collection_length1 = 0;
		gint _locale_collection_size_ = 0;
		gint locale_it = 0;
#line 130 "../src/client/util/util-international.vala"
		locale_collection = _tmp13_;
#line 130 "../src/client/util/util-international.vala"
		locale_collection_length1 = _tmp12_;
#line 130 "../src/client/util/util-international.vala"
		for (locale_it = 0; locale_it < locale_collection_length1; locale_it = locale_it + 1) {
#line 1128 "util-international.c"
			gchar* _tmp14_;
			gchar* locale = NULL;
#line 130 "../src/client/util/util-international.vala"
			_tmp14_ = g_strdup (locale_collection[locale_it]);
#line 130 "../src/client/util/util-international.vala"
			locale = _tmp14_;
#line 1135 "util-international.c"
			{
				GHashTable* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 131 "../src/client/util/util-international.vala"
				_tmp15_ = locales;
#line 131 "../src/client/util/util-international.vala"
				_tmp16_ = locale;
#line 131 "../src/client/util/util-international.vala"
				_tmp17_ = util_international_strip_encoding (_tmp16_);
#line 131 "../src/client/util/util-international.vala"
				g_hash_table_add (_tmp15_, _tmp17_);
#line 130 "../src/client/util/util-international.vala"
				_g_free0 (locale);
#line 1150 "util-international.c"
			}
		}
#line 130 "../src/client/util/util-international.vala"
		locale_collection = (_vala_array_free (locale_collection, locale_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1155 "util-international.c"
	}
#line 134 "../src/client/util/util-international.vala"
	_tmp18_ = g_new0 (gchar*, 0 + 1);
#line 134 "../src/client/util/util-international.vala"
	output = _tmp18_;
#line 134 "../src/client/util/util-international.vala"
	output_length1 = 0;
#line 134 "../src/client/util/util-international.vala"
	_output_size_ = output_length1;
#line 135 "../src/client/util/util-international.vala"
	_tmp20_ = _tmp19_ = g_get_language_names ();
#line 135 "../src/client/util/util-international.vala"
	language_names = _tmp20_;
#line 135 "../src/client/util/util-international.vala"
	language_names_length1 = _vala_array_length (_tmp19_);
#line 135 "../src/client/util/util-international.vala"
	_language_names_size_ = language_names_length1;
#line 136 "../src/client/util/util-international.vala"
	_tmp21_ = language_names;
#line 136 "../src/client/util/util-international.vala"
	_tmp21__length1 = language_names_length1;
#line 1177 "util-international.c"
	{
		gchar** lang_collection = NULL;
		gint lang_collection_length1 = 0;
		gint _lang_collection_size_ = 0;
		gint lang_it = 0;
#line 136 "../src/client/util/util-international.vala"
		lang_collection = _tmp21_;
#line 136 "../src/client/util/util-international.vala"
		lang_collection_length1 = _tmp21__length1;
#line 136 "../src/client/util/util-international.vala"
		for (lang_it = 0; lang_it < lang_collection_length1; lang_it = lang_it + 1) {
#line 1189 "util-international.c"
			gchar* _tmp22_;
			gchar* lang = NULL;
#line 136 "../src/client/util/util-international.vala"
			_tmp22_ = g_strdup (lang_collection[lang_it]);
#line 136 "../src/client/util/util-international.vala"
			lang = _tmp22_;
#line 1196 "util-international.c"
			{
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_ = FALSE;
				const gchar* _tmp25_;
#line 139 "../src/client/util/util-international.vala"
				_tmp25_ = lang;
#line 139 "../src/client/util/util-international.vala"
				if (g_strcmp0 (_tmp25_, "C") != 0) {
#line 1205 "util-international.c"
					GHashTable* _tmp26_;
					const gchar* _tmp27_;
#line 139 "../src/client/util/util-international.vala"
					_tmp26_ = dicts;
#line 139 "../src/client/util/util-international.vala"
					_tmp27_ = lang;
#line 139 "../src/client/util/util-international.vala"
					_tmp24_ = g_hash_table_contains (_tmp26_, _tmp27_);
#line 1214 "util-international.c"
				} else {
#line 139 "../src/client/util/util-international.vala"
					_tmp24_ = FALSE;
#line 1218 "util-international.c"
				}
#line 139 "../src/client/util/util-international.vala"
				if (_tmp24_) {
#line 1222 "util-international.c"
					GHashTable* _tmp28_;
					const gchar* _tmp29_;
#line 139 "../src/client/util/util-international.vala"
					_tmp28_ = locales;
#line 139 "../src/client/util/util-international.vala"
					_tmp29_ = lang;
#line 139 "../src/client/util/util-international.vala"
					_tmp23_ = g_hash_table_contains (_tmp28_, _tmp29_);
#line 1231 "util-international.c"
				} else {
#line 139 "../src/client/util/util-international.vala"
					_tmp23_ = FALSE;
#line 1235 "util-international.c"
				}
#line 139 "../src/client/util/util-international.vala"
				if (_tmp23_) {
#line 1239 "util-international.c"
					gchar** _tmp30_;
					gint _tmp30__length1;
					const gchar* _tmp31_;
					gchar* _tmp32_;
#line 140 "../src/client/util/util-international.vala"
					_tmp30_ = output;
#line 140 "../src/client/util/util-international.vala"
					_tmp30__length1 = output_length1;
#line 140 "../src/client/util/util-international.vala"
					_tmp31_ = lang;
#line 140 "../src/client/util/util-international.vala"
					_tmp32_ = g_strdup (_tmp31_);
#line 140 "../src/client/util/util-international.vala"
					_vala_array_add13 (&output, &output_length1, &_output_size_, _tmp32_);
#line 1254 "util-international.c"
				}
#line 136 "../src/client/util/util-international.vala"
				_g_free0 (lang);
#line 1258 "util-international.c"
			}
		}
	}
#line 143 "../src/client/util/util-international.vala"
	_tmp33_ = output;
#line 143 "../src/client/util/util-international.vala"
	_tmp33__length1 = output_length1;
#line 143 "../src/client/util/util-international.vala"
	if (result_length1) {
#line 143 "../src/client/util/util-international.vala"
		*result_length1 = _tmp33__length1;
#line 1270 "util-international.c"
	}
#line 143 "../src/client/util/util-international.vala"
	result = _tmp33_;
#line 143 "../src/client/util/util-international.vala"
	_g_hash_table_unref0 (locales);
#line 143 "../src/client/util/util-international.vala"
	_g_hash_table_unref0 (dicts);
#line 143 "../src/client/util/util-international.vala"
	return result;
#line 1280 "util-international.c"
}

gchar*
util_international_language_name_from_locale (const gchar* locale)
{
	GHashTable* _tmp0_;
	gint pos = 0;
	gchar* language_name = NULL;
	GHashTable* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gconstpointer _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* result = NULL;
#line 146 "../src/client/util/util-international.vala"
	g_return_val_if_fail (locale != NULL, NULL);
#line 147 "../src/client/util/util-international.vala"
	_tmp0_ = util_international_language_names;
#line 147 "../src/client/util/util-international.vala"
	if (_tmp0_ == NULL) {
#line 1302 "util-international.c"
		GHashFunc _tmp1_;
		GEqualFunc _tmp2_;
		GHashTable* _tmp3_;
		xmlDoc* doc = NULL;
		xmlDoc* _tmp4_;
		xmlDoc* _tmp5_;
#line 148 "../src/client/util/util-international.vala"
		_tmp1_ = g_str_hash;
#line 148 "../src/client/util/util-international.vala"
		_tmp2_ = g_str_equal;
#line 148 "../src/client/util/util-international.vala"
		_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_free0_);
#line 148 "../src/client/util/util-international.vala"
		_g_hash_table_unref0 (util_international_language_names);
#line 148 "../src/client/util/util-international.vala"
		util_international_language_names = _tmp3_;
#line 150 "../src/client/util/util-international.vala"
		_tmp4_ = xmlParseFile (ISO_CODE_639_XML);
#line 150 "../src/client/util/util-international.vala"
		doc = _tmp4_;
#line 151 "../src/client/util/util-international.vala"
		_tmp5_ = doc;
#line 151 "../src/client/util/util-international.vala"
		if (_tmp5_ == NULL) {
#line 152 "../src/client/util/util-international.vala"
			result = NULL;
#line 152 "../src/client/util/util-international.vala"
			return result;
#line 1331 "util-international.c"
		} else {
			xmlNode* root = NULL;
			xmlDoc* _tmp6_;
			xmlNode* _tmp7_;
#line 155 "../src/client/util/util-international.vala"
			_tmp6_ = doc;
#line 155 "../src/client/util/util-international.vala"
			_tmp7_ = xmlDocGetRootElement (_tmp6_);
#line 155 "../src/client/util/util-international.vala"
			root = _tmp7_;
#line 1342 "util-international.c"
			{
				xmlNode* entry = NULL;
				xmlNode* _tmp8_;
				xmlNode* _tmp9_;
#line 156 "../src/client/util/util-international.vala"
				_tmp8_ = root;
#line 156 "../src/client/util/util-international.vala"
				_tmp9_ = _tmp8_->children;
#line 156 "../src/client/util/util-international.vala"
				entry = _tmp9_;
#line 1353 "util-international.c"
				{
					gboolean _tmp10_ = FALSE;
#line 156 "../src/client/util/util-international.vala"
					_tmp10_ = TRUE;
#line 156 "../src/client/util/util-international.vala"
					while (TRUE) {
#line 1360 "util-international.c"
						xmlNode* _tmp13_;
						xmlNode* _tmp14_;
						xmlElementType _tmp15_;
#line 156 "../src/client/util/util-international.vala"
						if (!_tmp10_) {
#line 1366 "util-international.c"
							xmlNode* _tmp11_;
							xmlNode* _tmp12_;
#line 156 "../src/client/util/util-international.vala"
							_tmp11_ = entry;
#line 156 "../src/client/util/util-international.vala"
							_tmp12_ = _tmp11_->next;
#line 156 "../src/client/util/util-international.vala"
							entry = _tmp12_;
#line 1375 "util-international.c"
						}
#line 156 "../src/client/util/util-international.vala"
						_tmp10_ = FALSE;
#line 156 "../src/client/util/util-international.vala"
						_tmp13_ = entry;
#line 156 "../src/client/util/util-international.vala"
						if (!(_tmp13_ != NULL)) {
#line 156 "../src/client/util/util-international.vala"
							break;
#line 1385 "util-international.c"
						}
#line 157 "../src/client/util/util-international.vala"
						_tmp14_ = entry;
#line 157 "../src/client/util/util-international.vala"
						_tmp15_ = _tmp14_->type;
#line 157 "../src/client/util/util-international.vala"
						if (_tmp15_ == XML_ELEMENT_NODE) {
#line 1393 "util-international.c"
							gchar* iso_639_1 = NULL;
							gchar* language_name = NULL;
#line 158 "../src/client/util/util-international.vala"
							iso_639_1 = NULL;
#line 159 "../src/client/util/util-international.vala"
							language_name = NULL;
#line 1400 "util-international.c"
							{
								xmlAttr* a = NULL;
								xmlNode* _tmp16_;
								xmlAttr* _tmp17_;
#line 161 "../src/client/util/util-international.vala"
								_tmp16_ = entry;
#line 161 "../src/client/util/util-international.vala"
								_tmp17_ = _tmp16_->properties;
#line 161 "../src/client/util/util-international.vala"
								a = _tmp17_;
#line 1411 "util-international.c"
								{
									gboolean _tmp18_ = FALSE;
#line 161 "../src/client/util/util-international.vala"
									_tmp18_ = TRUE;
#line 161 "../src/client/util/util-international.vala"
									while (TRUE) {
#line 1418 "util-international.c"
										xmlAttr* _tmp21_;
										xmlAttr* _tmp22_;
										const gchar* _tmp23_;
										const gchar* _tmp24_;
										GQuark _tmp26_ = 0U;
#line 162 "../src/client/util/util-international.vala"
										static GQuark _tmp25_label0 = 0;
#line 162 "../src/client/util/util-international.vala"
										static GQuark _tmp25_label1 = 0;
#line 1428 "util-international.c"
										const gchar* _tmp35_;
#line 161 "../src/client/util/util-international.vala"
										if (!_tmp18_) {
#line 1432 "util-international.c"
											xmlAttr* _tmp19_;
											xmlAttr* _tmp20_;
#line 161 "../src/client/util/util-international.vala"
											_tmp19_ = a;
#line 161 "../src/client/util/util-international.vala"
											_tmp20_ = _tmp19_->next;
#line 161 "../src/client/util/util-international.vala"
											a = _tmp20_;
#line 1441 "util-international.c"
										}
#line 161 "../src/client/util/util-international.vala"
										_tmp18_ = FALSE;
#line 161 "../src/client/util/util-international.vala"
										_tmp21_ = a;
#line 161 "../src/client/util/util-international.vala"
										if (!(_tmp21_ != NULL)) {
#line 161 "../src/client/util/util-international.vala"
											break;
#line 1451 "util-international.c"
										}
#line 162 "../src/client/util/util-international.vala"
										_tmp22_ = a;
#line 162 "../src/client/util/util-international.vala"
										_tmp23_ = _tmp22_->name;
#line 162 "../src/client/util/util-international.vala"
										_tmp24_ = _tmp23_;
#line 162 "../src/client/util/util-international.vala"
										_tmp26_ = (NULL == _tmp24_) ? 0 : g_quark_from_string (_tmp24_);
#line 162 "../src/client/util/util-international.vala"
										if (_tmp26_ == ((0 != _tmp25_label0) ? _tmp25_label0 : (_tmp25_label0 = g_quark_from_static_string ("iso_639_1_code")))) {
#line 162 "../src/client/util/util-international.vala"
											switch (0) {
#line 1465 "util-international.c"
												default:
												{
													xmlAttr* _tmp27_;
													xmlNode* _tmp28_;
													const gchar* _tmp29_;
													gchar* _tmp30_;
#line 164 "../src/client/util/util-international.vala"
													_tmp27_ = a;
#line 164 "../src/client/util/util-international.vala"
													_tmp28_ = _tmp27_->children;
#line 164 "../src/client/util/util-international.vala"
													_tmp29_ = _tmp28_->content;
#line 164 "../src/client/util/util-international.vala"
													_tmp30_ = g_strdup (_tmp29_);
#line 164 "../src/client/util/util-international.vala"
													_g_free0 (iso_639_1);
#line 164 "../src/client/util/util-international.vala"
													iso_639_1 = _tmp30_;
#line 165 "../src/client/util/util-international.vala"
													break;
#line 1486 "util-international.c"
												}
											}
										} else if (_tmp26_ == ((0 != _tmp25_label1) ? _tmp25_label1 : (_tmp25_label1 = g_quark_from_static_string ("name")))) {
#line 162 "../src/client/util/util-international.vala"
											switch (0) {
#line 1492 "util-international.c"
												default:
												{
													xmlAttr* _tmp31_;
													xmlNode* _tmp32_;
													const gchar* _tmp33_;
													gchar* _tmp34_;
#line 167 "../src/client/util/util-international.vala"
													_tmp31_ = a;
#line 167 "../src/client/util/util-international.vala"
													_tmp32_ = _tmp31_->children;
#line 167 "../src/client/util/util-international.vala"
													_tmp33_ = _tmp32_->content;
#line 167 "../src/client/util/util-international.vala"
													_tmp34_ = g_strdup (_tmp33_);
#line 167 "../src/client/util/util-international.vala"
													_g_free0 (language_name);
#line 167 "../src/client/util/util-international.vala"
													language_name = _tmp34_;
#line 168 "../src/client/util/util-international.vala"
													break;
#line 1513 "util-international.c"
												}
											}
										} else {
#line 162 "../src/client/util/util-international.vala"
											switch (0) {
#line 1519 "util-international.c"
												default:
												{
#line 170 "../src/client/util/util-international.vala"
													break;
#line 1524 "util-international.c"
												}
											}
										}
#line 173 "../src/client/util/util-international.vala"
										_tmp35_ = language_name;
#line 173 "../src/client/util/util-international.vala"
										if (_tmp35_ != NULL) {
#line 1532 "util-international.c"
											const gchar* _tmp36_;
#line 174 "../src/client/util/util-international.vala"
											_tmp36_ = iso_639_1;
#line 174 "../src/client/util/util-international.vala"
											if (_tmp36_ != NULL) {
#line 1538 "util-international.c"
												GHashTable* _tmp37_;
												const gchar* _tmp38_;
												gchar* _tmp39_;
												const gchar* _tmp40_;
												gchar* _tmp41_;
#line 175 "../src/client/util/util-international.vala"
												_tmp37_ = util_international_language_names;
#line 175 "../src/client/util/util-international.vala"
												_tmp38_ = iso_639_1;
#line 175 "../src/client/util/util-international.vala"
												_tmp39_ = g_strdup (_tmp38_);
#line 175 "../src/client/util/util-international.vala"
												_tmp40_ = language_name;
#line 175 "../src/client/util/util-international.vala"
												_tmp41_ = g_strdup (_tmp40_);
#line 175 "../src/client/util/util-international.vala"
												g_hash_table_insert (_tmp37_, _tmp39_, _tmp41_);
#line 1556 "util-international.c"
											}
										}
									}
								}
							}
#line 157 "../src/client/util/util-international.vala"
							_g_free0 (language_name);
#line 157 "../src/client/util/util-international.vala"
							_g_free0 (iso_639_1);
#line 1566 "util-international.c"
						}
					}
				}
			}
		}
	}
#line 185 "../src/client/util/util-international.vala"
	pos = -1;
#line 186 "../src/client/util/util-international.vala"
	if (string_contains (locale, "_")) {
#line 187 "../src/client/util/util-international.vala"
		pos = string_index_of_char (locale, (gunichar) '_', 0);
#line 1579 "util-international.c"
	}
#line 191 "../src/client/util/util-international.vala"
	_tmp42_ = util_international_language_names;
#line 191 "../src/client/util/util-international.vala"
	_tmp43_ = string_substring (locale, (glong) 0, (glong) pos);
#line 191 "../src/client/util/util-international.vala"
	_tmp44_ = _tmp43_;
#line 191 "../src/client/util/util-international.vala"
	_tmp45_ = g_hash_table_lookup (_tmp42_, _tmp44_);
#line 191 "../src/client/util/util-international.vala"
	_tmp46_ = g_strdup (g_dgettext ("iso_639", (const gchar*) _tmp45_));
#line 191 "../src/client/util/util-international.vala"
	_tmp47_ = _tmp46_;
#line 191 "../src/client/util/util-international.vala"
	_g_free0 (_tmp44_);
#line 191 "../src/client/util/util-international.vala"
	language_name = _tmp47_;
#line 193 "../src/client/util/util-international.vala"
	result = language_name;
#line 193 "../src/client/util/util-international.vala"
	return result;
#line 1601 "util-international.c"
}

gchar*
util_international_country_name_from_locale (const gchar* locale)
{
	GHashTable* _tmp0_;
	gint pos = 0;
	gchar* country_name = NULL;
	GHashTable* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gconstpointer _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* result = NULL;
#line 196 "../src/client/util/util-international.vala"
	g_return_val_if_fail (locale != NULL, NULL);
#line 197 "../src/client/util/util-international.vala"
	_tmp0_ = util_international_country_names;
#line 197 "../src/client/util/util-international.vala"
	if (_tmp0_ == NULL) {
#line 1623 "util-international.c"
		GHashFunc _tmp1_;
		GEqualFunc _tmp2_;
		GHashTable* _tmp3_;
		xmlDoc* doc = NULL;
		xmlDoc* _tmp4_;
		xmlDoc* _tmp5_;
#line 198 "../src/client/util/util-international.vala"
		_tmp1_ = g_str_hash;
#line 198 "../src/client/util/util-international.vala"
		_tmp2_ = g_str_equal;
#line 198 "../src/client/util/util-international.vala"
		_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_free0_);
#line 198 "../src/client/util/util-international.vala"
		_g_hash_table_unref0 (util_international_country_names);
#line 198 "../src/client/util/util-international.vala"
		util_international_country_names = _tmp3_;
#line 200 "../src/client/util/util-international.vala"
		_tmp4_ = xmlParseFile (ISO_CODE_3166_XML);
#line 200 "../src/client/util/util-international.vala"
		doc = _tmp4_;
#line 202 "../src/client/util/util-international.vala"
		_tmp5_ = doc;
#line 202 "../src/client/util/util-international.vala"
		if (_tmp5_ == NULL) {
#line 203 "../src/client/util/util-international.vala"
			result = NULL;
#line 203 "../src/client/util/util-international.vala"
			return result;
#line 1652 "util-international.c"
		} else {
			xmlNode* root = NULL;
			xmlDoc* _tmp6_;
			xmlNode* _tmp7_;
#line 206 "../src/client/util/util-international.vala"
			_tmp6_ = doc;
#line 206 "../src/client/util/util-international.vala"
			_tmp7_ = xmlDocGetRootElement (_tmp6_);
#line 206 "../src/client/util/util-international.vala"
			root = _tmp7_;
#line 1663 "util-international.c"
			{
				xmlNode* entry = NULL;
				xmlNode* _tmp8_;
				xmlNode* _tmp9_;
#line 207 "../src/client/util/util-international.vala"
				_tmp8_ = root;
#line 207 "../src/client/util/util-international.vala"
				_tmp9_ = _tmp8_->children;
#line 207 "../src/client/util/util-international.vala"
				entry = _tmp9_;
#line 1674 "util-international.c"
				{
					gboolean _tmp10_ = FALSE;
#line 207 "../src/client/util/util-international.vala"
					_tmp10_ = TRUE;
#line 207 "../src/client/util/util-international.vala"
					while (TRUE) {
#line 1681 "util-international.c"
						xmlNode* _tmp13_;
						xmlNode* _tmp14_;
						xmlElementType _tmp15_;
#line 207 "../src/client/util/util-international.vala"
						if (!_tmp10_) {
#line 1687 "util-international.c"
							xmlNode* _tmp11_;
							xmlNode* _tmp12_;
#line 207 "../src/client/util/util-international.vala"
							_tmp11_ = entry;
#line 207 "../src/client/util/util-international.vala"
							_tmp12_ = _tmp11_->next;
#line 207 "../src/client/util/util-international.vala"
							entry = _tmp12_;
#line 1696 "util-international.c"
						}
#line 207 "../src/client/util/util-international.vala"
						_tmp10_ = FALSE;
#line 207 "../src/client/util/util-international.vala"
						_tmp13_ = entry;
#line 207 "../src/client/util/util-international.vala"
						if (!(_tmp13_ != NULL)) {
#line 207 "../src/client/util/util-international.vala"
							break;
#line 1706 "util-international.c"
						}
#line 208 "../src/client/util/util-international.vala"
						_tmp14_ = entry;
#line 208 "../src/client/util/util-international.vala"
						_tmp15_ = _tmp14_->type;
#line 208 "../src/client/util/util-international.vala"
						if (_tmp15_ == XML_ELEMENT_NODE) {
#line 1714 "util-international.c"
							gchar* iso_3166 = NULL;
							gchar* country_name = NULL;
#line 209 "../src/client/util/util-international.vala"
							iso_3166 = NULL;
#line 210 "../src/client/util/util-international.vala"
							country_name = NULL;
#line 1721 "util-international.c"
							{
								xmlAttr* a = NULL;
								xmlNode* _tmp16_;
								xmlAttr* _tmp17_;
#line 212 "../src/client/util/util-international.vala"
								_tmp16_ = entry;
#line 212 "../src/client/util/util-international.vala"
								_tmp17_ = _tmp16_->properties;
#line 212 "../src/client/util/util-international.vala"
								a = _tmp17_;
#line 1732 "util-international.c"
								{
									gboolean _tmp18_ = FALSE;
#line 212 "../src/client/util/util-international.vala"
									_tmp18_ = TRUE;
#line 212 "../src/client/util/util-international.vala"
									while (TRUE) {
#line 1739 "util-international.c"
										xmlAttr* _tmp21_;
										xmlAttr* _tmp22_;
										const gchar* _tmp23_;
										const gchar* _tmp24_;
										GQuark _tmp26_ = 0U;
#line 213 "../src/client/util/util-international.vala"
										static GQuark _tmp25_label0 = 0;
#line 213 "../src/client/util/util-international.vala"
										static GQuark _tmp25_label1 = 0;
#line 1749 "util-international.c"
										const gchar* _tmp35_;
#line 212 "../src/client/util/util-international.vala"
										if (!_tmp18_) {
#line 1753 "util-international.c"
											xmlAttr* _tmp19_;
											xmlAttr* _tmp20_;
#line 212 "../src/client/util/util-international.vala"
											_tmp19_ = a;
#line 212 "../src/client/util/util-international.vala"
											_tmp20_ = _tmp19_->next;
#line 212 "../src/client/util/util-international.vala"
											a = _tmp20_;
#line 1762 "util-international.c"
										}
#line 212 "../src/client/util/util-international.vala"
										_tmp18_ = FALSE;
#line 212 "../src/client/util/util-international.vala"
										_tmp21_ = a;
#line 212 "../src/client/util/util-international.vala"
										if (!(_tmp21_ != NULL)) {
#line 212 "../src/client/util/util-international.vala"
											break;
#line 1772 "util-international.c"
										}
#line 213 "../src/client/util/util-international.vala"
										_tmp22_ = a;
#line 213 "../src/client/util/util-international.vala"
										_tmp23_ = _tmp22_->name;
#line 213 "../src/client/util/util-international.vala"
										_tmp24_ = _tmp23_;
#line 213 "../src/client/util/util-international.vala"
										_tmp26_ = (NULL == _tmp24_) ? 0 : g_quark_from_string (_tmp24_);
#line 213 "../src/client/util/util-international.vala"
										if (_tmp26_ == ((0 != _tmp25_label0) ? _tmp25_label0 : (_tmp25_label0 = g_quark_from_static_string ("alpha_2_code")))) {
#line 213 "../src/client/util/util-international.vala"
											switch (0) {
#line 1786 "util-international.c"
												default:
												{
													xmlAttr* _tmp27_;
													xmlNode* _tmp28_;
													const gchar* _tmp29_;
													gchar* _tmp30_;
#line 215 "../src/client/util/util-international.vala"
													_tmp27_ = a;
#line 215 "../src/client/util/util-international.vala"
													_tmp28_ = _tmp27_->children;
#line 215 "../src/client/util/util-international.vala"
													_tmp29_ = _tmp28_->content;
#line 215 "../src/client/util/util-international.vala"
													_tmp30_ = g_strdup (_tmp29_);
#line 215 "../src/client/util/util-international.vala"
													_g_free0 (iso_3166);
#line 215 "../src/client/util/util-international.vala"
													iso_3166 = _tmp30_;
#line 216 "../src/client/util/util-international.vala"
													break;
#line 1807 "util-international.c"
												}
											}
										} else if (_tmp26_ == ((0 != _tmp25_label1) ? _tmp25_label1 : (_tmp25_label1 = g_quark_from_static_string ("name")))) {
#line 213 "../src/client/util/util-international.vala"
											switch (0) {
#line 1813 "util-international.c"
												default:
												{
													xmlAttr* _tmp31_;
													xmlNode* _tmp32_;
													const gchar* _tmp33_;
													gchar* _tmp34_;
#line 218 "../src/client/util/util-international.vala"
													_tmp31_ = a;
#line 218 "../src/client/util/util-international.vala"
													_tmp32_ = _tmp31_->children;
#line 218 "../src/client/util/util-international.vala"
													_tmp33_ = _tmp32_->content;
#line 218 "../src/client/util/util-international.vala"
													_tmp34_ = g_strdup (_tmp33_);
#line 218 "../src/client/util/util-international.vala"
													_g_free0 (country_name);
#line 218 "../src/client/util/util-international.vala"
													country_name = _tmp34_;
#line 219 "../src/client/util/util-international.vala"
													break;
#line 1834 "util-international.c"
												}
											}
										} else {
#line 213 "../src/client/util/util-international.vala"
											switch (0) {
#line 1840 "util-international.c"
												default:
												{
#line 221 "../src/client/util/util-international.vala"
													break;
#line 1845 "util-international.c"
												}
											}
										}
#line 224 "../src/client/util/util-international.vala"
										_tmp35_ = country_name;
#line 224 "../src/client/util/util-international.vala"
										if (_tmp35_ != NULL) {
#line 1853 "util-international.c"
											const gchar* _tmp36_;
#line 225 "../src/client/util/util-international.vala"
											_tmp36_ = iso_3166;
#line 225 "../src/client/util/util-international.vala"
											if (_tmp36_ != NULL) {
#line 1859 "util-international.c"
												GHashTable* _tmp37_;
												const gchar* _tmp38_;
												gchar* _tmp39_;
												const gchar* _tmp40_;
												gchar* _tmp41_;
#line 226 "../src/client/util/util-international.vala"
												_tmp37_ = util_international_country_names;
#line 226 "../src/client/util/util-international.vala"
												_tmp38_ = iso_3166;
#line 226 "../src/client/util/util-international.vala"
												_tmp39_ = g_strdup (_tmp38_);
#line 226 "../src/client/util/util-international.vala"
												_tmp40_ = country_name;
#line 226 "../src/client/util/util-international.vala"
												_tmp41_ = g_strdup (_tmp40_);
#line 226 "../src/client/util/util-international.vala"
												g_hash_table_insert (_tmp37_, _tmp39_, _tmp41_);
#line 1877 "util-international.c"
											}
										}
									}
								}
							}
#line 208 "../src/client/util/util-international.vala"
							_g_free0 (country_name);
#line 208 "../src/client/util/util-international.vala"
							_g_free0 (iso_3166);
#line 1887 "util-international.c"
						}
					}
				}
			}
		}
	}
#line 236 "../src/client/util/util-international.vala"
	pos = -1;
#line 237 "../src/client/util/util-international.vala"
	if (string_contains (locale, "_")) {
#line 238 "../src/client/util/util-international.vala"
		pos = string_index_of_char (locale, (gunichar) '_', 0);
#line 1900 "util-international.c"
	}
#line 241 "../src/client/util/util-international.vala"
	_tmp42_ = util_international_country_names;
#line 241 "../src/client/util/util-international.vala"
	_tmp43_ = string_substring (locale, (glong) (pos + 1), (glong) -1);
#line 241 "../src/client/util/util-international.vala"
	_tmp44_ = _tmp43_;
#line 241 "../src/client/util/util-international.vala"
	_tmp45_ = g_hash_table_lookup (_tmp42_, _tmp44_);
#line 241 "../src/client/util/util-international.vala"
	_tmp46_ = g_strdup (g_dgettext ("iso_3166", (const gchar*) _tmp45_));
#line 241 "../src/client/util/util-international.vala"
	_tmp47_ = _tmp46_;
#line 241 "../src/client/util/util-international.vala"
	_g_free0 (_tmp44_);
#line 241 "../src/client/util/util-international.vala"
	country_name = _tmp47_;
#line 243 "../src/client/util/util-international.vala"
	result = country_name;
#line 243 "../src/client/util/util-international.vala"
	return result;
#line 1922 "util-international.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

