/* db.c generated by valac 0.46.0, the Vala compiler
 * generated from db.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	GEARY_DB_DATABASE_FLAGS_NONE = 0,
	GEARY_DB_DATABASE_FLAGS_CREATE_DIRECTORY = 1 << 0,
	GEARY_DB_DATABASE_FLAGS_CREATE_FILE = 1 << 1,
	GEARY_DB_DATABASE_FLAGS_READ_ONLY = 1 << 2,
	GEARY_DB_DATABASE_FLAGS_CHECK_CORRUPTION = 1 << 3
} GearyDbDatabaseFlags;

#define GEARY_DB_TYPE_DATABASE_FLAGS (geary_db_database_flags_get_type ())
typedef enum  {
	GEARY_DB_RESET_SCOPE_SAVE_BINDINGS,
	GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS
} GearyDbResetScope;

#define GEARY_DB_TYPE_RESET_SCOPE (geary_db_reset_scope_get_type ())
typedef enum  {
	GEARY_DB_TRANSACTION_OUTCOME_ROLLBACK = 0,
	GEARY_DB_TRANSACTION_OUTCOME_COMMIT = 1,
	GEARY_DB_TRANSACTION_OUTCOME_SUCCESS = GEARY_DB_TRANSACTION_OUTCOME_COMMIT,
	GEARY_DB_TRANSACTION_OUTCOME_FAILURE = GEARY_DB_TRANSACTION_OUTCOME_ROLLBACK,
	GEARY_DB_TRANSACTION_OUTCOME_DONE = GEARY_DB_TRANSACTION_OUTCOME_COMMIT
} GearyDbTransactionOutcome;

#define GEARY_DB_TYPE_TRANSACTION_OUTCOME (geary_db_transaction_outcome_get_type ())

#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;

#define GEARY_DB_TYPE_CONTEXT (geary_db_context_get_type ())
#define GEARY_DB_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_CONTEXT, GearyDbContext))
#define GEARY_DB_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_CONTEXT, GearyDbContextClass))
#define GEARY_DB_IS_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_CONTEXT))
#define GEARY_DB_IS_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_CONTEXT))
#define GEARY_DB_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_CONTEXT, GearyDbContextClass))

typedef struct _GearyDbContext GearyDbContext;
typedef struct _GearyDbContextClass GearyDbContextClass;

#define GEARY_DB_TYPE_CONNECTION (geary_db_connection_get_type ())
#define GEARY_DB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_CONNECTION, GearyDbConnection))
#define GEARY_DB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_CONNECTION, GearyDbConnectionClass))
#define GEARY_DB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_CONNECTION))
#define GEARY_DB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_CONNECTION))
#define GEARY_DB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_CONNECTION, GearyDbConnectionClass))

typedef struct _GearyDbConnection GearyDbConnection;
typedef struct _GearyDbConnectionClass GearyDbConnectionClass;
typedef GearyDbTransactionOutcome (*GearyDbTransactionMethod) (GearyDbConnection* cx, GCancellable* cancellable, gpointer user_data, GError** error);
typedef gint (*GearyDbSqliteExecOperation) (gpointer user_data);
#define _g_free0(var) (var = (g_free (var), NULL))

#define GEARY_DB_TYPE_DATABASE (geary_db_database_get_type ())
#define GEARY_DB_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_DATABASE, GearyDbDatabase))
#define GEARY_DB_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_DATABASE, GearyDbDatabaseClass))
#define GEARY_DB_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_DATABASE))
#define GEARY_DB_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_DATABASE))
#define GEARY_DB_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_DATABASE, GearyDbDatabaseClass))

typedef struct _GearyDbDatabase GearyDbDatabase;
typedef struct _GearyDbDatabaseClass GearyDbDatabaseClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GEARY_TYPE_BASE_INTERFACE (geary_base_interface_get_type ())
#define GEARY_BASE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface))
#define GEARY_IS_BASE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_INTERFACE))
#define GEARY_BASE_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_TYPE_BASE_INTERFACE, GearyBaseInterfaceIface))

typedef struct _GearyBaseInterface GearyBaseInterface;
typedef struct _GearyBaseInterfaceIface GearyBaseInterfaceIface;
typedef struct _GearyBaseObjectPrivate GearyBaseObjectPrivate;
typedef struct _GearyDbContextPrivate GearyDbContextPrivate;

#define GEARY_DB_TYPE_STATEMENT (geary_db_statement_get_type ())
#define GEARY_DB_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_STATEMENT, GearyDbStatement))
#define GEARY_DB_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_STATEMENT, GearyDbStatementClass))
#define GEARY_DB_IS_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_STATEMENT))
#define GEARY_DB_IS_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_STATEMENT))
#define GEARY_DB_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_STATEMENT, GearyDbStatementClass))

typedef struct _GearyDbStatement GearyDbStatement;
typedef struct _GearyDbStatementClass GearyDbStatementClass;

#define GEARY_DB_TYPE_RESULT (geary_db_result_get_type ())
#define GEARY_DB_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_RESULT, GearyDbResult))
#define GEARY_DB_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_RESULT, GearyDbResultClass))
#define GEARY_DB_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_RESULT))
#define GEARY_DB_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_RESULT))
#define GEARY_DB_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_RESULT, GearyDbResultClass))

typedef struct _GearyDbResult GearyDbResult;
typedef struct _GearyDbResultClass GearyDbResultClass;
typedef struct _GearyDbConnectionPrivate GearyDbConnectionPrivate;

typedef enum  {
	GEARY_DATABASE_ERROR_GENERAL,
	GEARY_DATABASE_ERROR_OPEN_REQUIRED,
	GEARY_DATABASE_ERROR_BUSY,
	GEARY_DATABASE_ERROR_CORRUPT,
	GEARY_DATABASE_ERROR_ACCESS,
	GEARY_DATABASE_ERROR_MEMORY,
	GEARY_DATABASE_ERROR_ABORT,
	GEARY_DATABASE_ERROR_INTERRUPT,
	GEARY_DATABASE_ERROR_LIMITS,
	GEARY_DATABASE_ERROR_TYPESPEC,
	GEARY_DATABASE_ERROR_FINISHED,
	GEARY_DATABASE_ERROR_SCHEMA_VERSION
} GearyDatabaseError;
#define GEARY_DATABASE_ERROR geary_database_error_quark ()
struct _GearyBaseInterfaceIface {
	GTypeInterface parent_iface;
};

struct _GearyBaseObject {
	GObject parent_instance;
	GearyBaseObjectPrivate * priv;
};

struct _GearyBaseObjectClass {
	GObjectClass parent_class;
};

struct _GearyDbContext {
	GearyBaseObject parent_instance;
	GearyDbContextPrivate * priv;
};

struct _GearyDbContextClass {
	GearyBaseObjectClass parent_class;
	GearyDbDatabase* (*get_database) (GearyDbContext* self);
	GearyDbConnection* (*get_connection) (GearyDbContext* self);
	GearyDbStatement* (*get_statement) (GearyDbContext* self);
	GearyDbResult* (*get_result) (GearyDbContext* self);
};

struct _GearyDbConnection {
	GearyDbContext parent_instance;
	GearyDbConnectionPrivate * priv;
	sqlite3* db;
};

struct _GearyDbConnectionClass {
	GearyDbContextClass parent_class;
};

gint sqlite3_enable_shared_cache (gint enabled);
#define GEARY_DB_INVALID_ROWID ((gint64) -1)
GType geary_db_database_flags_get_type (void) G_GNUC_CONST;
GType geary_db_reset_scope_get_type (void) G_GNUC_CONST;
GType geary_db_transaction_outcome_get_type (void) G_GNUC_CONST;
GType geary_base_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyBaseObject, g_object_unref)
GType geary_db_context_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyDbContext, g_object_unref)
GType geary_db_connection_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyDbConnection, g_object_unref)
gboolean geary_db_threadsafe (void);
const gchar* geary_db_sqlite_version (void);
gint geary_db_sqlite_version_number (void);
gboolean geary_db_set_shared_cache_mode (gboolean enabled);
gchar* geary_db_normalise_case_insensitive_query (const gchar* text);
void geary_db_check_cancelled (const gchar* method,
                               GCancellable* cancellable,
                               GError** error);
gboolean geary_string_is_empty (const gchar* str);
GQuark geary_database_error_quark (void);
gint geary_db_throw_on_error (GearyDbContext* ctx,
                              const gchar* method,
                              gint _result_,
                              const gchar* raw,
                              GError** error);
GType geary_db_database_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyDbDatabase, g_object_unref)
GearyDbDatabase* geary_db_context_get_database (GearyDbContext* self);
const gchar* geary_db_database_get_path (GearyDbDatabase* self);
GearyDbConnection* geary_db_context_get_connection (GearyDbContext* self);
GType geary_base_interface_get_type (void) G_GNUC_CONST;
GType geary_db_statement_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyDbStatement, g_object_unref)
GType geary_db_result_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyDbResult, g_object_unref)
GearyDbStatement* geary_db_context_get_statement (GearyDbContext* self);
const gchar* geary_db_statement_get_sql (GearyDbStatement* self);

GType
geary_db_database_flags_get_type (void)
{
	static volatile gsize geary_db_database_flags_type_id__volatile = 0;
	if (g_once_init_enter (&geary_db_database_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{GEARY_DB_DATABASE_FLAGS_NONE, "GEARY_DB_DATABASE_FLAGS_NONE", "none"}, {GEARY_DB_DATABASE_FLAGS_CREATE_DIRECTORY, "GEARY_DB_DATABASE_FLAGS_CREATE_DIRECTORY", "create-directory"}, {GEARY_DB_DATABASE_FLAGS_CREATE_FILE, "GEARY_DB_DATABASE_FLAGS_CREATE_FILE", "create-file"}, {GEARY_DB_DATABASE_FLAGS_READ_ONLY, "GEARY_DB_DATABASE_FLAGS_READ_ONLY", "read-only"}, {GEARY_DB_DATABASE_FLAGS_CHECK_CORRUPTION, "GEARY_DB_DATABASE_FLAGS_CHECK_CORRUPTION", "check-corruption"}, {0, NULL, NULL}};
		GType geary_db_database_flags_type_id;
		geary_db_database_flags_type_id = g_flags_register_static ("GearyDbDatabaseFlags", values);
		g_once_init_leave (&geary_db_database_flags_type_id__volatile, geary_db_database_flags_type_id);
	}
	return geary_db_database_flags_type_id__volatile;
}

GType
geary_db_reset_scope_get_type (void)
{
	static volatile gsize geary_db_reset_scope_type_id__volatile = 0;
	if (g_once_init_enter (&geary_db_reset_scope_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_DB_RESET_SCOPE_SAVE_BINDINGS, "GEARY_DB_RESET_SCOPE_SAVE_BINDINGS", "save-bindings"}, {GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS, "GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS", "clear-bindings"}, {0, NULL, NULL}};
		GType geary_db_reset_scope_type_id;
		geary_db_reset_scope_type_id = g_enum_register_static ("GearyDbResetScope", values);
		g_once_init_leave (&geary_db_reset_scope_type_id__volatile, geary_db_reset_scope_type_id);
	}
	return geary_db_reset_scope_type_id__volatile;
}

/**
 * See [[http://www.sqlite.org/c3ref/threadsafe.html]]
 */
gboolean
geary_db_threadsafe (void)
{
	gboolean result = FALSE;
#line 60 "../src/engine/db/db.vala"
	result = sqlite3_threadsafe () != 0;
#line 60 "../src/engine/db/db.vala"
	return result;
#line 246 "db.c"
}

/**
 * See [[http://www.sqlite.org/c3ref/libversion.html]]
 */
const gchar*
geary_db_sqlite_version (void)
{
	const gchar* _tmp0_;
	const gchar* result = NULL;
#line 67 "../src/engine/db/db.vala"
	_tmp0_ = sqlite3_libversion ();
#line 67 "../src/engine/db/db.vala"
	result = _tmp0_;
#line 67 "../src/engine/db/db.vala"
	return result;
#line 263 "db.c"
}

/**
 * See [[http://www.sqlite.org/c3ref/libversion.html]]
 */
gint
geary_db_sqlite_version_number (void)
{
	gint result = 0;
#line 74 "../src/engine/db/db.vala"
	result = sqlite3_libversion_number ();
#line 74 "../src/engine/db/db.vala"
	return result;
#line 277 "db.c"
}

/**
 * See [[http://www.sqlite.org/c3ref/enable_shared_cache.html]]
 */
gboolean
geary_db_set_shared_cache_mode (gboolean enabled)
{
	gint _tmp0_ = 0;
	gboolean result = FALSE;
#line 81 "../src/engine/db/db.vala"
	if (enabled) {
#line 81 "../src/engine/db/db.vala"
		_tmp0_ = 1;
#line 292 "db.c"
	} else {
#line 81 "../src/engine/db/db.vala"
		_tmp0_ = 0;
#line 296 "db.c"
	}
#line 81 "../src/engine/db/db.vala"
	result = sqlite3_enable_shared_cache (_tmp0_) == SQLITE_OK;
#line 81 "../src/engine/db/db.vala"
	return result;
#line 302 "db.c"
}

/** Standard transformation for case-insensitive string values. */
inline gchar*
geary_db_normalise_case_insensitive_query (const gchar* text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 85 "../src/engine/db/db.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 92 "../src/engine/db/db.vala"
	_tmp0_ = g_utf8_normalize (text, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 92 "../src/engine/db/db.vala"
	_tmp1_ = _tmp0_;
#line 92 "../src/engine/db/db.vala"
	_tmp2_ = g_utf8_casefold (_tmp1_, (gssize) -1);
#line 92 "../src/engine/db/db.vala"
	_tmp3_ = _tmp2_;
#line 92 "../src/engine/db/db.vala"
	_g_free0 (_tmp1_);
#line 92 "../src/engine/db/db.vala"
	result = _tmp3_;
#line 92 "../src/engine/db/db.vala"
	return result;
#line 330 "db.c"
}

void
geary_db_check_cancelled (const gchar* method,
                          GCancellable* cancellable,
                          GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 95 "../src/engine/db/db.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 96 "../src/engine/db/db.vala"
	if (cancellable != NULL) {
#line 96 "../src/engine/db/db.vala"
		_tmp0_ = g_cancellable_is_cancelled (cancellable);
#line 346 "db.c"
	} else {
#line 96 "../src/engine/db/db.vala"
		_tmp0_ = FALSE;
#line 350 "db.c"
	}
#line 96 "../src/engine/db/db.vala"
	if (_tmp0_) {
#line 354 "db.c"
		const gchar* _tmp1_ = NULL;
		GError* _tmp2_;
#line 97 "../src/engine/db/db.vala"
		if (!geary_string_is_empty (method)) {
#line 97 "../src/engine/db/db.vala"
			_tmp1_ = method;
#line 361 "db.c"
		} else {
#line 97 "../src/engine/db/db.vala"
			_tmp1_ = "Operation";
#line 365 "db.c"
		}
#line 97 "../src/engine/db/db.vala"
		_tmp2_ = g_error_new (G_IO_ERROR, G_IO_ERROR_CANCELLED, "%s cancelled", _tmp1_);
#line 97 "../src/engine/db/db.vala"
		_inner_error0_ = _tmp2_;
#line 97 "../src/engine/db/db.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 97 "../src/engine/db/db.vala"
			g_propagate_error (error, _inner_error0_);
#line 97 "../src/engine/db/db.vala"
			return;
#line 377 "db.c"
		} else {
#line 97 "../src/engine/db/db.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "../src/engine/db/db.vala"
			g_clear_error (&_inner_error0_);
#line 97 "../src/engine/db/db.vala"
			return;
#line 385 "db.c"
		}
	}
}

gint
geary_db_throw_on_error (GearyDbContext* ctx,
                         const gchar* method,
                         gint _result_,
                         const gchar* raw,
                         GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* location = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	GearyDbConnection* _tmp13_;
	GearyDbConnection* _tmp14_;
	gboolean _tmp15_;
	gchar* errmsg = NULL;
	gchar* _tmp22_;
	gchar* sql = NULL;
	GearyDbStatement* _tmp23_;
	GearyDbStatement* _tmp24_;
	gboolean _tmp25_;
	gchar* msg = NULL;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	GError* _inner_error0_ = NULL;
	gint result = 0;
#line 101 "../src/engine/db/db.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONTEXT (ctx), 0);
#line 103 "../src/engine/db/db.vala"
	switch (_result_) {
#line 103 "../src/engine/db/db.vala"
		case SQLITE_OK:
#line 103 "../src/engine/db/db.vala"
		case SQLITE_DONE:
#line 103 "../src/engine/db/db.vala"
		case SQLITE_ROW:
#line 427 "db.c"
		{
#line 107 "../src/engine/db/db.vala"
			result = _result_;
#line 107 "../src/engine/db/db.vala"
			return result;
#line 433 "db.c"
		}
		default:
#line 103 "../src/engine/db/db.vala"
		break;
#line 438 "db.c"
	}
#line 110 "../src/engine/db/db.vala"
	if (!geary_string_is_empty (method)) {
#line 442 "db.c"
		GearyDbDatabase* _tmp1_;
		GearyDbDatabase* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 111 "../src/engine/db/db.vala"
		_tmp1_ = geary_db_context_get_database (ctx);
#line 111 "../src/engine/db/db.vala"
		_tmp2_ = _tmp1_;
#line 111 "../src/engine/db/db.vala"
		_tmp3_ = geary_db_database_get_path (_tmp2_);
#line 111 "../src/engine/db/db.vala"
		_tmp4_ = _tmp3_;
#line 111 "../src/engine/db/db.vala"
		_tmp5_ = g_strdup_printf ("(%s %s) ", method, _tmp4_);
#line 111 "../src/engine/db/db.vala"
		_g_free0 (_tmp0_);
#line 111 "../src/engine/db/db.vala"
		_tmp0_ = _tmp5_;
#line 111 "../src/engine/db/db.vala"
		_g_object_unref0 (_tmp2_);
#line 464 "db.c"
	} else {
		GearyDbDatabase* _tmp6_;
		GearyDbDatabase* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 112 "../src/engine/db/db.vala"
		_tmp6_ = geary_db_context_get_database (ctx);
#line 112 "../src/engine/db/db.vala"
		_tmp7_ = _tmp6_;
#line 112 "../src/engine/db/db.vala"
		_tmp8_ = geary_db_database_get_path (_tmp7_);
#line 112 "../src/engine/db/db.vala"
		_tmp9_ = _tmp8_;
#line 112 "../src/engine/db/db.vala"
		_tmp10_ = g_strdup_printf ("(%s) ", _tmp9_);
#line 112 "../src/engine/db/db.vala"
		_g_free0 (_tmp0_);
#line 112 "../src/engine/db/db.vala"
		_tmp0_ = _tmp10_;
#line 112 "../src/engine/db/db.vala"
		_g_object_unref0 (_tmp7_);
#line 487 "db.c"
	}
#line 110 "../src/engine/db/db.vala"
	_tmp11_ = g_strdup (_tmp0_);
#line 110 "../src/engine/db/db.vala"
	location = _tmp11_;
#line 113 "../src/engine/db/db.vala"
	_tmp13_ = geary_db_context_get_connection (ctx);
#line 113 "../src/engine/db/db.vala"
	_tmp14_ = _tmp13_;
#line 113 "../src/engine/db/db.vala"
	_tmp15_ = _tmp14_ != NULL;
#line 113 "../src/engine/db/db.vala"
	_g_object_unref0 (_tmp14_);
#line 113 "../src/engine/db/db.vala"
	if (_tmp15_) {
#line 503 "db.c"
		GearyDbConnection* _tmp16_;
		GearyDbConnection* _tmp17_;
		sqlite3* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 113 "../src/engine/db/db.vala"
		_tmp16_ = geary_db_context_get_connection (ctx);
#line 113 "../src/engine/db/db.vala"
		_tmp17_ = _tmp16_;
#line 113 "../src/engine/db/db.vala"
		_tmp18_ = _tmp17_->db;
#line 113 "../src/engine/db/db.vala"
		_tmp19_ = sqlite3_errmsg (_tmp18_);
#line 113 "../src/engine/db/db.vala"
		_tmp20_ = g_strdup_printf (" - %s", _tmp19_);
#line 113 "../src/engine/db/db.vala"
		_g_free0 (_tmp12_);
#line 113 "../src/engine/db/db.vala"
		_tmp12_ = _tmp20_;
#line 113 "../src/engine/db/db.vala"
		_g_object_unref0 (_tmp17_);
#line 525 "db.c"
	} else {
		gchar* _tmp21_;
#line 113 "../src/engine/db/db.vala"
		_tmp21_ = g_strdup ("");
#line 113 "../src/engine/db/db.vala"
		_g_free0 (_tmp12_);
#line 113 "../src/engine/db/db.vala"
		_tmp12_ = _tmp21_;
#line 534 "db.c"
	}
#line 113 "../src/engine/db/db.vala"
	_tmp22_ = g_strdup (_tmp12_);
#line 113 "../src/engine/db/db.vala"
	errmsg = _tmp22_;
#line 115 "../src/engine/db/db.vala"
	_tmp23_ = geary_db_context_get_statement (ctx);
#line 115 "../src/engine/db/db.vala"
	_tmp24_ = _tmp23_;
#line 115 "../src/engine/db/db.vala"
	_tmp25_ = _tmp24_ != NULL;
#line 115 "../src/engine/db/db.vala"
	_g_object_unref0 (_tmp24_);
#line 115 "../src/engine/db/db.vala"
	if (_tmp25_) {
#line 550 "db.c"
		GearyDbStatement* _tmp26_;
		GearyDbStatement* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
#line 116 "../src/engine/db/db.vala"
		_tmp26_ = geary_db_context_get_statement (ctx);
#line 116 "../src/engine/db/db.vala"
		_tmp27_ = _tmp26_;
#line 116 "../src/engine/db/db.vala"
		_tmp28_ = geary_db_statement_get_sql (_tmp27_);
#line 116 "../src/engine/db/db.vala"
		_tmp29_ = _tmp28_;
#line 116 "../src/engine/db/db.vala"
		_tmp30_ = g_strdup_printf (" (%s)", _tmp29_);
#line 116 "../src/engine/db/db.vala"
		_g_free0 (sql);
#line 116 "../src/engine/db/db.vala"
		sql = _tmp30_;
#line 116 "../src/engine/db/db.vala"
		_g_object_unref0 (_tmp27_);
#line 572 "db.c"
	} else {
#line 117 "../src/engine/db/db.vala"
		if (!geary_string_is_empty (raw)) {
#line 576 "db.c"
			gchar* _tmp31_;
#line 118 "../src/engine/db/db.vala"
			_tmp31_ = g_strdup_printf (" (%s)", raw);
#line 118 "../src/engine/db/db.vala"
			_g_free0 (sql);
#line 118 "../src/engine/db/db.vala"
			sql = _tmp31_;
#line 584 "db.c"
		} else {
			gchar* _tmp32_;
#line 120 "../src/engine/db/db.vala"
			_tmp32_ = g_strdup ("");
#line 120 "../src/engine/db/db.vala"
			_g_free0 (sql);
#line 120 "../src/engine/db/db.vala"
			sql = _tmp32_;
#line 593 "db.c"
		}
	}
#line 122 "../src/engine/db/db.vala"
	_tmp33_ = location;
#line 122 "../src/engine/db/db.vala"
	_tmp34_ = errmsg;
#line 122 "../src/engine/db/db.vala"
	_tmp35_ = sql;
#line 122 "../src/engine/db/db.vala"
	_tmp36_ = g_strdup_printf ("%s[err=%d]%s%s", _tmp33_, _result_, _tmp34_, _tmp35_);
#line 122 "../src/engine/db/db.vala"
	msg = _tmp36_;
#line 124 "../src/engine/db/db.vala"
	switch (_result_) {
#line 124 "../src/engine/db/db.vala"
		case SQLITE_BUSY:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_LOCKED:
#line 612 "db.c"
		{
			const gchar* _tmp37_;
			GError* _tmp38_;
#line 127 "../src/engine/db/db.vala"
			_tmp37_ = msg;
#line 127 "../src/engine/db/db.vala"
			_tmp38_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_BUSY, _tmp37_);
#line 127 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp38_;
#line 127 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 624 "db.c"
				gint _tmp39_ = -1;
#line 127 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 127 "../src/engine/db/db.vala"
				return _tmp39_;
#line 642 "db.c"
			} else {
				gint _tmp40_ = -1;
#line 127 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 127 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 127 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 127 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 127 "../src/engine/db/db.vala"
				return _tmp40_;
#line 663 "db.c"
			}
		}
#line 124 "../src/engine/db/db.vala"
		case SQLITE_IOERR:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_PERM:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_READONLY:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_CANTOPEN:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_NOLFS:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_AUTH:
#line 678 "db.c"
		{
			const gchar* _tmp41_;
			GError* _tmp42_;
#line 135 "../src/engine/db/db.vala"
			_tmp41_ = msg;
#line 135 "../src/engine/db/db.vala"
			_tmp42_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_ACCESS, _tmp41_);
#line 135 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp42_;
#line 135 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 690 "db.c"
				gint _tmp43_ = -1;
#line 135 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 135 "../src/engine/db/db.vala"
				return _tmp43_;
#line 708 "db.c"
			} else {
				gint _tmp44_ = -1;
#line 135 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 135 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 135 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 135 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 135 "../src/engine/db/db.vala"
				return _tmp44_;
#line 729 "db.c"
			}
		}
#line 124 "../src/engine/db/db.vala"
		case SQLITE_CORRUPT:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_FORMAT:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_NOTADB:
#line 738 "db.c"
		{
			const gchar* _tmp45_;
			GError* _tmp46_;
#line 140 "../src/engine/db/db.vala"
			_tmp45_ = msg;
#line 140 "../src/engine/db/db.vala"
			_tmp46_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_CORRUPT, _tmp45_);
#line 140 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp46_;
#line 140 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 750 "db.c"
				gint _tmp47_ = -1;
#line 140 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 140 "../src/engine/db/db.vala"
				return _tmp47_;
#line 768 "db.c"
			} else {
				gint _tmp48_ = -1;
#line 140 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 140 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 140 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 140 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 140 "../src/engine/db/db.vala"
				return _tmp48_;
#line 789 "db.c"
			}
		}
#line 124 "../src/engine/db/db.vala"
		case SQLITE_NOMEM:
#line 794 "db.c"
		{
			const gchar* _tmp49_;
			GError* _tmp50_;
#line 143 "../src/engine/db/db.vala"
			_tmp49_ = msg;
#line 143 "../src/engine/db/db.vala"
			_tmp50_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_MEMORY, _tmp49_);
#line 143 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp50_;
#line 143 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 806 "db.c"
				gint _tmp51_ = -1;
#line 143 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 143 "../src/engine/db/db.vala"
				return _tmp51_;
#line 824 "db.c"
			} else {
				gint _tmp52_ = -1;
#line 143 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 143 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 143 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 143 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 143 "../src/engine/db/db.vala"
				return _tmp52_;
#line 845 "db.c"
			}
		}
#line 124 "../src/engine/db/db.vala"
		case SQLITE_ABORT:
#line 850 "db.c"
		{
			const gchar* _tmp53_;
			GError* _tmp54_;
#line 146 "../src/engine/db/db.vala"
			_tmp53_ = msg;
#line 146 "../src/engine/db/db.vala"
			_tmp54_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_ABORT, _tmp53_);
#line 146 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp54_;
#line 146 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 862 "db.c"
				gint _tmp55_ = -1;
#line 146 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 146 "../src/engine/db/db.vala"
				return _tmp55_;
#line 880 "db.c"
			} else {
				gint _tmp56_ = -1;
#line 146 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 146 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 146 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 146 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 146 "../src/engine/db/db.vala"
				return _tmp56_;
#line 901 "db.c"
			}
		}
#line 124 "../src/engine/db/db.vala"
		case SQLITE_INTERRUPT:
#line 906 "db.c"
		{
			const gchar* _tmp57_;
			GError* _tmp58_;
#line 149 "../src/engine/db/db.vala"
			_tmp57_ = msg;
#line 149 "../src/engine/db/db.vala"
			_tmp58_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_INTERRUPT, _tmp57_);
#line 149 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp58_;
#line 149 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 918 "db.c"
				gint _tmp59_ = -1;
#line 149 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 149 "../src/engine/db/db.vala"
				return _tmp59_;
#line 936 "db.c"
			} else {
				gint _tmp60_ = -1;
#line 149 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 149 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 149 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 149 "../src/engine/db/db.vala"
				return _tmp60_;
#line 957 "db.c"
			}
		}
#line 124 "../src/engine/db/db.vala"
		case SQLITE_FULL:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_EMPTY:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_TOOBIG:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_CONSTRAINT:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_RANGE:
#line 970 "db.c"
		{
			const gchar* _tmp61_;
			GError* _tmp62_;
#line 156 "../src/engine/db/db.vala"
			_tmp61_ = msg;
#line 156 "../src/engine/db/db.vala"
			_tmp62_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_LIMITS, _tmp61_);
#line 156 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp62_;
#line 156 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 982 "db.c"
				gint _tmp63_ = -1;
#line 156 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 156 "../src/engine/db/db.vala"
				return _tmp63_;
#line 1000 "db.c"
			} else {
				gint _tmp64_ = -1;
#line 156 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 156 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 156 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 156 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 156 "../src/engine/db/db.vala"
				return _tmp64_;
#line 1021 "db.c"
			}
		}
#line 124 "../src/engine/db/db.vala"
		case SQLITE_SCHEMA:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_MISMATCH:
#line 1028 "db.c"
		{
			const gchar* _tmp65_;
			GError* _tmp66_;
#line 160 "../src/engine/db/db.vala"
			_tmp65_ = msg;
#line 160 "../src/engine/db/db.vala"
			_tmp66_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_TYPESPEC, _tmp65_);
#line 160 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp66_;
#line 160 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1040 "db.c"
				gint _tmp67_ = -1;
#line 160 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 160 "../src/engine/db/db.vala"
				return _tmp67_;
#line 1058 "db.c"
			} else {
				gint _tmp68_ = -1;
#line 160 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 160 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 160 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 160 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 160 "../src/engine/db/db.vala"
				return _tmp68_;
#line 1079 "db.c"
			}
		}
		default:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_ERROR:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_INTERNAL:
#line 124 "../src/engine/db/db.vala"
		case SQLITE_MISUSE:
#line 1089 "db.c"
		{
			const gchar* _tmp69_;
			GError* _tmp70_;
#line 166 "../src/engine/db/db.vala"
			_tmp69_ = msg;
#line 166 "../src/engine/db/db.vala"
			_tmp70_ = g_error_new_literal (GEARY_DATABASE_ERROR, GEARY_DATABASE_ERROR_GENERAL, _tmp69_);
#line 166 "../src/engine/db/db.vala"
			_inner_error0_ = _tmp70_;
#line 166 "../src/engine/db/db.vala"
			if (_inner_error0_->domain == GEARY_DATABASE_ERROR) {
#line 1101 "db.c"
				gint _tmp71_ = -1;
#line 166 "../src/engine/db/db.vala"
				g_propagate_error (error, _inner_error0_);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 166 "../src/engine/db/db.vala"
				return _tmp71_;
#line 1119 "db.c"
			} else {
				gint _tmp72_ = -1;
#line 166 "../src/engine/db/db.vala"
				_g_free0 (msg);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (sql);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (errmsg);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (_tmp12_);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (location);
#line 166 "../src/engine/db/db.vala"
				_g_free0 (_tmp0_);
#line 166 "../src/engine/db/db.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 166 "../src/engine/db/db.vala"
				g_clear_error (&_inner_error0_);
#line 166 "../src/engine/db/db.vala"
				return _tmp72_;
#line 1140 "db.c"
			}
		}
	}
#line 101 "../src/engine/db/db.vala"
	_g_free0 (msg);
#line 101 "../src/engine/db/db.vala"
	_g_free0 (sql);
#line 101 "../src/engine/db/db.vala"
	_g_free0 (errmsg);
#line 101 "../src/engine/db/db.vala"
	_g_free0 (_tmp12_);
#line 101 "../src/engine/db/db.vala"
	_g_free0 (location);
#line 101 "../src/engine/db/db.vala"
	_g_free0 (_tmp0_);
#line 1156 "db.c"
}

