/* rfc822.c generated by valac 0.46.0, the Vala compiler
 * generated from rfc822.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gmime/gmime.h>

typedef enum  {
	GEARY_RF_C822_TEXT_FORMAT_PLAIN,
	GEARY_RF_C822_TEXT_FORMAT_HTML
} GearyRFC822TextFormat;

#define GEARY_RF_C822_TYPE_TEXT_FORMAT (geary_rf_c822_text_format_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

extern gint geary_rf_c822_init_count;
gint geary_rf_c822_init_count = 0;
extern GRegex* geary_rf_c822_invalid_filename_character_re;
GRegex* geary_rf_c822_invalid_filename_character_re = NULL;

GType geary_rf_c822_text_format_get_type (void) G_GNUC_CONST;
#define GEARY_RF_C822_UTF8_CHARSET "UTF-8"
#define GEARY_RF_C822_ASCII_CHARSET "US-ASCII"
void geary_rf_c822_init (void);
gboolean geary_rf_c822_is_utf_8 (const gchar* charset);

/**
 * Common text formats supported by {@link Geary.RFC822}.
 */
GType
geary_rf_c822_text_format_get_type (void)
{
	static volatile gsize geary_rf_c822_text_format_type_id__volatile = 0;
	if (g_once_init_enter (&geary_rf_c822_text_format_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_RF_C822_TEXT_FORMAT_PLAIN, "GEARY_RF_C822_TEXT_FORMAT_PLAIN", "plain"}, {GEARY_RF_C822_TEXT_FORMAT_HTML, "GEARY_RF_C822_TEXT_FORMAT_HTML", "html"}, {0, NULL, NULL}};
		GType geary_rf_c822_text_format_type_id;
		geary_rf_c822_text_format_type_id = g_enum_register_static ("GearyRFC822TextFormat", values);
		g_once_init_leave (&geary_rf_c822_text_format_type_id__volatile, geary_rf_c822_text_format_type_id);
	}
	return geary_rf_c822_text_format_type_id__volatile;
}

void
geary_rf_c822_init (void)
{
	gint _tmp0_;
#line 40 "../src/engine/rfc822/rfc822.vala"
	static const gchar* USER_CHARSETS[2] = {GEARY_RF_C822_UTF8_CHARSET, NULL};
#line 60 "rfc822.c"
	GError* _inner_error0_ = NULL;
#line 32 "../src/engine/rfc822/rfc822.vala"
	_tmp0_ = geary_rf_c822_init_count;
#line 32 "../src/engine/rfc822/rfc822.vala"
	geary_rf_c822_init_count = _tmp0_ + 1;
#line 32 "../src/engine/rfc822/rfc822.vala"
	if (_tmp0_ != 0) {
#line 33 "../src/engine/rfc822/rfc822.vala"
		return;
#line 70 "rfc822.c"
	}
#line 35 "../src/engine/rfc822/rfc822.vala"
	g_mime_init ((guint32) GMIME_ENABLE_RFC2047_WORKAROUNDS);
#line 46 "../src/engine/rfc822/rfc822.vala"
	g_mime_set_user_charsets (USER_CHARSETS);
#line 76 "rfc822.c"
	{
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
#line 49 "../src/engine/rfc822/rfc822.vala"
		_tmp2_ = g_regex_new ("[/\\0]", 0, 0, &_inner_error0_);
#line 49 "../src/engine/rfc822/rfc822.vala"
		_tmp1_ = _tmp2_;
#line 49 "../src/engine/rfc822/rfc822.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 49 "../src/engine/rfc822/rfc822.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 89 "rfc822.c"
				goto __catch238_g_regex_error;
			}
#line 49 "../src/engine/rfc822/rfc822.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 49 "../src/engine/rfc822/rfc822.vala"
			g_clear_error (&_inner_error0_);
#line 49 "../src/engine/rfc822/rfc822.vala"
			return;
#line 98 "rfc822.c"
		}
#line 49 "../src/engine/rfc822/rfc822.vala"
		_tmp3_ = _tmp1_;
#line 49 "../src/engine/rfc822/rfc822.vala"
		_tmp1_ = NULL;
#line 49 "../src/engine/rfc822/rfc822.vala"
		_g_regex_unref0 (geary_rf_c822_invalid_filename_character_re);
#line 49 "../src/engine/rfc822/rfc822.vala"
		geary_rf_c822_invalid_filename_character_re = _tmp3_;
#line 48 "../src/engine/rfc822/rfc822.vala"
		_g_regex_unref0 (_tmp1_);
#line 110 "rfc822.c"
	}
	goto __finally238;
	__catch238_g_regex_error:
	{
		GError* e = NULL;
#line 48 "../src/engine/rfc822/rfc822.vala"
		e = _inner_error0_;
#line 48 "../src/engine/rfc822/rfc822.vala"
		_inner_error0_ = NULL;
#line 51 "../src/engine/rfc822/rfc822.vala"
		g_assert_not_reached ();
#line 48 "../src/engine/rfc822/rfc822.vala"
		_g_error_free0 (e);
#line 124 "rfc822.c"
	}
	__finally238:
#line 48 "../src/engine/rfc822/rfc822.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/engine/rfc822/rfc822.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../src/engine/rfc822/rfc822.vala"
		g_clear_error (&_inner_error0_);
#line 48 "../src/engine/rfc822/rfc822.vala"
		return;
#line 135 "rfc822.c"
	}
}

gboolean
geary_rf_c822_is_utf_8 (const gchar* charset)
{
	gchar* up = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gboolean result = FALSE;
#line 56 "../src/engine/rfc822/rfc822.vala"
	g_return_val_if_fail (charset != NULL, FALSE);
#line 57 "../src/engine/rfc822/rfc822.vala"
	_tmp0_ = g_utf8_strup (charset, (gssize) -1);
#line 57 "../src/engine/rfc822/rfc822.vala"
	up = _tmp0_;
#line 60 "../src/engine/rfc822/rfc822.vala"
	_tmp6_ = up;
#line 60 "../src/engine/rfc822/rfc822.vala"
	if (g_strcmp0 (_tmp6_, "ASCII") == 0) {
#line 60 "../src/engine/rfc822/rfc822.vala"
		_tmp5_ = TRUE;
#line 163 "rfc822.c"
	} else {
		const gchar* _tmp7_;
#line 61 "../src/engine/rfc822/rfc822.vala"
		_tmp7_ = up;
#line 61 "../src/engine/rfc822/rfc822.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "US-ASCII") == 0;
#line 170 "rfc822.c"
	}
#line 60 "../src/engine/rfc822/rfc822.vala"
	if (_tmp5_) {
#line 60 "../src/engine/rfc822/rfc822.vala"
		_tmp4_ = TRUE;
#line 176 "rfc822.c"
	} else {
		const gchar* _tmp8_;
#line 62 "../src/engine/rfc822/rfc822.vala"
		_tmp8_ = up;
#line 62 "../src/engine/rfc822/rfc822.vala"
		_tmp4_ = g_strcmp0 (_tmp8_, "US_ASCII") == 0;
#line 183 "rfc822.c"
	}
#line 60 "../src/engine/rfc822/rfc822.vala"
	if (_tmp4_) {
#line 60 "../src/engine/rfc822/rfc822.vala"
		_tmp3_ = TRUE;
#line 189 "rfc822.c"
	} else {
		const gchar* _tmp9_;
#line 63 "../src/engine/rfc822/rfc822.vala"
		_tmp9_ = up;
#line 63 "../src/engine/rfc822/rfc822.vala"
		_tmp3_ = g_strcmp0 (_tmp9_, "UTF-8") == 0;
#line 196 "rfc822.c"
	}
#line 60 "../src/engine/rfc822/rfc822.vala"
	if (_tmp3_) {
#line 60 "../src/engine/rfc822/rfc822.vala"
		_tmp2_ = TRUE;
#line 202 "rfc822.c"
	} else {
		const gchar* _tmp10_;
#line 64 "../src/engine/rfc822/rfc822.vala"
		_tmp10_ = up;
#line 64 "../src/engine/rfc822/rfc822.vala"
		_tmp2_ = g_strcmp0 (_tmp10_, "UTF8") == 0;
#line 209 "rfc822.c"
	}
#line 60 "../src/engine/rfc822/rfc822.vala"
	if (_tmp2_) {
#line 60 "../src/engine/rfc822/rfc822.vala"
		_tmp1_ = TRUE;
#line 215 "rfc822.c"
	} else {
		const gchar* _tmp11_;
#line 65 "../src/engine/rfc822/rfc822.vala"
		_tmp11_ = up;
#line 65 "../src/engine/rfc822/rfc822.vala"
		_tmp1_ = g_strcmp0 (_tmp11_, "UTF_8") == 0;
#line 222 "rfc822.c"
	}
#line 58 "../src/engine/rfc822/rfc822.vala"
	result = _tmp1_;
#line 58 "../src/engine/rfc822/rfc822.vala"
	_g_free0 (up);
#line 58 "../src/engine/rfc822/rfc822.vala"
	return result;
#line 230 "rfc822.c"
}

